#include <bits/stdc++.h>

using namespace std;

const char en = '\n';

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

const int MOD = 1'000'000'000 + 7;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> p(n);
    iota(p.begin(), p.end(), 0);
    int ans = 0;
    do {
        int now = 0;
        bool ok = true;
        for (auto i : p) {
            now += a[i] % 3;
            now %= 3;
            if (now == 0) {
                ok = false;
                break;
            }
        }
        ans += ok;
        if (ans == MOD) {
            ans = 0;
        }
    } while (next_permutation(p.begin(), p.end()));
    cout << ans << en;
}

int32_t main() {
#ifdef THEEVILBIRD
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}
