#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) x.begin(), x.end()
#define int long long
#define tm (tl + tr >> 1)
#define ls v << 1, tl, tm
#define rs v << 1 | 1, tm + 1, tr
#define pb push_back
#define F first
#define S second
#define len(x) (int) x.size()

using namespace std;
using namespace __gnu_pbds;

const int INF = 1e18;
const int N = 2e5 + 7;

int d[N], act[N][2], cnt, nd;

vector <int> g[N];

void calc(int v, int p) {
    d[v] = d[p] + 1;
    act[v][0] = INF;
    act[v][1] = 0;
    for (int u: g[v]) if (u != p) {
        calc(u, v);
        act[v][0] = min(act[v][0], act[u][0]);
        act[v][1] = max(act[v][1], act[u][1]);
    }
    if (act[v][0] == INF) act[v][0] = d[v];
    if (act[v][1] == 0) act[v][1] = d[v];
}

void dfs(int v, int p) {
    if (v != 1 && len(g[v]) == 1) {
        cout << cnt + 1;
        exit(0);
    }
    if (!nd || d[v] == nd) {
        if (nd) cnt++;
        int u1 = 0, u2 = 0;
        for (int u: g[v]) if (u != p) {
            if (!u1) u1 = u;
            if (!u2) u2 = u;
            if (act[u][0] < act[u1][0]) u1 = u;
            if (act[u][1] > act[u2][1]) u2 = u;
        }
        nd = act[u1][0];
        dfs(u2, v);
    } else {
        int u2 = 0;
        for (int u: g[v]) if (u != p) {
            if (!u2) u2 = u;
            if (act[u][1] > act[u2][1]) u2 = u;
        }
        dfs(u2, v);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int v;
        cin >> v;
        g[v].pb(i);
        g[i].pb(v);
    }
    calc(1, 0);
    dfs(1, 0);
}