#include <bits/stdc++.h>
using namespace std;

#define int long long
const int Mod = 1e9 + 7;
const int N = 1e5 + 1;
int fact[N + 10], inv[N + 10];
int binPow(int u, int v){
    int ans = 1;
    while ( v > 0 ){
        if ( v & 1 ){
            ans = ans * u % Mod;
        }
        u = u * u % Mod;
        v >>= 1;
    }
    return ans;
}
int C(int n, int k){
    if ( n < k ){
        return 0;
    }
    return inv[k] * fact[n] % Mod * inv[n - k] % Mod;
}
void add(int &x, int y){
    x = (x + y) % Mod;
    if ( x < 0 ) x += Mod;
}


 main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    fact[0] = inv[0] = 1;
    for ( int i = 1; i < N; i++ ){
        fact[i] = fact[i - 1] * i % Mod;
        inv[i] = binPow(fact[i], Mod - 2);
    }
    int n; cin >> n;
    int all = 0;
    vector<int> dp(n + 10);
    dp[1] = 1;
    dp[2] = 1;
    for(int i = 3;i <= n; i++){
        int all = 0;
        for(int j = 1; j * 2 <= i; j++){
            add(all, C(i-1, j) * C(i - 1 - j , i-j*2));
        }
       // cout << i << " = " << all << '\n';
        all*= dp[i-1];
        all%= Mod;
        dp[i] = all;
    }
    cout << dp[n];
}
