#include <bits/stdc++.h>
using namespace std;
#define int long long
#define ln '\n'
#define ar array
#define pb push_back
#define all(x) x.begin(), x.end()
const int Mod = 1e9 + 7;
const int N = 1e5 + 1;
int fact[N], inv[N];
int binPow(int u, int v){
    int ans = 1;
    while ( v > 0 ){
        if ( v & 1 ){
            ans = ans * u % Mod;
        }
        u = u * u % Mod;
        v >>= 1;
    }
    return ans;
}
int C(int n, int k){
    if ( n < k ){
        return 0;
    }
    return inv[k] * fact[n] % Mod * inv[n - k] % Mod;
}
void add(int &x, int y){
    x = (x + y) % Mod;
    if ( x < 0 ) x += Mod;
}
signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    fact[0] = 1;
    for ( int i = 1; i < N; i++ ){
        fact[i] = fact[i - 1] * i % Mod;
        inv[i] = binPow(fact[i], Mod - 2);
    }

    int n; cin >> n;
    vector <int> a(n), c(3);
    for ( auto &i: a ){
        cin >> i;
        i %= 3;
        c[i]++;
    }
    if ( n == 1 ){
        cout << !c[0]; return 0;
    }
    int ans = 0;
    if ( c[2] - c[1] > 0 && c[2] - c[1] <= 2  ){
        add(ans, fact[c[2]] * fact[c[1]] % Mod * C(n - 2 + c[0], c[0]) % Mod);
    }
    if ( c[1] - c[2] > 0 && c[1] - c[2] <= 2  ){
        add(ans, fact[c[2]] * fact[c[1]] % Mod * C(n - 2 + c[0], c[0]) % Mod);
    }
    cout << ans;
}

