#include<bits/stdc++.h>

using namespace std;

const int inf = (int)1e9 + 7;
const int N = (int)1e3 + 7;
const int MOD = (int)1e9 + 7;

int n;
int dp[N][N];

int sum(int x, int y) {
    x += y;
    if(x >= MOD) {
        x -= MOD;
    }
    return x;
}

int mult(int x, int y) {
    return 1ll*x*y%MOD;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    int ans = 0;
    for(int m = 1; m <= n+1; ++m) {
        int val = m*(m-1)/2;
        if(val > n) {
            break;
        }
        memset(dp, 0, sizeof(dp));
        dp[1][m*(m-1)/2] = 1;
        for(int s = 2; s <= n; ++s) {
            for(int e = m*(m-1)/2; e <= n; ++e) {
                for(int w = 1; w <= n; ++w) {
                    if(w == m) {
                        continue;
                    }
                    if(e >= w) {
                        dp[s][e] = sum(dp[s][e], dp[s-1][e-w]);
                     }
                }
            }
        }
        for(int i = 1; i <= n; ++i) {
            ans = sum(ans, mult(m, dp[i][n]));
        }
    }
    cout << ans;
    return 0;
}
