#include <bits/stdc++.h>
using namespace std;
#define ll long long
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    
    int n; cin >> n;

    vector a(n + 1, vector < int >(n + 1));

    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
            cin >> a[i][j];

    ll sum = 0;

    for (int i = 1; i <= n * n; i++)
        sum += i;

    sum /= n;

    vector < int > r(n + 1), c(n + 1);

    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
            r[i] += a[i][j],
            c[j] += a[i][j];

    int r1 = -1, c1 = -1, r2 = -1, c2 = -1;

    for (int i = 1; i <= n; i++)
        if (r[i] != sum) {
            if (r1 == -1)
                r1 = i;
            else
                r2 = i;
        }

    for (int i = 1; i <= n; i++)
        if (c[i] != sum) {
            if (c1 == -1)
                c1 = i;
            else
                c2 = i;
        }

    if (r1 == -1) {
        for (int i = 1; i <= n; i++) {
            swap(a[i][c1], a[i][c2]);

            c[c1] = c[c2] = 0;

            for (int i = 1; i <= n; i++)
                c[c1] += a[i][c1],
                c[c2] += a[i][c2];

            if (c[c1] == sum && c[c2] == sum) {
                r1 = r2 = i;
                break;
            }

            swap(a[i][c1], a[i][c2]);
        }
    } else if (c1 == -1) {
        for (int j = 1; j <= n; j++) {
            swap(a[r1][j], a[r2][j]);

            r[r1] = r[r2] = 0;

            for (int j = 1; j <= n; j++)
                r[r1] += a[r1][j],
                r[r2] += a[r2][j];

            if (r[r1] == sum && r[r2] == sum) {
                c1 = c2 = j;
                break;
            }

            swap(a[r1][j], a[r2][j]);
        }
    } else {
        bool ok = false;
        
        swap(a[r1][c1], a[r2][c2]);

        r[r1] = r[r2] = c[c1] = c[c2] = 0;

        for (int i = 1; i <= n; i++)
            for (int j = 1; j <= n; j++)
                r[i] += a[i][j],
                c[j] += a[i][j];

        if (r[r1] == sum && r[r2] == sum && c[c1] == sum && c[c2] == sum)
            ok = true;

        swap(a[r1][c1], a[r2][c2]);

        if (!ok) {
            swap(r1, r2);

            swap(a[r1][c1], a[r2][c2]);

            r[r1] = r[r2] = c[c1] = c[c2] = 0;

            for (int i = 1; i <= n; i++)
                for (int j = 1; j <= n; j++)
                    r[i] += a[i][j],
                    c[j] += a[i][j];

            if (!(r[r1] == sum && r[r2] == sum && c[c1] == sum && c[c2] == sum))
                assert(0);

            swap(a[r1][c1], a[r2][c2]);
        }
    }

    cout << r1 << " " << c1 << "\n" << r2 << " " << c2 << "\n";
}