# include <bits/stdc++.h>
# define nl '\n'
# define pb push_back

using namespace std;
using ll = long long;

const ll N = 5e3+5;
const ll inf = (ll)2e18 + 7;
const ll mod = 1e9 + 7;

ll fact[N];
ll inv[N];

ll binpow (ll x, ll n) {
    ll res = 1;
    while (n > 0) {
        if (n & 1) {
            res = (res * x) % mod;
        }
        x = (x * x) % mod;
        n >>= 1;
    }
    return res;
}
void precalc () {
    fact[0] = 1;
    for (ll i = 1; i < N; ++i) {
        fact[i] = fact[i - 1] * i % mod;
    }
    inv[N - 1] = binpow(fact[N - 1], mod - 2);
    for (ll i = N - 2; i >= 0; --i) {
        inv[i] = inv[i + 1] * (i + 1) % mod;
    }
}

ll f (ll k) {
    ll lim = (k + 1) / 2;
    ll res = 0;
    for (ll i = 1; i <= lim; ++i) {
         ll cur = fact[k];
         cur = (cur * inv[i]) % mod;
         cur = (cur * inv[k + 1 - i - i]) % mod;
         cur = (cur * inv[i - 1]) % mod;
        res = (res + cur) % mod;
    }
    return res;
}
void ma1n () {
    precalc();
    ll n;
    cin >> n;
    ll ans = 1;
    for (ll i = 1; i < n; ++i) {
        ans = (ans * f(i)) % mod;
    }
    cout << ans;
}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    ma1n();
    return 0;
}
