#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

const int maxn = 1e3 + 1;
int n;
int a[maxn][maxn];
ll col[maxn], row[maxn];

bool isgood(int i1, int j1, int k1, int t1) {
    swap(a[i1][j1], a[k1][t1]);
    bool fl = 0;
    set<int> col1, row1;
    fill(row, row + n, 0);
    fill(col, col + n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            row[i] += a[i][j];
            col[j] += a[i][j];
        }
    }
    for (int i = 0; i < n; i++) {
        col1.insert(col[i]);
        row1.insert(row[i]);
    }
    swap(a[i1][j1], a[k1][t1]);
    if (col1.size() == 1 && row1.size() == 1) {
        cout << i1 + 1 << ' ' << j1 + 1 << ' ' << k1 + 1 << ' ' << t1 + 1 << '\n';
        exit(0);
    }
    return 0;
}

void solve() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            row[i] += a[i][j];
            col[j] += a[i][j];
        }
    }
    vector<int> badcols, badrows;
    map<ll, int> col1, row1;
    for (int i = 0; i < n; i++) {
        col1[col[i]]++;
        row1[row[i]]++;
    }
    for (int i = 0; i < n; i++) {
        if (col1[col[i]] < 3) {
            badcols.push_back(i);
        }
        if (row1[row[i]] < 3) {
            badrows.push_back(i);
        }
    }
    if (badcols.empty()) {
        int i1 = badrows[0];
        int i2 = badrows[1];
        for (int j = 0; j < n; j++) {
            if (row[i1] - row[i2] == (a[i1][j] - a[i2][j]) * 2) {
                cout << i1 + 1 << " " << j + 1 << '\n' << i2 + 1 << " " << j + 1;
                exit(0);
            }
        }
    } else if (badrows.empty()) {
        int j1 = badcols[0];
        int j2 = badcols[1];
        for (int i = 0; i < n; i++) {
            if (col[j1] - col[j2] == (a[i][j1] - a[i][j2]) * 2) {
                cout << i + 1 << " " << j1 + 1 << '\n' << i + 1 << " " << j2 + 1;
                exit(0);
            }
        }
    } else {
        int i1 = badrows[0];
        int i2 = badrows[1];
        int j1 = badcols[0];
        int j2 = badcols[1];
        isgood(i1, j1, i2, j2);
        isgood(i1, j2, i2, j1);
    }
}

void solve1() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++) {
                for (int t = 0; t < n; t++) {
                    if (isgood(i, j, k, t)) {
                        cout << i + 1 << ' ' << j + 1 << ' ' << '\n' << k + 1 << ' ' << t + 1 << '\n';
                        exit(0);
                    }
                }
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }
    if (n < 5) {
        solve1();
        exit(0);
    }
    solve();
}
