﻿#pragma optimize("O2");

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <deque>
#include <set>
#include <map>

using namespace std;

using ll = long long;
using ld = long double;

ll binpow(ll bs, ll ex) {
    if (ex == 0) return 1ll;

    if (ex & 1) return bs * binpow(bs, ex - 1);

    ll hf = binpow(bs, ex / 2);
    return hf * hf;
}

ll ask(ll k) {
    cout << k << endl;
    int res; cin >> res;
    return res;
}

void ans(ll x, ll b) {
    cout << x << ' ' << b << endl;
}

int main() {
    //cin.tie(0)->sync_with_stdio(false);
    ll n; cin >> n;

    ll l1 = 1, r1 = 1e16;
    while (r1 - l1 > 1) {
        ll m = (l1 + r1) / 2;
        int res = ask(m);
        if (res < n + 2) l1 = m;
        else r1 = m;
    }
    
    ll l2 = 0, r2 = r1 + 1;
    while (r2 - l2 > 1) {
        ll m = (l2 + r2) / 2;
        int res = ask(m);
        if (res == n) l2 = m;
        else r2 = m;
    }

    int B;
    for (int b = 2; b <= 2023; b++) {
        if ((r1 - r2) % binpow(b, n) == 0) {
            B = b;
            break;
        }
    }

    int X = binpow(B, n) - r2;
    ans(X, B);
}
