﻿#pragma optimize("O2");

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <deque>
#include <set>
#include <map>

using namespace std;

using ll = long long;
using ld = long double;
bool cmp(pair<int, int> a, pair<int, int> b) {
    return a.second < b.second;
}

int main() {
    cin.tie(0)->sync_with_stdio(false);
    int n;
    cin >> n;
    if (n == 3) {
        vector<vector<int>> a(n, vector<int>(n));
        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                cin >> a[i][j];

        map<int, int> occur;
        vector<int> ver(n, 0), hor(n, 0);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                ver[i] += a[i][j];
            }
        }
        for (int j = 0; j < n; j++) {
            for (int i = 0; i < n; i++) {
                hor[j] += a[i][j];
            }
        }
        int mx = 0, best = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                occur[ver[i] + hor[j]]++;
                if (occur[ver[i] + hor[j]] > mx) {
                    mx = occur[ver[i] + hor[j]];
                    best = ver[i] + hor[j];
                }
            }
        }
        for (int i1 = 0; i1 < n; i1++) {
            for (int j1 = 0; j1 < n; j1++) {
                for (int i2 = 0; i2 < n; i2++) {
                    for (int j2 = 0; j2 < n; j2++) {
                        int s = ver[i1] + hor[j1];

                        s = s - 2 * a[i1][j1] + 2 * a[i2][j2];

                        bool ok = 1;
                        for (int i = 0; i < n; i++) {
                            for (int j = 0; j < n; j++) {
                                if (i == i1) ver[i] = ver[i] - a[i1][j1] + a[i2][j2];
                                if (i == i2) ver[i] = ver[i] - a[i2][j2] + a[i1][j1];
                                if (j == j1) hor[j] = hor[j] - a[i1][j1] + a[i2][j2];
                                if (j == j2) hor[j] = hor[j] - a[i2][j2] + a[i1][j1];

                                ok &= (s == (ver[i] + hor[j]));

                                if (i == i1) ver[i] = ver[i] + a[i1][j1] - a[i2][j2];
                                if (i == i2) ver[i] = ver[i] + a[i2][j2] - a[i1][j1];
                                if (j == j1) hor[j] = hor[j] + a[i1][j1] - a[i2][j2];
                                if (j == j2) hor[j] = hor[j] + a[i2][j2] - a[i1][j1];
                            }
                        }

                        if (ok) {
                            cout << i1 + 1 << ' ' << j1 + 1 << endl
                                << i2 + 1 << ' ' << j2 + 1 << endl;
                            return 0;
                        }
                    }
                }
            }
        }
    }
    else {
        vector<vector<int>> d(n, vector<int>(n));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                cin >> d[i][j];
            }
        }
        vector<int> a(n), b(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                a[i] += d[i][j];
                b[j] += d[i][j];
            }
        }
        map<int, int>ma;
        for (auto i : a) {
            ma[i] += 1;
        }
        vector<pair<int, int>> m;
        for (auto i : ma) {
            m.push_back(i);
        }
        sort(m.begin(), m.end(), cmp);
        int s = (*m.rbegin()).second;
        int x, y, x2, y2;
        for (int i = 0; i < n; i++) {
            if (a[i] == (*m.begin()).first) x = i;
            else if (a[i] != (*m.rbegin()).first) x2 = i;
        }
        for (int i = 0; i < n; i++) {
            if (b[i] == (*m.begin()).first) y = i;
            else if (b[i] != (*m.rbegin()).first) y2 = i;
        }
        cout << x +1 << ' '<<y + 1<< endl<<x2 + 1<<' '<<y2 + 1;
    }
}
