﻿#include <iomanip>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <map>
#include <iostream>
#include <string>
#include <iomanip>
#include <vector>
#include <cmath>
#define int long long
using ll = long long;
using namespace std;
const int mod = 1e9 + 7;
const int INF = 1e9 + 7;
#define get_time (double)clock() / (double)(CLOCKS_PER_SEC)
#ifndef ONLINE_JUDGE
#define debug(x) cerr << (#x) << ": " << x << endl;
#else
#define debug(x)
#endif
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll bs_sqrt(ll x) {
    ll left = 0, right = 2000000123;
    while (right > left) {
        ll mid = (left + right) / 2;
        if (mid * mid > x) {
            right = mid;
            continue;
        }
        left = mid + 1;
    }
    return left - 1;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
int bin_pow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        ll t = bin_pow(a, n / 2);
        return (t * t) % mod;
    }
    else {
        ll t = bin_pow(a, n - 1);
        return (t * a) % mod;
    }
}
int rev(int x) {
    return bin_pow(x, mod - 2);
}
int mul(int a, int b) {
    return (a * b) % mod;
}
int make_add(int a, int b) {
    return (a + b) % mod;
}

int getLen(ll d) {
    cout << "? " << d << endl;
    int res;
    cin >> res;
    return res;
}

void solve() {
    ll n;
    cin >> n;
    ll l = 0, r = 1e15;
    while (r - l > 1) {
        ll m = (r + l) >> 1;
        if (getLen(m) == n) {
            l = m;
        }
        else {
            r = m;
        }
    }
    ll addToMaxNumInLen = l;
    //debug(addToMaxNumInLen);
    l = 1, r = 1e15;
    while (r - l > 1) {
        ll m = (r + l) >> 1;
        if (getLen(m + addToMaxNumInLen) <= n+1) {
            l = m;
        }
        else {
            r = m;
        }
    }
    ll deltaPow = l;
    //debug(deltaPow);
    ll p = -1;
    for (ll i = 2; i <= 2023; ++i) {
        if (deltaPow % (i - 1) == 0) {
            ll test = deltaPow / (i - 1);
            int count = 0;
            while (test % i == 0 && test > 0) {
                count++;
                test /= i;
            }
            if (count == n && test == 0) {
                p = i;
                break;
            }
        }
    }
    ll num = deltaPow / (p - 1) - addToMaxNumInLen - 1;
    cout << "! " << num << " " << p << endl;
}
signed main() {
    cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}