﻿#include <iomanip>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <map>
#include <iostream>
#include <string>
#include <iomanip>
#include <vector>
#include <cmath>
#define int long long
using ll = long long;
using namespace std;
const int mod = 1e9 + 7;
const int INF = 1e9 + 7;
#define get_time (double)clock() / (double)(CLOCKS_PER_SEC)
#ifndef ONLINE_JUDGE
#define debug(x) cerr << (#x) << ": " << x << endl;
#else
#define debug(x)
#endif
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll bs_sqrt(ll x) {
    ll left = 0, right = 2000000123;
    while (right > left) {
        ll mid = (left + right) / 2;
        if (mid * mid > x) {
            right = mid;
            continue;
        }
        left = mid + 1;
    }
    return left - 1;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
int bin_pow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        ll t = bin_pow(a, n / 2);
        return (t * t) % mod;
    }
    else {
        ll t = bin_pow(a, n - 1);
        return (t * a) % mod;
    }
}
int rev(int x) {
    return bin_pow(x, mod - 2);
}
int mul(int a, int b) {
    return (a * b) % mod;
}
int make_add(int a, int b) {
    return (a + b) % mod;
}

int ask(int start, char a, char b) {
    cout << "? " << start + 1 << " " << a << b << endl;
    int res;
    cin >> res;
    return res;
}

int oneChar(int pos) {
    pair<int, char> a1 = { ask(pos - 1, 'a', 'a'), 'a' };
    pair<int, char> b1 = { ask(pos - 1, 'a', 'b'), 'b' };
    pair<int, char> c1 = { ask(pos - 1, 'a', 'c'), 'c' };
    auto mx = max(a1, max(b1, c1));
    return mx.second;
}

void solve() {
    int n;
    while (1) {
        cin >> n;
        if (n == 0) exit(0);
        vector<char> answers(n);
        int count = n / 3 + (n % 3 != 0);
        vector<pair<int, int>> segs(count);
        for (int i = 0; i < count; ++i) {
            segs[i].first = i * 3;
            segs[i].second = min(n, (i + 1) * 3) - i * 3;
        }
        for (auto& her : segs) {
            int start = her.first;
            int len = her.second;
            if (len == 1) {
                answers[start] = oneChar(start);
            }
            else if (len == 2) {
                int res1 = ask(start, 'a', 'b');
                if (res1 == 2) {
                    answers[start] = 'a';
                    answers[start + 1] = 'b';
                }
                else if (res1 == 1) {
                    int res2 = ask(start, 'b', 'b');
                    if (res2 == 1) {
                        answers[start] = 'c';
                        answers[start + 1] = 'b';
                    }
                    else if (res2 == 0) {
                        answers[start] = 'a';
                        int res3 = ask(start, 'a', 'c');
                        if (res3 == 1) {
                            answers[start + 1] = 'a';
                        }
                        else {
                            answers[start + 1] = 'c';
                        }
                    }
                    else {
                        answers[start] = 'b';
                        answers[start + 1] = 'b';
                    }
                }
                else if (res1 == 0) {
                    int res2 = ask(start, 'b', 'b');
                    if (res2 == 0) {
                        answers[start] = 'c';
                        int res3 = ask(start, 'c', 'a');
                        if (res3 == 1) {
                            answers[start + 1] = 'c';
                        }
                        else {
                            answers[start + 1] = 'a';
                        }
                    }
                    else if (res2 == 1) {
                        answers[start] = 'b';
                        int res3 = ask(start, 'b', 'a');
                        if (res3 == 0) {
                            answers[start + 1] = 'c';
                        }
                        else {
                            answers[start + 1] = 'a';
                        }
                    }
                }
            }
            else {
                int ab1 = ask(start, 'a', 'b'), bb1 = ask(start, 'b', 'b'), ab2 = ask(start + 1, 'a', 'b'), ac2 = ask(start + 1, 'a', 'c');
                if (ab1 == 2) {
                    answers[start] = 'a';
                    answers[start + 1] = 'b';
                    if (ab2 == 1) {
                        answers[start + 2] = 'b';
                    }
                    else if (ac2 == 1) {
                        answers[start + 2] = 'c';
                    }
                    else {
                        answers[start + 2] = 'a';
                    }
                }
                else if (ab1 == 1) {
                    if (bb1 == 2) {
                        answers[start] = 'b';
                        answers[start + 1] = 'b';
                        if (ab2 == 1) {
                            answers[start + 2] = 'b';
                        }
                        else if (ac2 == 1) {
                            answers[start + 2] = 'c';
                        }
                        else {
                            answers[start + 2] = 'a';
                        }
                    }
                    else if (bb1 == 1) {
                        answers[start] = 'c';
                        answers[start + 1] = 'b';
                        if (ab2 == 1) {
                            answers[start + 2] = 'b';
                        }
                        else if (ac2 == 1) {
                            answers[start + 2] = 'c';
                        }
                        else {
                            answers[start + 2] = 'a';
                        }
                    }
                    else if (bb1 == 0) {
                        answers[start] = 'a';
                        if (ab2 == 2) {
                            answers[start + 1] = 'a';
                            answers[start + 2] = 'b';
                        }
                        else if (ab2 == 1) {
                            if (ac2 == 2) {
                                answers[start + 1] = 'a';
                                answers[start + 2] = 'c';
                            }
                            else if (ac2 == 1) {
                                answers[start + 1] = 'a';
                                answers[start + 2] = 'a';
                            }
                        }
                        else if (ab2 == 0) {
                            answers[start + 1] = 'c';
                            if (ac2 == 1) {
                                answers[start + 2] = 'c';
                            }
                            else if (ac2 == 0) {
                                answers[start + 2] = 'a';
                            }
                        }
                    }
                }
                else if (ab1 == 0) {
                    if (bb1 == 0) {
                        answers[start] = 'c';
                        if (ab2 == 2) {
                            answers[start + 1] = 'a';
                            answers[start + 2] = 'b';
                        }
                        else if (ab2 == 1) {
                            if (ac2 == 2) {
                                answers[start + 1] = 'a';
                                answers[start + 2] = 'c';
                            }
                            else if (ac2 == 1) {
                                answers[start + 1] = 'a';
                                answers[start + 2] = 'a';
                            }
                        }
                        else if (ab2 == 0) {
                            answers[start + 1] = 'c';
                            if (ac2 == 1) {
                                answers[start + 2] = 'c';
                            }
                            else if (ac2 == 0) {
                                answers[start + 2] = 'a';
                            }
                        }
                    }
                    else if (bb1 == 1) {
                        answers[start] = 'b';
                        if (ab2 == 2) {
                            answers[start + 1] = 'a';
                            answers[start + 2] = 'b';
                        }
                        else if (ab2 == 1) {
                            if (ac2 == 2) {
                                answers[start + 1] = 'a';
                                answers[start + 2] = 'c';
                            }
                            else if (ac2 == 1) {
                                answers[start + 1] = 'a';
                                answers[start + 2] = 'a';
                            }
                        }
                        else if (ab2 == 0) {
                            answers[start + 1] = 'c';
                            if (ac2 == 1) {
                                answers[start + 2] = 'c';
                            }
                            else if (ac2 == 0) {
                                answers[start + 2] = 'a';
                            }
                        }
                    }
                }
            }
        }
        cout << "! ";
        for (int i = 0; i < n; ++i) {
            cout << answers[i];
        }
        cout << endl;
    }
}
signed main() {
    cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}