#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define ve vector
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int)(a).size()
#define eb emplace_back
#define pb push_back
#define INF1 INT32_MAX
#define INF2 INT64_MAX

using namespace std;
using namespace __gnu_pbds;

random_device rd;

mt19937 rnd(rd());

//template<typename key, typename cmp = less<key>>
//using pbds = tree<key, nulltype, cmp, rb_tree_tag, tree_order_statistics_node_update>;

int a[1000][1000];

void solve() {
    int n; cin >> n;
    map<int, int> cnt_i;
    map<int, int> cnt_j;

    ve<int> st(n);
    ve<int> sr(n);

    for (int i = 0; i < n; ++i) {
        int sum = 0;
        for (int j = 0; j < n; ++j) cin >> a[i][j], sum += a[i][j];
        cnt_i[sum]++;
        sr[i] = sum;
    }
    for (int j = 0; j < n; ++j) {
        int sum = 0;
        for (int i = 0; i < n; ++i) sum += a[i][j];
        cnt_j[sum]++;
        st[j] = sum;
    }

    if (sz(cnt_i) == 3 && sz(cnt_j) == 3) {
        auto[s,c] = *(++cnt_i.begin());
        int j1=-1, j2;
        for (int j = 0; j < n;++j) {
            if (st[j] != s) {
                if (j1 == -1) j1 = j;
                else j2 = j;
            }
        }

        for (int i2 = 1; i2 < n; ++i2) {
            for (int i1 = 0; i1 < i2; ++i1) {
                if (sr[i1] == s || sr[i2] == s) continue;
                if (s - st[j2] == a[i1][j1]-a[i2][j2] && s - sr[i2] == a[i1][j1]-a[i2][j2]) {
                    cout << i1+1 << " " << j1+1 << '\n';
                    cout << i2+1 << " " << j2+1 << '\n';
                    return;
                }
            }
        }
        swap(j2, j1);
        for (int i2 = 1; i2 < n; ++i2) {
            for (int i1 = 0; i1 < i2; ++i1) {
                if (sr[i1] == s || sr[i2] == s) continue;
                if (s - st[j2] == a[i1][j1]-a[i2][j2] && s - sr[i2] == a[i1][j1]-a[i2][j2]) {
                    cout << i1+1 << " " << j1+1 << '\n';
                    cout << i2+1 << " " << j2+1 << '\n';
                    return;
                }
            }
        }
    }
    else if (sz(cnt_i) == 1 && sz(cnt_j) == 3) {
        auto[s,c] = *cnt_i.begin();
        int j1=-1, j2;
        for (int j = 0; j < n;++j) {
            if (st[j] != s) {
                if (j1 == -1) j1 = j;
                else j2 = j;
            }
        }


        for (int i = 0; i < n; ++i) {
            if (s-st[j2] == a[i][j1] - a[i][j2]) {
                cout << i+1 << " " << j1 + 1 << '\n';
                cout << i+1 << " " << j2 + 1 << '\n';
                return;
            }
        }
    }
    else if (sz(cnt_i) == 3 && sz(cnt_j) == 1) {
        auto[s,c] = *cnt_j.begin();
        int i1=-1, i2;
        for (int i = 0; i < n;++i) {
            if (sr[i] != s) {
                if (i1 == -1) i1 = i;
                else i2 = i;
            }
        }
        for (int j = 0; j < n; ++j) {
            if (s-sr[i2] == a[i1][j] - a[i2][j]) {
                cout << i1+1 << " " << j + 1 << '\n';
                cout << i2+1 << " " << j + 1 << '\n';
                return;
            }
        }
    }
    else {
        assert(0);
    }

}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt--) solve();
}
