#include <bits/stdc++.h>

using namespace std;
#define int long long
const int mod = 1e9 + 7;
int ans = 1;

int prod(int a, int b) {
    return (a * b) % mod;
}

int bin_pow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int t = bin_pow(a, n / 2);
        return prod(t, t);
    }
    return prod(a, bin_pow(a, n - 1));
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin>>n;
    int sum;
    vector<int> F(1e6 + 1), F_inv(1e6 + 1);
    F[0] = 1;
    for (int i = 1; i <= 1e6; ++i) {
        F[i] = prod(F[i - 1], i);
    }
    F_inv.back() = bin_pow(F.back(), mod - 2);
    for (int i = 1e6 - 1; i >= 0; --i) {
        F_inv[i] = prod(F_inv[i + 1], (i + 1));
    }
    for (int i = 1; i < n; ++i) {
        sum = 0;
        for (int k = 1; k <= (i + 1) / 2; ++k) {
            sum += prod(F[i], prod(F_inv[i - k], F_inv[k]));
        }
        ans = prod(ans, sum);
    }
    cout << ans;
}
