#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

typedef long long ll;

const long long INF = 1e18, MOD = 1e9 + 7;
#define all(x) x.begin(), x.end()

map<int, int> X0, X1, Y0, Y1;
map<pair<int, int>, int> mp;
int ansX0 = 0, ansX1 = 0, ansY0 = 0, ansY1 = 0;

void chx(int x, int y, int d) {
	if (x % 2 == 0) {
		ansX0 -= max(X0[x], X1[x]);
	}
	else {
		ansX1 -= max(X0[x], X1[x]);
	}
	if (y % 2 == 0) {
		X0[x] += d;
	}
	else {
		X1[x] += d;
	}
	if (x % 2 == 0) {
		ansX0 += max(X0[x], X1[x]);
	}
	else {
		ansX1 += max(X0[x], X1[x]);
	}
}

void chy(int x, int y, int d) {
	if (y % 2 == 0) {
		ansY0 -= max(Y0[y], Y1[y]);
	}
	else {
		ansY1 -= max(Y0[y], Y1[y]);
	}
	if (x % 2 == 0) {
		Y0[y] += d;
	}
	else {
		Y1[y] += d;
	}
	if (y % 2 == 0) {
		ansY0 += max(Y0[y], Y1[y]);
	}
	else {
		ansY1 += max(Y0[y], Y1[y]);
	}
}

void mk(int x, int y, int d) {
	chx(x, y, d);
	chy(x, y, d);
}

void solve()
{
	int n; cin >> n;
	for (int i = 0; i < n; ++i) {
		int x, y; cin >> x >> y;
		if (mp[make_pair(x, y)]) {
			mk(x, y, -1);
			mp[make_pair(x, y)] = 0;
		}
		else {
			mk(x, y, 1);
			mp[make_pair(x, y)] = 1;
		}
		cout << max(max(ansX0, ansX1), max(ansY0, ansY1)) << '\n';
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*

























*/
