#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long

void solveF() {
    int n;
    cin >> n;

    vector <vector <int>> a(n, vector <int> (n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }

    auto check = [&]() {
        int s = n * n * (n * n + 1) / 2 / n;
        for (int i = 0; i < n; i++) {
            int cur = 0;
            for (int j = 0; j < n; j++) {
                cur += a[i][j];
            }
            if (cur != s) return false;
        }
        for (int j = 0; j < n; j++) {
            int cur = 0;
            for (int i = 0; i < n; i++) {
                cur += a[i][j];
            }
            if (cur != s) return false;
        }
        return true;
    };

    int s = n * n * (n * n + 1) / 2 / n;
    vector <int> r, c;
    for (int i = 0; i < n; i++) {
        int cur = 0;
        for (int j = 0; j < n; j++) {
            cur += a[i][j];
        }
        if (cur != s) {
            r.push_back(i);
        }
    }
    for (int j = 0; j < n; j++) {
        int cur = 0;
        for (int i = 0; i < n; i++) {
            cur += a[i][j];
        }
        if (cur != s) {
            c.push_back(j);
        }
    }

    for (int i1 : r) {
        for (int i2 : r) {
            if (i1 == i2) continue;
            for (int j1 : c) {
                for (int j2 : c) {
                    if (j1 == j2) continue;

                    swap(a[i1][j1], a[i2][j2]);
                    if (check()) {
                        cout << i1 + 1 << " " << j1 + 1 << "\n";
                        cout << i2 + 1 << " " << j2 + 1 << "\n";
                        return;
                    }
                    swap(a[i1][j1], a[i2][j2]);
                }
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;

    while (t--) {
        solveF();
    }
}
