#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MOD = 1e9 + 7;
const int INF = 1e9;

//#define int long long

int bin_pow(int a, int n) {
    int ans = 1;
    while (n > 0) {
        if (n & 1) {
            ans = ans * a % MOD;
        }
        n /= 2;
        a = a * a % MOD;
    }
    return ans;
}

void solveI() {
    int n; cin >> n;
    set<pair<int, int>> now;
    int ansEvenVer = 0, ansOddVer = 0, ansEvenHor = 0, ansOddHor = 0;
    map<int, pair<int, int>> cntVer, cntHor;
    for (int i = 0; i < n; ++i) {
        int x, y; cin >> x >> y;
        int delta = 1;
        if (now.find({x, y}) != now.end()) {
            delta = -1;
            now.erase({x, y});
        } else {
            now.insert({x, y});
        }
        if (x % 2 == 0) {
            ansEvenVer -= max(cntVer[x].first, cntVer[x].second);
            if (y % 2 == 0) {
                cntVer[x].first += delta;
            } else {
                cntVer[x].second += delta;
            }
            ansEvenVer += max(cntVer[x].first, cntVer[x].second);
        } else {
            ansOddVer -= max(cntVer[x].first, cntVer[x].second);
            if (y % 2 == 0) {
                cntVer[x].first += delta;
            } else {
                cntVer[x].second += delta;
            }
            ansOddVer += max(cntVer[x].first, cntVer[x].second);
        }
        if (y % 2 == 0) {
            ansEvenHor -= max(cntHor[y].first, cntHor[y].second);
            if (x % 2 == 0) {
                cntHor[y].first += delta;
            } else {
                cntHor[y].second += delta;
            }
            ansEvenHor += max(cntHor[y].first, cntHor[y].second);
        } else {
            ansOddHor -= max(cntHor[y].first, cntHor[y].second);
            if (x % 2 == 0) {
                cntHor[y].first += delta;
            } else {
                cntHor[y].second += delta;
            }
            ansOddHor += max(cntHor[y].first, cntHor[y].second);
        }
        cout << max({ansEvenVer, ansEvenHor, ansOddVer, ansOddHor}) << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;

    while (t--) {
        solveI();
    }
}
