#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define int long long

typedef pair<int, int> pii;

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}
template<typename T>
ostream &operator <<(ostream &in, vector<T> &arr) {
    for (auto &i : arr) in << i << " ";
    return in;
}

void solve() {
    int n; cin >> n;
    vector<vector<int>> s(n, vector<int>(n)); cin >> s;

    int sm = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            sm += s[i][j];
        }
    }
    sm /= n;

    vector<int> st(n), sr(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            sr[i] += s[i][j];
            st[j] += s[i][j];
        }
    }

    int r1 = -1, r2 = -1;
    for (int i = 0; i < n; i++) {
        if (sm != sr[i]) {
            if (r1 == -1) r1 = i;
            else r2 = i;
        }
    }

    int t1 = -1, t2 = -1;
    for (int i = 0; i < n; i++) {
        if (sm != st[i]) {
            if (t1 == -1) t1 = i;
            else t2 = i;
        }
    }

    if (r2 == -1) r2 = r1;
    if (t2 == -1) t2 = t1;

    if (sr[r1] == st[t1] && sr[r2] == st[t2]) {
        cout << r1 + 1 << " " << t1 + 1 << "\n" << r2 + 1 << " " << t2 + 1 << "\n";
    } else {
        cout << r1 + 1 << " " << t2 + 1 << "\n" << r2 + 1 << " " << t1 + 1 << "\n";
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int tt = 1;
    //cin >> tt;

    while (tt--) {
        solve();
    }
}
