#include <iostream>
#include <vector>
#include <map>
#include <string>

using namespace std;

using ll = long long;


template <typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& x : a) in >> x;
    return in;
}

string SEP = " ";

template <typename T>
ostream& operator<<(ostream& out, vector<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}

void RUN(ll RND) {

}
vector<vector<int>> g;

vector<int> d_root, d_end;
void dfs(int u){
    for(auto v : g[u]){
        d_root[v] = d_root[u] + 1;
        dfs(v);
        d_end[u] = d_end[v] + 1;
    }
    if(g[u].size() == 0) d_end[u] = 0;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n; cin >> n;
    g.resize(n);
    for(int i = 1; i < n; i++){
        int p; cin >> p;
        p--;
        g[p].push_back(i);
    }

    d_root.resize(n);
    d_end.resize(n);
    d_root[0] = 0;
    dfs(0);

    int rez = 1;
    int d_min_read = (1 << 31) - 1;
    int d_max_blue = -1;
    for(int i = 0; i < n; i++){
        if(d_end[i] == 0) {
            d_min_read = min(d_min_read, d_root[i]);
        }
        d_max_blue = max(d_max_blue, d_root[i]);
    }
    int d_blue_now = 0;
    while(true){
        d_blue_now += d_min_read;
        if(d_blue_now >= d_max_blue) break;
        rez++;
        d_min_read = d_max_blue - d_blue_now;
    }

    cout << rez;

    return ('U' ^ 'U');
}
