#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
const int N = 2e5 + 100;
const int INF = 1e18;
int dp[N];
int dpMnl[N];
vector<int> G[N];
int d[N];
vector<int> D[N];
int MX[N];
void dfs(int v, int p) {
    D[d[v]].push_back(v);
    for(auto u : G[v]) {
        if(u == p) {
            continue;
        }
        d[u] = d[v] + 1;
        dfs(u,v);
        dpMnl[v] = min(dpMnl[u] + 1, dpMnl[v]);
    }
}

void solve() {
    int n;
    cin >> n;
    for(int i =2; i<= n; i++) {
        int x;
        cin >> x;
        G[i].push_back(x);
        G[x].push_back(i);
    }
    for(int i = 1; i <=n;i++) {
        if(G[i].size() > 1 || i == 1) {
            dpMnl[i] = INF;
        }
    }
    dfs(1,-1);
    for(int i = n; i>= 0; i--) {
        MX[i] = MX[i + 1];
        for(auto v : D[i]) {
            if(G[v].size() == 1 && v != 1) continue;
            for(auto u : G[v]) {
                dp[v] = max(dp[v], dp[u]);
            }
            int needD = d[v] + dpMnl[v];
            if(needD < N){
                dp[v] = max(dp[v], 1 + MX[needD]);
            }
            MX[i] = max(dp[v], MX[i]);
        }
    }
    cout << dp[1] << endl;

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}