#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

constexpr int MOD = 1e9 + 7;

int add(int a, int b) {
    if ((a += b) >= MOD) {
        a -= MOD;
    }
    return a;
}
int mul(int a, int b) {
    return a * b % MOD;
}

void solve() {
    int n;
    cin >> n;
    vector dp(n + 1, vector<int>(n + 1));
    dp[0][0] = 1;
    for (int len = 1; len <= n; len++) {
        for (int sum = 0; sum <= n; sum++) {
            dp[len][sum] = add(dp[len][sum], dp[len-1][sum]);
            if (sum-1 >= 0) dp[len][sum] = add(dp[len][sum], dp[len-1][sum-1]);
            if (sum-2 >= 0) dp[len][sum] = add(dp[len][sum], dp[len-1][sum-2]);
        }
    }
    int ans = 1;
    for (int i = 1; i < n; i++) {
        ans = mul(ans, dp[i][i + 1]);
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}