
#include <bits/stdc++.h>
#define int ll

using namespace std;

typedef long long ll;
const int N = 1e5 + 10;
const int mod = 1e9 + 7;

int dp[1002][1002];
int pref[1002][1002];
int lim;

ll get(int i , int j , int l , int r)
{
    ll sum = pref[j][r];
    if(l > r || i > j)
    {
        return 0;
    }
    if(l > 0)
    {
        sum += mod;
        sum -= pref[j][l - 1];
        sum %= mod;
    }
    if(i > 0)
    {
        sum += mod;
        sum -= pref[i - 1][r];
        sum %= mod;
    }
    if(l > 0 && i > 0)
    {
        sum += mod;
        sum += pref[i - 1][l - 1];
        sum %= mod;
    }
    return sum;
}

int solve(int mex)
{
    //cout << mex << endl;
    if(mex * (mex - 1) / 2 > lim)
    {
        return 0;
    }
    int n = lim - (mex - 1) * mex / 2;
    for(int i = 0;i <= n;++ i)
    {
        for(int j = 0;j <= n;++ j)
        {
            dp[i][j] = 0;
            pref[i][j] = 0;
        }
    }
    dp[0][0] = 1;
    pref[0][0] = 1;
    for(int i = 1;i <= n;++ i)
    {
        pref[0][i] = 1;
        pref[i][0] = 1;
    }
    for(int i = 1;i <= n;++ i)
    {
        for(int j = 1;j <= n;++ j)
        {
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] + mod - pref[i - 1][j - 1];
            pref[i][j] %= mod;
            if(j <= i)
            {
                dp[i][j] += get(i - j , i - j , 0 , j);
                dp[i][j] %= mod;
                dp[i][j] += mod;
                //dp[i][j] -= dp[i - j][mex];
                dp[i][j] %= mod;
                if(j == mex)
                {
                    dp[i][j] += mod;
                    dp[i][j] -= get(i - mex , i - mex , 0 , mex);
                    dp[i][j] %= mod;
                }
            }
            pref[i][j] += dp[i][j];
            pref[i][j] %= mod;
        }
    }
    ll ans = 0;
    for(int i = 0;i <= n;++ i)
    {
        ans += dp[n][i];
        ans %= mod;
    }
    return ans;
}


int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef LOCAL

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
    int n;
    cin >> n;
    lim = n;
    ll answer = 0;
    for(int i = 0;i <= sqrt(3 * n);++ i)//sqrt(3 * n);++ i)
    {
        //cerr << i + 1 << ' ' << solve(i + 1) << endl;
        answer += ((i + 1) * solve(i + 1)) % mod;
        answer %= mod;

    }


    cout << answer;
    return 0;
}
