#include <bits/stdc++.h>
using namespace std;
#define int long long

const int N = 1000 + 10;
int a[N][N];

void solve() {
    int n;
    cin >> n;

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            cin >> a[i][j];
        }
    }

    if (n == 3) {
        for (int r1 = 1; r1 <= n; r1++) {
            for (int c1 = 1; c1 <= n; c1++) {
                for (int r2 = 1; r2 <= n; r2++) {
                    for (int c2 = 1; c2 <= n; c2++) {
                        swap(a[r1][c1], a[r2][c2]);

                        set<int> s;

                        for (int i = 1; i <= n; i++) {
                            int sum = 0;
                            for (int j = 1; j <= n; j++) {
                                sum += a[i][j];
                            }
                            s.insert(sum);
                        }

                        for (int j = 1; j <= n; j++) {
                            int sum = 0;
                            for (int i = 1; i <= n; i++) {  
                                sum += a[i][j];
                            }
                            s.insert(sum);
                        }

                        if (s.size() == 1) {
                            cout << r1 << " " << c1 << "\n" << r2 << " " << c2 << "\n";
                            return;
                        }

                        swap(a[r1][c1], a[r2][c2]);
                    }
                }
            }
        }
    }

    // find corr
    map<int, int> cm;

    for (int i = 1; i <= n; i++) {
        int sum = 0;
        for (int j = 1; j <= n; j++) {
            sum += a[i][j];
        }
        cm[sum]++;
    }

    for (int j = 1; j <= n; j++) {
        int sum = 0;
        for (int i = 1; i <= n; i++) {
            sum += a[i][j];
        }
        cm[sum]++;
    }

    int corr = 0;
    for (auto [sum, cnt] : cm) {
        if (cnt > cm[corr]) {
            corr = sum;
        }
    }

    // find inc
    vector<pair<int, int>> in;

    for (int i = 1; i <= n; i++) {
        int sum = 0;
        for (int j = 1; j <= n; j++) {
            sum += a[i][j];
        }
        if (sum != corr) {
            in.emplace_back(i, -1);
        }
    }

    for (int j = 1; j <= n; j++) {
        int sum = 0;
        for (int i = 1; i <= n; i++) {
            sum += a[i][j];
        }
        if (sum != corr) {
            in.emplace_back(-1, j);
        }
    }

    vector<int> r, c;
    for (auto [ri, ci] : in) {
        if (ri != -1) {
            r.emplace_back(ri);
        }

        if (ci != -1) {
            c.emplace_back(ci);
        }
    }

    for (auto r1 : r) {
        for (auto c1 : c) {
            for (auto r2 : r) {
                for (auto c2 : c) {
                    if (r1 == r2 && c1 == c2) {
                        continue;
                    }

                    swap(a[r1][c1], a[r2][c2]);

                    set<int> s;
                    s.insert(corr);

                    {
                        int sum = 0;
                        for (int j = 1; j <= n; j++) {
                            sum += a[r1][j];
                        }
                        s.insert(sum);
                    }

                    {
                        int sum = 0;
                        for (int j = 1; j <= n; j++) {
                            sum += a[r2][j];
                        }
                        s.insert(sum);
                    }

                    {
                        int sum = 0;
                        for (int i = 1; i <= n; i++) {
                            sum += a[i][c1];
                        }
                        s.insert(sum);
                    }

                    {
                        int sum = 0;
                        for (int i = 1; i <= n; i++) {
                            sum += a[i][c2];
                        }
                        s.insert(sum);
                    }

                    if (s.size() == 1) {
                        cout << r1 << " " << c1 << "\n" << r2 << " " << c2 << "\n";
                        return;
                    }

                    swap(a[r1][c1], a[r2][c2]);
                }
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
