#include <bits/stdc++.h>

using namespace std;
#define int long long
const size_t nMax = 5e3 + 228, mod = 1e9 + 7;

int binpow(int n, int m) {
    int res = 1;
    while (m) {
        if (m & 1) {
            res = (res * n) % mod;
        }

        n = (n * n) % mod;
        m >>= 1;
    }

    return res;
}

struct mint {
    int value = 0;

    mint() {}
    mint(int val) : value(val) {}

    mint operator+(mint oth) {
        auto rese = value + oth.value;
        if (rese >= mod)rese -= mod;
        return {rese};
    }

    mint operator-(mint oth) {
        auto rese = value - oth.value;
        if (rese < 0)rese += mod;
        return {rese};
    }

    mint operator*(mint oth) {
        int rese = (value * oth.value) % mod;
        return {rese};
    }

    mint operator/(mint oth) {
        return *this * mint(binpow(oth.value, mod-2));
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    int cnt0 = 0, cnt1 = 0, cnt2 = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i] %= 3;
        if (a[i] == 1) cnt1++;
        else if (a[i] == 2) cnt2++;
        else cnt0++;
    }

    auto check = [](int ones, int twos) {
        return twos >= ones && twos <= ones + 1;
    };

    mint ans(0);

    mint fac1(1);
    mint fac2(1);

    for (int i = 2; i <= cnt1; i++) {
        fac1 = fac1 * mint(i);
    }

    for (int i = 2; i <= cnt2; i++) {
        fac2 = fac2 * mint(i);
    }

    if (check(cnt1-2, cnt2)) {
        mint cur(1);

        ans = ans + mint(1);
    }

    if (check(cnt1, cnt2-1)) {
        ans = ans + mint(1);
    }

    int tot = n-1;
    mint cur(1);
    for (int i = 2; i <= tot; i++) {
        cur = cur * mint(i);
    }

    mint q(1);
    for (int i = 2; i <= cnt1 + cnt2 - 1; i++) {
        q = q * (mint(i));
    }

    mint w(1);
    for (int i = 2; i <= tot - (cnt1 + cnt2 - 1); i++) {
        w = w * (mint(i));
    }

    cout << (ans * fac1 * fac2 * cur / q / w).value;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
