#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

vector<ll> fac(200001), fac_rev(200001);
ll mod = 1e9 + 7;

ll cnk(int n, int k) {
    return fac[n] * fac_rev[n - k] * fac_rev[k];
}

void diof(ll a, ll b, ll &x, ll &y) {
    if (b == 0) {
        x = 1;
        y = 0;
        return;// a;
    }
    ll x1, y1;
    diof(b, a % b, x1, y1);
    x = y1;
    y = x1 - (a / b) * y1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    fac[0] = 1;
    fac[1] = 1;
    fac_rev[1] = 1;
    for (ll i = 2; i < 200001; ++i) {
        fac[i] = i * fac[i - 1] % mod;
    }
    ll x, y;
    diof(fac[200000], mod, x, y);
    fac_rev[200000] = ((x + mod) % mod) % mod;
    for (ll i = 200000 - 1; i > -1; --i) {
        fac_rev[i] = fac_rev[i + 1] * (i + 1) % mod;
    }
    ll n;
    cin >> n;
    ll z = 0;
    x = 0;
    y = 0;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t % 3 == 0) {
            z++;
        } else if (t % 3 == 1) {
            x++;
        } else {
            y++;
        }
    }
    if (abs(x - y) > 2 || abs(x - y) == 0) {
        cout << 0;
        return 0;
    }
    ll ans = ((fac[x] * fac[y]) % mod * fac[z]) % mod;
    ans *= cnk(x + y + z - 1, x + y - 1);
    ans %= mod;
    cout << ans;
    return 0;
}
