#include<iostream>
#include<string>
#include<vector>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>

#define sz(x) (long long)x.size()
#define pb push_back
#define fr first
#define sc second

using namespace std;
using ll = long long;
using vl = vector<ll>;
using vvl = vector<vl>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;

const ll INF = 1e18;

bool g(vvl& v, ll n) {
	set<ll> s1, s2;
	for (int i = 0; i < n; i++) {
		ll c = 0;
		for (int j = 0; j < n; j++)
			c += v[i][j];
		s1.insert(c);
	}
	for (int i = 0; i < n; i++) {
		ll c = 0;
		for (int j = 0; j < n; j++)
			c += v[j][i];
		s2.insert(c);
	}
	if (sz(s1) == 1 && sz(s2) == 1)
		return 1;
	return 0;
}



void f(vvl& v, ll n) {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			for (int ii = 0; ii < n; ii++) {
				for (int jj = 0; jj < n; jj++) {
					if (ii == i && jj == j)continue;
					swap(v[i][j], v[ii][jj]);
					if (g(v, n)) {
						cout << i + 1 << " " << j + 1 << "\n" << ii + 1 << " " << jj + 1;
						return;
					}
					swap(v[i][j], v[ii][jj]);
				}
			}
		}
	}
	cout << "1 1\n1 1";
}

bool prov(pll p1, pll p2, ll st, ll sr, vvl&prs, vvl&prl, vvl&v) {
	ll sum1 = prs[p1.sc].back();
	ll sum2 = prs[p2.sc].back();
	ll sum3 = prl[p1.fr].back();
	ll sum4 = prl[p2.fr].back();
	sum1 += v[p2.fr][p2.sc] - v[p1.fr][p1.sc];
	sum2 += -v[p2.fr][p2.sc] + v[p1.fr][p1.sc];
	sum3 += v[p2.fr][p2.sc] - v[p1.fr][p1.sc];
	sum4 += -v[p2.fr][p2.sc] + v[p1.fr][p1.sc];
	if (sum1 == st && sum2 == st && sum3 == sr && sum4 == sr)
		return 1;
	return 0;
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	ll n; cin >> n;
	vvl v(n, vl(n)); for (auto& i : v)for (auto& j : i)cin >> j;
	if (n < 10) {
		f(v, n);
		return 0;
	}
	vvl prl(n, vl(n + 1, 0)); for (int i = 0; i < n; i++)for (int j = 0; j < n; j++)prl[i][j + 1] = prl[i][j] + v[i][j];
	vvl prs(n, vl(n + 1, 0)); for (int i = 0; i < n; i++)for (int j = 0; j < n; j++)prl[i][j+1] = prl[i][j] + v[j][i];
	map<ll, vl> mym1, mym2;
	for (int i = 0; i < n; i++)mym1[prl[i][n]].pb(i);
	for (int i = 0; i < n; i++)mym2[prs[i][n]].pb(i);
	ll x1 = -INF, x2 = -INF, y1 = -INF, y2 = -INF;
	for(auto i : mym1)
		if(i.sc.size()<3)
			for (auto j : i.sc) {
				if (x1 == -INF)
					x1 = j;
				else
					x2 = j;
			}
	for (auto i : mym2)
		if (i.sc.size() < 3)
			for (auto j : i.sc) {
				if (y1 == -INF)
					y1 = j;
				else
					y2 = j;
			}
	if (mym1.size() == 0) {
		ll st, sr = prl[0].back();
		for (auto i : mym2)
			if (i.sc.size() > 2) st = i.fr;
		for (int i = 0; i < n; i++) {
			pll p1 = { i, y1 }, p2 = { i, y2 };
			if (prov(p1, p2, st, sr, prs, prl, v)) {
				cout << p1.fr + 1 << " " << p1.sc + 1 << "\n" << p2.fr + 1 << " " << p2.sc + 1;
				return 0;
			}
		}
	}
	if (mym2.size() == 0) {
		ll st = prs[0].back(), sr;
		for (auto i : mym1)
			if (i.sc.size() > 2) sr = i.fr;
		for (int i = 0; i < n; i++) {
			pll p1 = { x1, i }, p2 = { x2, i };
			if (prov(p1, p2, st, sr, prs, prl, v)) {
				cout << p1.fr + 1 << " " << p1.sc + 1 << "\n" << p2.fr + 1 << " " << p2.sc + 1;
				return 0;
			}
		}
	}
	ll st, sr;
	for (auto i : mym1)
		if (i.sc.size() > 2) sr = i.fr;
	for (auto i : mym2)
		if (i.sc.size() > 2) st = i.fr;
	if (prov({ x1, y1 }, { x2, y2 }, st, sr, prs, prl, v))
		cout << x1 + 1 << " " << y1 + 1 << "\n" << x2 + 1 << " " << y2 + 1;
	else if (prov({ x2, y1 }, { x1, y2 }, st, sr, prs, prl, v))
		cout << x1 + 1 << " " << y1 + 1 << "\n" << x2 + 1 << " " << y2 + 1;
}