#include<iostream>
#include<string>
#include<vector>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>

#define sz(x) (long long)x.size()
#define pb push_back
#define fr first
#define sc second

using namespace std;
using ll = long long;
using vl = vector<ll>;
using vvl = vector<vl>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
vl prl, prs;
vvl v;
ll suma;
const ll INF = 1e18;

bool prov(pll p1, pll p2) {
	ll sum1 = prl[p1.fr] - v[p1.fr][p1.sc] + v[p2.fr][p2.sc];
	ll sum2 = prl[p2.fr] + v[p1.fr][p1.sc] - v[p2.fr][p2.sc];
	ll sum3 = prs[p1.sc] - v[p1.fr][p1.sc] + v[p2.fr][p2.sc];
	ll sum4 = prl[p2.sc] + v[p1.fr][p1.sc] - v[p2.fr][p2.sc];
	if (sum1 == suma && sum2 == suma && sum3 == suma && sum4 == suma)
		return 1;
	return 0;
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	ll n; cin >> n;
	v.resize(n, vl(n)); for (auto& i : v)for (auto& j : i)cin >> j;
	prl.resize(n, 0); for (int i = 0; i < n; i++)for (int j = 0; j < n; j++)prl[i] += v[i][j];
	prs.resize(n, 0); for (int i = 0; i < n; i++)for (int j = 0; j < n; j++)prs[i] += v[j][i];
	suma = (1 + n * n) * n / 2;
	vl stroki; for (int i = 0; i < n; i++)if (prl[i] != suma)stroki.pb(i);
	vl stolbi; for (int i = 0; i < n; i++)if (prs[i] != suma)stolbi.pb(i);
	if (sz(stroki) == sz(stolbi) && sz(stroki) == 2) {
		ll x1 = stroki[0], x2 = stroki[1], y1 = stolbi[0], y2 = stolbi[1];
		if (prov({ x1, y1 }, { x2, y2 }))
			cout << x1 + 1 << " " << y1 + 1 << "\n" << x2 + 1 << " " << y2 + 1;
		else
			cout << x1 + 1 << " " << y2 + 1 << "\n" << x2 + 1 << " " << y1 + 1;
		return 0;
	}
	else if (sz(stroki) == 2) {
		ll x1 = stroki[0], x2 = stroki[1];
		for (int i = 0; i < n; i++) {
			if (prov({ x1, i }, { x2, i })) {
				cout << x1 + 1 << " " << i + 1 << "\n" << x2 + 1 << " " << i + 1;
				return 0;
			}
		}
	}
	else if (sz(stolbi) == 2) {
		ll y1 = stolbi[0], y2 = stolbi[1];
		for (int i = 0; i < n; i++) {
			if (prov({ i, y1 }, { i, y2 })) {
				cout << i + 1 << " " << y1 + 1 << "\n" << i + 1 << " " << y2 + 1;
				return 0;
			}
		}
	}
	else {
		cout << "1 1\n1 1";
	}
}