#include "bits/stdc++.h"

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    // cin >> t;
    while (t--)
        solve();
}

bool is(vector<vector<ll>> &v) {
    ll n = v.size();
    vector<ll> sum1(n), sum2(n);
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++) {
            sum1[i] += v[i][j];
            sum2[j] += v[i][j];
        }
    }
    set<ll> s;
    for (ll i: sum1)
        s.insert(i);
    for (ll i: sum2)
        s.insert(i);
    return s.size() == 1;
}

void solve() {
    ll n;
    cin >> n;
    vector<vector<ll>> v(n, vector<ll>(n));
    for (auto &i: v) {
        for (ll &j: i)
            cin >> j;
    }
    if (is(v)) {
        cout << "1 1\n1 1\n";
        return;
    }
    vector<ll> sum1(n), sum2(n);
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++) {
            sum1[i] += v[i][j];
            sum2[j] += v[i][j];
        }
    }
    if (n == 3) {
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < n; j++) {
                for (ll i1 = 0; i1 < n; i1++) {
                    for (ll j1 = 0; j1 < n; j1++) {
                        swap(v[i][j], v[i1][j1]);
                        if (is(v)) {
                            cout << i + 1 << ' ' << j + 1 << '\n';
                            cout << i1 + 1 << ' ' << j1 + 1 << '\n';
                            return;
                        }
                        swap(v[i][j], v[i1][j1]);
                    }
                }
            }
        }
    }
    ll x = -1, y = -1, x1 = -1, y1 = -1;
    map<ll, ll> a, b;
    for (ll i = 0; i < n; i++) {
        a[sum1[i]]++;
        b[sum2[i]]++;
    }
    for (ll i = 0; i < n; i++) {
        if (a[sum1[i]] == 1) {
            if (x == -1)
                x = i;
            else
                y = i;
        }
    }
    for (ll i = 0; i < n; i++) {
        if (b[sum2[i]] == 1) {
            if (x1 == -1)
                x1 = i;
            else
                y1 = i;
        }
    }
    if (y == -1) {
        for (int i = 0; i < n; i++) {
            if (sum2[x1] - v[i][x1] + v[i][y1] == sum2[y1] - v[i][y1] + v[i][x1]) {
                cout << i + 1 << ' ' << x1 + 1 << '\n';
                cout << i + 1 << ' ' << y1 + 1 << '\n';
                return;
            }
        }
    }
    if (y1 == -1) {
        for (int i = 0; i < n; i++) {
            if (sum1[x] - v[x][i] + v[y][i] == sum1[y] - v[y][i] + v[x][i]) {
                cout << x + 1 << ' ' << i + 1 << '\n';
                cout << y + 1 << ' ' << i + 1 << '\n';
                return;
            }
        }
    }
    swap(v[x][x1], v[y][y1]);
    if (is(v)) {
        cout << x + 1 << ' ' << x1 + 1 << '\n';
        cout << y + 1 << ' ' << y1 + 1 << '\n';
        return;
    }
    cout << x + 1 << ' ' << y1 + 1 << '\n';
    cout << y + 1 << ' ' << x1 + 1 << '\n';
}
