#include <bits/stdc++.h>

using namespace std;

#define endl "\n"

template<typename T>
istream& operator>>(istream& in, vector<T> &arr__) {
    for (auto &i : arr__) {
        in >> i;
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T> &arr__) {
    for (auto &i : arr__) {
        out << i << " ";
    }
    return out;
}

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define int ll

#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
#define file(a, b) freopen(a, "r", stdin); freopen(b, "w", stdout);
#define p_b push_back
#define all(x) (x).begin() (x).end()
#define rall(x) (x).rbegin() (x).rend()

const int INT_INF = INT_MAX;
const ll LL_INF = LONG_LONG_MAX;
const int mod = 1000000007;

int bin_pow(int a, int b) {
    if (b == 0) {
        return 1;
    }
    if (b % 2 == 1) {
        return (int)((1ll * a * bin_pow(a, b - 1)) % mod);
    }
    int r = bin_pow(a, b / 2);
    return (int)((1ll * r * r) % mod);
}

int fact(int n) {
    int res = 1;
    for (int i = 1; i <= n; i++) {
        res = res * i;
        res = res % mod;
    }
    return res;
}

int cnk(int n, int k) {
    ll f1, f2, f3, f4, f5;
    f1 = fact(n);
    f2 = fact(k);
    f3 = fact(n - k);
    f4 = 1ll * bin_pow((int)f2, mod - 2);
    f5 = 1ll * bin_pow((int)f3, mod - 2);
    f1 = f1 * f4;
    f1 = f1 % mod;
    f1 = f1 * f5;
    f1 = f1 % mod;
    return (int)(f1);
}

signed main() {
    //file("inp.txt", "out.txt")
    fast
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> cnt(3);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i] = a[i] % 3;
        cnt[a[i]]++;
    }
    if (abs(cnt[1] - cnt[2]) > 2) {
        cout << "0\n";
        exit(0);
    }
    if (cnt[1] == cnt[2]) {
        cout << "0\n";
        exit(0);
    }
    int mn, mx;
    mn = min(cnt[1], cnt[2]);
    mx = max(cnt[1], cnt[2]);
    //mx!*mn!*cnk(mn+mx-1+cnt[0],cnt[0])*cnt[0]!
    ll ans;
    ans = 1ll * fact(mx);
    ans = ans * (1ll * fact(mn));
    ans = ans % mod;
    ans *= (1ll * cnk(mn+mx+cnt[0]-1,cnt[0]));
    ans = ans % mod;
    ans *= (1ll * fact(cnt[0]));
    ans = ans % mod;
    cout << ans << "\n";
}
