#include <bits/stdc++.h>

using namespace std;

//#define endl "\n"

template<typename T>
istream& operator>>(istream& in, vector<T> &arr__) {
    for (auto &i : arr__) {
        in >> i;
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T> &arr__) {
    for (auto &i : arr__) {
        out << i << " ";
    }
    return out;
}

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
//#define int ll

#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
#define file(a, b) freopen(a, "r", stdin); freopen(b, "w", stdout);
#define p_b push_back
#define all(x) (x).begin() (x).end()
#define rall(x) (x).rbegin() (x).rend()

const int INT_INF = INT_MAX;
const ll LL_INF = LONG_LONG_MAX;
const int mod = 1000000007;

int req(int ind, str s) {
    cout << "? " << ind + 1 << " " << s << endl;
    int x;
    cin >> x;
    return x;
}

signed main() {
    fast
    int n;
    cin >> n;
    ll ans = 0;
    vector<vector<int>> dp1(n + 1, vector<int>(n + 1)), dp2(n + 1, vector<int>(n + 1));
    dp2[0][0] = 1;
    for (int i = 2; i <= n; i++) {
        dp2[i][i] = 1;
    }
    for (int i = 2; i <= n; i++) {
        for (int j = 2; j <= i; j++) {
            for (int u = 2; u <= j && u + i <= n; u++) {
                dp2[i + u][u] += dp2[i][j];
                if (dp2[i + u][u] >= mod) {
                    dp2[i + u][u] -= mod;
                }
            }
        }
    }
    for (int i = 0; i <= n; i++) {
        for (int j = n; j >= 1; j--) {
            dp2[i][j - 1] += dp2[i][j];
            if (dp2[i][j - 1] >= mod) {
                dp2[i][j - 1] -= mod;
            }
        }
    }
    dp1[1][1] = 1;
    for (int i = 0; i <= n; i++) {
        for (int j = 0; i + j <= n && j <= i; j++) {
            if (i + j != 0) {
                dp1[i + j][j] += dp1[i][j];
            }
            if (dp1[i + j][j] >= mod) {
                dp1[i + j][j] -= mod;
            }
            if (i + j + 1 <= n) {
                dp1[i + j + 1][j + 1] += dp1[i][j];
                if (dp1[i + j + 1][j + 1] >= mod) {
                    dp1[i + j + 1][j + 1] -= mod;
                }
            }
            if (i + j + 2 <= n) {
                if (j != 0) {
                    ans += 1ll * dp2[n - i][j + 2] * (j + 1);
                    ans %= mod;
                } else {
                    if (i == 0) {
                        ans += 1ll * dp2[n - i][j + 2] * (j + 1);
                        ans %= mod;
                    }
                }
            }
        }
    }
    for (int i = 0; i <= n; i++) {
        ans += dp1[n][i] * (i + 1);
        ans %= mod;
    }
    cout << ans << "\n";
}
