#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    long long n;
    cin >> n;
    vector <vector<long long>> a(n, vector<long long>(n));
    vector <long long> sumsi(n, 0);
    vector <long long> sumsj(n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
            sumsi[i] += a[i][j];
            sumsj[j] += a[i][j];
        }
    }
    long long ig = (1ll + n * n) * n / 2;
    vector <int> iw;
    vector <int> jw;
    for (int i = 0; i < n; i++) {
        if (sumsi[i] != ig) {
            iw.push_back(i);
        }
        if (sumsj[i] != ig) {
            jw.push_back(i);
        }
    }
    if (iw.empty()) {
        for (int i = 0; i < n; i++) {
            if (ig - sumsj[jw[0]] == a[i][jw[1]] - a[i][jw[0]]) {
                cout << i + 1 << " " << jw[0] + 1 << "\n";
                cout << i + 1 << " " << jw[1] + 1 << "\n";
                break;
            }
        }
    } else if (jw.empty()) {
        for (int j = 0; j < n; j++) {
            if (ig - sumsi[iw[0]] == a[iw[1]][j] - a[iw[0]][j]) {
                cout << iw[0] + 1 << " " << j + 1 << "\n";
                cout << iw[1] + 1 << " " << j + 1 << "\n";
                break;
            }
        }
    } else {
        if (sumsi[iw[0]] == sumsj[jw[0]]) {
            cout << iw[0] + 1 << " " << jw[0] + 1 << "\n";
            cout << iw[1] + 1 << " " << jw[1] + 1 << "\n";
        } else {
            cout << iw[0] + 1 << " " << jw[1] + 1 << "\n";
            cout << iw[1] + 1 << " " << jw[0] + 1 << "\n";
        }
    }
}
