#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,strict-overflow")
#pragma GCC target("sse4.2,avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif
using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pdd = pair<double, double>;
using pii = pair<int, int>;

#define inf 1'000'001'000
#define linf 1'000'000'000'000'001'000ll

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<vector<ll>> dp(n + 1, vector<ll>(n + 1));
    dp[0][0] = 1;
    ll ans = 1;
    const ll mod = 1'000'000'007;
    for (int i = 1; i <= n - 1; ++i) {
        for (int j = 0; j <= n; ++j) {
            if (j > 1) dp[i][j] = dp[i - 1][j]  + dp[i - 1][j - 1] + dp[i - 1][j - 2];
            else if (j == 1) dp[i][j] = dp[i - 1][j - 1] + dp[i - 1][j];
            else dp[i][j] = dp[i - 1][j];
            dp[i][j] %= mod;
            //cout << i << ' ' << j << ' ' << dp[i][j] << '\n';
        }
        if (i != 1) {
            ans *= dp[i][i + 1];
            ans %= mod;
        }
    }
    cout << ans;
}
