#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = 1000000007;

map<pair<ll, pair<ll, ll>>, ll> mp;

ll rec(ll n, ll d, ll last) {
    if (mp.find({n, {d, last}}) != mp.end())
        return mp[{n, {d, last}}];
    if (n == 0)
        return 1ll;
    ll res = 0;
    for (ll i = last; i <= min(n, 1000ll); i++) {
        if (i != d) {
            res += rec(n - i, d, i);
            res %= MOD;
        }
    }
    mp[{n, {d, last}}] = res;
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n; cin >> n;
    ll cnt = 0;
    ll i = 1;
    ll ans = 0;
    while (cnt <= n) {
        ans += (rec(n - cnt, i, 1) * i) % MOD;
        ans %= MOD;
        cnt += i;
        i++;
    }
    cout << ans << "\n";
    return 0;

}
