#include <bits/stdc++.h>

using namespace std;

//#define int long long

#pragma GCC optimize("03")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,bmi2,fma")
#define endl '\n'

struct node{
    bool lev;
    bool pr;
    bool oba;
    bool vse;
    char first;
    char last;
};

string s;

struct segtree{
    node d[400000];
    void build(int u, int l, int r){
        if(l + 1 == r){
            d[u].lev = true;
            d[u].pr = true;
            d[u].oba = false;
            d[u].vse = (s[l] == 'a');
            d[u].last = s[l];
            d[u].first = s[l];
        }else{
            int m = (l + r) / 2;
            build(2 * u + 1, l, m);
            build(2 * u + 2, m, r);
            d[u].lev = (d[u * 2 + 1].lev && d[u * 2 + 2].vse) || (d[u * 2 + 1].oba && d[u * 2 + 1].last != d[u * 2 + 2].first && d[u * 2 + 2].lev);
            d[u].pr = (d[u * 2 + 1].vse && d[u * 2 + 2].pr) || (d[u * 2 + 1].pr && d[u * 2 + 1].last != d[u * 2 + 2].first && d[u * 2 + 2].oba);
            d[u].oba = (d[u * 2 + 1].lev && d[u * 2 + 2].pr) || (d[u * 2 + 1].oba && d[u * 2 + 1].last != d[u * 2 + 2].first && d[u * 2 + 2].pr);
            d[u].vse = (d[u * 2 + 1].vse && d[u * 2 + 2].vse) || (d[u * 2 + 1].pr && d[u * 2 + 1].last != d[u * 2 + 2].first && d[u * 2 + 2].lev);
            d[u].first = d[u * 2 + 1].first;
            d[u].last = d[u * 2 + 2].last;
        }
    }
    node get(int u, int l, int r, int ql, int qr){
        if(l >= qr || r <= ql){
            return {false, false, false, true, 'f', 'l'};
        }
        if(ql <= l && r <= qr){
            return d[u];
        }
        int m = (l + r) / 2;
        node a = get(u * 2 + 1, l, m, ql, qr);
        node b = get(u * 2 + 2, m, r, ql, qr);
        node ans;
        ans.lev = (a.lev && b.vse) || (a.oba && a.last != b.first && b.lev);
        ans.pr = (a.vse && b.pr) || (a.pr && a.last != b.first && b.oba);
        ans.oba = (a.lev && b.pr) || (a.oba && a.last != b.first && b.pr);
        ans.vse = (a.vse && b.vse) || (a.pr && a.last != b.first && b.lev);
        ans.first = a.first;
        ans.last = b.last;
        if(ans.first == 'f'){
            ans.first = b.first;
        }
        if(ans.last == 'l'){
            ans.last = a.last;
        }
        return ans;
    }
    void update(int u, int l, int r, int ind){
        if(l + 1 == r){
            d[u].lev = true;
            d[u].pr = true;
            d[u].oba = true;
            d[u].vse = (s[l] == 'a');
            d[u].last = s[l];
            d[u].first = s[l];
            return;
        }
        int m = (l + r) / 2;
        if(ind < m){
            update(u * 2 + 1, l, m, ind);
        }else{
            update(u * 2 + 2, m, r, ind);
        }
        d[u].lev = (d[u * 2 + 1].lev && d[u * 2 + 2].vse) || (d[u * 2 + 1].oba && d[u * 2 + 1].last != d[u * 2 + 2].first && d[u * 2 + 2].lev);
        d[u].pr = (d[u * 2 + 1].vse && d[u * 2 + 2].pr) || (d[u * 2 + 1].pr && d[u * 2 + 1].last != d[u * 2 + 2].first && d[u * 2 + 2].oba);
        d[u].oba = (d[u * 2 + 1].lev && d[u * 2 + 2].pr) || (d[u * 2 + 1].oba && d[u * 2 + 1].last != d[u * 2 + 2].first && d[u * 2 + 2].pr);
        d[u].vse = (d[u * 2 + 1].vse && d[u * 2 + 2].vse) || (d[u * 2 + 1].pr && d[u * 2 + 1].last != d[u * 2 + 2].first && d[u * 2 + 2].lev);
        d[u].first = d[u * 2 + 1].first;
        d[u].last = d[u * 2 + 2].last;
    }
};

segtree st;

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n >> s;
    int q;
    cin >> q;
    st.build(0, 0, n);
    while(q--){
        int t;
        cin >> t;
        if(t == 1){
            int ind;
            cin >> ind;
            ind--;
            s[ind] = (char)(('a' + 'b') - s[ind]);
            st.update(0, 0, n, ind);
        }else{
            int l, r;
            cin >> l >> r;
            l--;r--;
            node ans = st.get(0, 0, n, l, r + 1);
            if(ans.vse){
                cout << "YES\n";
            }else{
                cout << "NO\n";
            }
        }
    }
    return 0;
}
