#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    out << a.first << ' ' << a.second;
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a)out << i << ' ';
    return out;
}
ll a, b, c;
ll f(ll x){
    if(x<5){
        return a;
    }
    if(x<10){
        return b;
    }
    return c;
}

void solve1() {
    map<pair<ll, ll>, ll> mp, mp1;
    ll q;
    cin>>q;
    while(q--){
        ll x, y;
        cin>>x>>y;
        if(mp1[{x, y}]==1){
            mp1[{x, y}]=0;
            mp[{x%2, y%2}]--;
        }
        else{
            mp1[{x, y}]=1;
            mp[{x%2, y%2}]++;
        }
        cout<<max({mp[{0, 0}], mp[{1, 1}], mp[{0, 1}], mp[{1, 0}]})<<"\n";
    }
}
void solve(){
    ll n;
    cin>>n;
    vector<vector<ll>> dp(2*n, vector<ll> (n+2, 0));
    dp[0][0]=1;
    ll ans =1, mod = 1e9+7;
    for(int i = 1; i<2*n; i++){
        for(int j = 0; j<n+2; j++){
            dp[i][j]=dp[i-1][j];
            if(j>=1){
                dp[i][j]+=dp[i-1][j-1];
            }
            if(j>=2){
                dp[i][j]+=dp[i-1][j-2];
            }
            dp[i][j]%=mod;
        }
    }
    //cout<<dp<<"\n";
    for(int i = 1; i<n; i++){
        ans*=dp[i][i+1];
        ans%=mod;
    }
    cout<<ans<<"\n";
}
signed main() {
#ifdef Local
    freopen("in.in", "r", stdin);
    freopen("out.out", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    ll t = 1;
    //cin>>t;
    while (t--) solve();
}
