#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    out << a.first << ' ' << a.second;
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a)out << i << '\n';
    return out;
}

void solve() {
    ll n;
    cin>>n;
    if(n==1){
        cout<<2<<"\n";
        return;
    }
    vector<vector<ll>> dp(n+1, vector<ll> (n+1, 0));
    vector<vector<ll>> dp1(n+1, vector<ll> (n+1, 0));
    for(int i = 1; i<=n; i++){
        for(int j = 0; j<=i; j++){
            if(i==1){
                dp1[i][j]=1;
                continue;
            }
            if(j==0){
                dp1[i][j]=0;
                continue;
            }

           dp1[i][j]=dp1[i-1][j]+dp1[i-1][j-1];
        }
    }
    for(int i = 1; i<=n; i++){
        for(int j = 0; j<=i; j++){
            if(i==1){
                dp[i][j]=(j==i)*(i+1);
                continue;
            }
            for(int k = 1; k<=j; k++){
                dp[i][j]+=dp[i-1][k]+dp1[i-1][k-1];
            }
        }
    }
    ll ans = 0;
    for(int i = 1; i<=n; i++){
        ans+=dp[n][i];
    }
    cout<<ans<<"\n";
}

signed main() {
#ifdef Local
    freopen("in.in", "r", stdin);
    freopen("out.out", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    ll t = 1;
    //cin>>t;
    while (t--) solve();
}