#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;
using ll = long long;
using ld = long double;

void solve() {
	string s;
	cin >> s;
	int n;
	cin >> n;
	map<char, int>x;
	for (int i = 0; i < 26; ++i) x['a' + i] = 0 ;
	for (int i = 0; i < n; ++i) {
		char c;
		int cnt;
		cin >> c >> cnt;
		x[c] = cnt;
	}
	map<char, int>used;
	ll ans = 0;
	for (int i = 0; i < s.size(); ++i) {
		if (x[s[i]] != 0) {
			++used[s[i]];
		}
		else {
			++ans;
		}
	}
	//cout << ans << "\n";
	for (auto [a, b] : used) {
		//cout << a << ' ' << b << "\n";
		ans += (b - 1) / (x[a] - 1) + 1 + b;
	}
	cout << ans << "\n";
}

int main()
{
	int t = 1;
	//cin>>t;
	while (t--) solve();
}
