#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pp = pair<ll, ll>;

template<typename t>
istream &operator>>(istream &din, vector<t> &a) {
    for (t &e : a) {
        din >> e;
    }
    return din;
}

const ll mod = 1'000'000'007;

ll qmpaw(ll a, ll n) {
    if (n == 0) return 1;
    ll tmp = qmpaw(a, n >> 1);
    tmp *= tmp;
    tmp %= mod;
    tmp *= (n & 1 ? a : 1);
    tmp %= mod;
    return tmp;
}

struct unit {
  ll v, points, counter;
  unit(ll v, ll points, ll counter) : v(v), points(points), counter(counter) {}
};

void dfs(const vector<vector<ll>> &g, vector<bool> &used, vector<ll> &depth, ll v) {
    if (used[v]) return;
    used[v] = true;
    if (g[v].size() == 0) depth[v] = 0;
    for (ll u : g[v]) {
        dfs(g, used, depth, u);
        depth[v] = min(depth[v], depth[u] + 1);
    }
}

signed main() {
    ll n;
    cin >> n;
    vector<ll> p(n);
    for (ll i = 1; i < n; i++) {
        cin >> p[i];
    }
    vector<vector<ll>> g(n);
    for (ll i = 1; i < n; i++) {
        g[p[i] - 1].push_back(i);
    }
    vector<bool> used(n);
    vector<ll> depth(n, 1'000'000'000'000);
    dfs(g, used, depth, 0);
    deque<unit> d(1, {0, 0, 0});
    ll ans = 0;
    while (!d.empty()) {
        unit pos = d.back();
        d.pop_back();
        if (pos.counter == 0) {
            pos.counter = depth[pos.v];
            pos.points += depth[pos.v] != 0;
        }
        for (ll u : g[pos.v]) {
            d.emplace_front(u, pos.points, pos.counter - 1);
        }
        ans = max(ans, pos.points);
    }
    cout << ans;
}
//ඞ
