#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<string>
#include<set>
#include<map>


using namespace std;
#define int long long
#define all(a) a.begin(), a.end()
const int MOD = 1e9 + 7;
int MAXN = 5001;

vector<vector<int>> C(MAXN, vector<int>(MAXN, 0));

void calc() {
	C[0][0] = 1;
	for (int i = 1; i < MAXN; ++i) {
		C[i][0] = 1;
		//cout << C[i][0] << " ";
		for (int j = 1; j <= i; ++j) {
			C[i][j] = C[i - 1][j] + C[i - 1][j - 1];
			//C[i][j] %= MOD;
			//cout << C[i][j] << " ";
		}
		//cout << "\n";
	}
}

int f(int k, int n) {
	return C[n][k];
}

void solve() {
	// UP MAXN
	int n;
	cin >> n;
	calc();
	vector<int> dp(n + 1);
	dp[0] = 1;
	dp[1] = 1;
	dp[2] = 1;
	for (int i = 3; i <= n; ++i) {
		int m = (i - 1) - (i + 1) / 2;
		int ans = 0;
		for (int j = 0; j <= m; ++j) {
			ans += f(j + 1, i - 1);
			ans %= MOD;
		}
		dp[i] = dp[i - 1] * ans;
		dp[i] %= MOD;
	}
	cout << dp[n];
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _DEBUG

	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}