#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<string>
#include<set>
#include<map>


using namespace std;
#define int unsigned long long
#define all(a) a.begin(), a.end()
const int MOD = 1e9 + 7;
int binpow(int a, int n) {
	if (n == 0) {
		return 1;
	}
	if (n == 1) {
		return a % MOD;
	}
	if (n % 2) {
		int x = binpow(a, n / 2);
		return (((a * x) % MOD) * x) % MOD;
	}
	int x = binpow(a, n / 2);
	return (x * x) % MOD;
}
void solve() {
	int n;
	cin >> n;
	vector<int> v(n);
	vector<int> fact(n+2);
	fact[0] = 1;
	fact[1] = 1;
	for (int i = 2; i < n+2; ++i) {
		fact[i] = fact[i - 1] * i;
		fact[i] %= MOD;
	}
	vector<int> k(3, 0);
	for (int i = 0; i < n; ++i) {
		cin >> v[i];
		k[v[i] % 3]++;
	}
	int a1 = k[1];
	int a2 = k[2];
	if (a1 < a2) {
		swap(a1, a2);
	}
	if (a1 - a2 == 1 || a1 - a2 == 2) {
		int ans = fact[k[1]] * fact[k[2]];
		ans %= MOD;
		ans *= fact[n - 1];
		ans %= MOD;
		ans*= binpow(fact[k[1] + k[2] - 1], MOD - (int)2);
		ans %= MOD;
		cout << ans;
	}
	else cout << 0;
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _DEBUG

	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}