#include<bits/stdc++.h>
#define int long long

using namespace std;

const int M = 1000000000 + 7, N = 2e5 + 10;

int fact[N];

int powa(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int x = powa(a, n / 2);
        return (x * x) % M;
    }
    return (a * powa(a, n - 1)) % M;
}

int divv(int a, int b) {
    return (a * powa(b, M - 2)) % M;
}

int C(int n, int k) {
    return divv(fact[n], fact[k] * fact[n - k] % M);
}

signed main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    fact[0] = 1;
    for (int i = 1; i < N; ++i) {
        fact[i] = (fact[i - 1] * i) % M;
    }
    int n;
    cin >> n;
    int r0 = 0, r1 = 0, r2 = 0;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x % 3 == 0) ++r0;
        if (x % 3 == 1) ++r1;
        if (x % 3 == 2) ++r2;
    }
    int ans = 0;
    int q1 = r1, q2 = r2, q0 = r0;
    if (q1 > 0) {
        --q1;
        if (q1 - 1 == q2 || q1 == q2) {
            int N = q1 + q2;
            int K = q0;
            int r = fact[q1] * fact[q2] % M;
            r *= divv(fact[N + K], fact[N]);
            r %= M;
            r *= r1;
            r %= M;
            ans += r;
        }
    }
    q1 = r1, q2 = r2, q0 = r0;
    if (q2 > 0) {
        --q2;
        if (q2 - 1 == q1 || q2 == q1) {
            int N = q1 + q2;
            int K = q0;
            int r = fact[q1] * fact[q2] % M;
            r *= divv(fact[N + K], fact[N]);
            r %= M;
            r *= r2;
            r %= M;
            ans += r;
            ans %= M;
        }
    }
    cout << ans << '\n';
}