#include<bits/stdc++.h>

using namespace std;

struct node{
    int prefB, sufB, B, cntA, cntB, cnt;
};

const int N = 1e5 + 10;

string s;

node t[4 * N];

void merg(node &a, node b, node c) {
    a.cnt = b.cnt + c.cnt;
    a.prefB = b.prefB;
    if (a.prefB == b.cnt) {
        a.prefB += c.prefB;
    }
    a.sufB = c.sufB;
    if (a.sufB == c.cnt) {
        a.sufB += b.sufB;
    }

    a.B = max(b.B, c.B);
    a.B = max(a.B, b.sufB + b.prefB);
    a.cntA = b.cntA + c.cntA;
    a.cntB = b.cntB + c.cntB;
}

void build(int v, int l, int r) {
    if (l + 1 == r) {
        t[v].cnt = 1;
        if (s[l] == 'a') {
            t[v].B = t[v].sufB = t[v].prefB = 0;
            t[v].cntA = 1;
        }
        else {
            t[v].B = t[v].sufB = t[v].prefB = 1;
            t[v].cntB = 1;
        }
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    merg(t[v], t[2 * v + 1], t[2 * v + 2]);
}

void upd(int v, int l, int r, int qi) {
    if (l + 1 == r) {
        if (s[l] == 'a') {
            s[l] = 'b';
        }
        else {
            s[l] = 'a';
        }
        if (s[l] == 'a') {
            t[v].B = t[v].sufB = t[v].prefB = 0;
            t[v].cntA = 1;
            t[v].cntB = 0;
        }
        else {
            t[v].B = t[v].sufB = t[v].prefB = 1;
            t[v].cntA = 0;
            t[v].cntB = 1;
        }
        return;
    }
    int m = (l + r) / 2;
    if (qi < m) {
        upd(2 * v + 1, l, m, qi);
    }
    else {
        upd(2 * v + 2, m, r, qi);
    }
    merg(t[v], t[2 * v + 1], t[2 * v + 2]);
}

node nut;

node get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return t[v];
    }
    if (ql >= r || qr <= l) {
        return nut;
    }
    int m = (l + r) / 2;
    node r1 = get(2 * v + 1, l, m, ql, qr);
    node r2 = get(2 * v + 2, m, r, ql, qr);
    node r3;
    merg(r3, r1, r2);
    return r3;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    cin >> s;
    build(0, 0, n);
    int q;
    cin >> q;
    while (q--) {
        int op;
        cin >> op;
        if (op == 1) {
            int i;
            cin >> i;
            --i;
            upd(0, 0, n, i);
        }
        else {
            int l, r;
            cin >> l >> r;
            --l;
            node r1 = get(0, 0, n, l, r);
            if (r1.B >= 3 || r1.prefB >= 2 || r1.sufB >= 2 || r1.cntB > r1.cntA) {
                cout << "NO" << '\n';
            }
            else {
                cout << "YES" << '\n';
            }
        }
    }
}