#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
//#define int ll;

struct Node{
    int closest;
    set<int> layer;
};

const int N = 2e5 + 10;
vector<int> dp(N);


auto dfs(int v, vector<int>& p, vector<vector<int>>& g){
    if(g[v].empty()){
        dp[v] = 1;
        Node* ret;
        ret->closest = 0;
        ret->layer.insert(v);
        return ret;
    }

    vector<Node*> kids;
    int mn = 1e9;
    for(auto to : g[v]){
        kids.push_back(dfs(to, p, g));
        kids.back()->closest++;
        mn = min(mn, kids.back()->closest);
    }

    set<int> big_set;
    int sz = 0, ind = -1;
    vector<set<int>> sets(kids.size());
    for(int i = 0; i < kids.size();i++){
        int to = g[v][i];
        if(kids[i]->closest == mn){
            dp[v] = max(dp[v], dp[to] + 1);
            if(kids[i]->layer.size() > sz) {
                sz = kids[i]->layer.size();
                ind = i;
            }
        }
        else{
            int mx = 0;
            for(auto v1 : kids[i]->layer){
                int u = v1;
                for(int j = 0; j < kids[i]->closest - mn; j++){
                    u = p[u];
                }
                mx = max(mx, dp[u]);
                sets[i].insert(u);
            }
            if(sets[i].size() > sz){
                sz = sets[i].size();
                ind = i;
            }
            dp[v] = max(dp[v], mx + 1);
        }
    }

    if(!sets[ind].empty() )
        kids[ind]->layer = sets[ind];
    for(int i = 0; i < kids.size(); i++){
        if(i == ind)
            continue;
        if(i != ind){
            if(!sets.empty())
                kids[i]->layer = sets[i];
            for(auto j : kids[i]->layer)
                kids[ind]->layer.insert(j);
        }
    }
    return kids[ind];
}



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;

    vector<int> p(n);
    vector<vector<int>> g(n);
    for(int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    dfs(0,p,g);
    cout<<dp[0];


}
