#include <bits/stdc++.h>
using namespace std;
#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define eb emplace_back
#define pb push_back

bool check(vector<vector<int>> &a, int n) {
    vector<int> sum1(n), sum2(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            sum1[i] += a[i][j];
            sum2[j] += a[i][j];
        }
    }
    sort(all(sum1));
    sort(all(sum2));
    return sum1.front() == sum1.back() && sum2.front() == sum2.back() && sum1.front() == sum2.front();
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int> (n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }
    if (check(a, n)) {
        cout << "1 1\n1 1\n";
        return;
    }
    vector<int> sum1(n), sum2(n);
    for (int i = 0; i < n; i++)  {
        for (int j = 0; j < n; j++) {
            sum1[i] += a[i][j];
            sum2[j] += a[i][j];
        }
    }
    int res = (1 + n * n) * n * n / (2 * n);
    vector<int> wx, wy;
    for (int i = 0; i < n; i++) {
        if (sum1[i] != res) {
            wx.eb(i);
        }
        if (sum2[i] != res) {
            wy.eb(i);
        }
    }
    if (wy.empty()) {
        int f = wx[0];
        int s = wx[1];
        for (int i = 0; i < n; i++) {
            if (sum1[f] - a[f][i] + a[s][i] == res) {
                cout << f + 1 << " " << i + 1 << '\n' << s + 1 << " " << i + 1 << '\n';
                return;
            }
        }
        swap(f, s);
        for (int i = 0; i < n; i++) {
            if (sum1[f] - a[f][i] + a[s][i] == res) {
                cout << f + 1 << " " << i + 1 << '\n' << s + 1 << " " << i + 1 << '\n';
                return;
            }
        }
    }
    if (wx.empty()){
        int f = wy[0];
        int s = wy[1];
        for (int i = 0; i < n; i++) {
            if (sum2[f] - a[i][f] + a[i][s] == res) {
                cout << i + 1 << " " << s + 1 << '\n' << i + 1 << " " << f + 1 << '\n';
                return;
            }
        }
        swap(f, s);
        for (int i = 0; i < n; i++) {
            if (sum2[f] - a[i][f] + a[i][s] == res) {
                cout << i + 1 << " " << s + 1 << '\n' << i + 1 << " " << f + 1 << '\n';
                return;
            }
        }
    }
    vector<pair<int, int>> wr;
    for (auto i : wx) {
        for (auto j : wy) {
            wr.eb(i, j);
        }
    }
    for (auto [i, j] : wr) {
        for (auto [x, y] : wr) {
            swap(a[i][j], a[x][y]);
            if (check(a, n)) {
                cout << i + 1 << " " << j + 1 << '\n';
                cout << x + 1 << " " << y + 1 << '\n';
                return;
            }
            swap(a[i][j], a[x][y]);
        }
    }
    exit(-1);
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    int T = 1;
    //cin >> T;
    while (T--)
        solve();
    return 0;
}