#include <bits/stdc++.h>
using namespace std;

const int MOD = 1e9 + 7;

int inverse(int x) {
    int ans = 1;
    for (int base = x, p = MOD - 2; p > 0; p /= 2, base = 1LL * base * base % MOD) {
        if (p & 1) {
            ans = 1LL * ans * base % MOD;
        }
    }
    return ans;
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> c(3);
    for (int &v : a) {
        cin >> v;
        c[v % 3]++;
    }
    vector<int> fact(2 * n + 1, 1);
    for (int i = 1; i <= 2 * n; i++) {
        fact[i] = 1LL * fact[i - 1] * i % MOD;
    }
    auto S = [&](int n, int k) {
        if (n < 0) {
            return 0;
        }
        return int(1LL * fact[n + k] * inverse(fact[n]) % MOD * inverse(fact[k]) % MOD);
    };
    int ans = 0;
    for (int s = 1; s < 3; s++) {
        int val = s;
        vector<int> cur_c(3);
        cur_c[s]++;
        for (int i = 0; i < n - 1 - c[0]; i++) {
            if ((val + 1) % 3 != 0) {
                cur_c[1]++;
                val++;
            } else if ((val + 2) % 3 != 0) {
                cur_c[2]++;
                val += 2;
            }
        }
        cur_c[0] = c[0];
        // 2 1 0 2
        if (c == cur_c) {
            int res = S(c[1] + c[2] - 1, c[0]);
            res = 1LL * res * fact[c[0]] % MOD;
            res = 1LL * res * fact[c[1]] % MOD;
            res = 1LL * res * fact[c[2]] % MOD;
            ans = (ans + res) % MOD;
        }
    }
    cout << ans << "\n";
}
