#include <bits/stdc++.h>

#define int int64_t
#define pb push_back
#define fi first
#define se second

using namespace std;

const int INF = 2e18, N = 1e3 + 50;

int a[N][N], n;

bool good () {
    set <int> st;
    for (int i = 0; i < n; ++i) {
        int s1 = 0;
        for (int j = 0; j < n; ++j) {
            s1 += a[i][j];
        }
        st.insert(s1);
    }
    for (int j = 0; j < n; ++j) {
        int s1 = 0;
        for (int i = 0; i < n; ++i) {
            s1 += a[i][j];
        }
        st.insert(s1);
    }
    return (st.size() == 1);
}

void solve1 () {
    for (int x = 0; x < n; ++x) {
        for (int y = 0; y < n; ++y) {
            for (int x1 = 0; x1 < n; ++x1) {
                for (int y1 = 0; y1 < n; ++y1) {
                    if (x == x1 && y == y1) {
                        continue;
                    }
                    swap(a[x][y], a[x1][y1]);
                    if (good()) {
                        cout << x + 1 << ' ' << y + 1 << endl;
                        cout << x1 + 1 << ' ' << y1 + 1 << endl;
                        exit(0);
                    }
                    swap(a[x][y], a[x1][y1]);
                }
            }
        }
    }

}

void solve2 () {
    vector <pair <int, int>> v1;
    for (int i = 0; i < n; ++i) {
        int s1 = 0;
        for (int j = 0; j < n; ++j) {
            s1 += a[i][j];
        }
        v1.pb({s1, i});
    }
    vector <pair <int, int>> v2;
    for (int j = 0; j < n; ++j) {
        int s1 = 0;
        for (int i = 0; i < n; ++i) {
            s1 += a[i][j];
        }
        v2.pb({s1, j});
    }
    map <int, int> mp;
    for (auto to : v1) {
        mp[to.fi]++;
    }
    for (auto to : v2) {
        mp[to.fi]++;
    }
    int need = v1[0].fi;
    for (auto to : mp) {
        if (mp[to.fi] > mp[need]) {
            need = to.fi;
        }
    }
    vector <int> a1;
    for (auto to : v1) {
        if (to.fi != need) {
            a1.pb(to.se);
        }
    }
    vector <int> a2;
    for (auto to : v2) {
        if (to.fi != need) {
            a2.pb(to.se);
        }
    }
    for (auto x1 : a1) {
        for (auto x2 : a1) {
            for (auto y1 : a2) {
                for (auto y2 : a2) {
                    if (x1 == x2 && y1 == y2) {
                        continue;
                    }
                    swap(a[x1][y1], a[x2][y2]);
                    if (good()) {
                        cout << x1 + 1 << ' ' << y1 + 1 << endl;
                        cout << x2 + 1 << ' ' << y2 + 1 << endl;
                        exit(0);
                    }
                    swap(a[x1][y1], a[x2][y2]);

                }
            }
        }
    }
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }
    if (n < 10) {
        solve1();
    } else {
        solve2();
    }
}
