#include <bits/stdc++.h>

#define int long long
using namespace std;

const int N = 1e5, mod = 1e9 + 7;
const long long NN = 1e6;

inline void smod(int &a, int b) {a = a + b >= mod ? a + b - mod : a + b;}

int a[N], c[3];
long long f[NN];

long long ans = 0;

long long fastpow(long long a, long long b) {
    if (b == 0)
        return 1;
    long long x = fastpow(a, b / 2);
    if (b % 2 == 0)
        return x * x % mod;
    return x * x % mod * a % mod;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i] %= 3;
        c[a[i]] ++;
    }

    //    cout << c[0] << ' ' << c[1] << ' ' << c[2] << '\n';

    int m = c[1] + c[2];
    if (c[1] == c[2] || c[2] == c[1] + 1) {
        ans = f[m + c[0] - 1] * f[c[0]] % mod * fastpow(f[c[0]], mod - 2) % mod * fastpow(f[m - 1], mod - 2) % mod * f[c[1]] % mod * f[c[2]] % mod;
    } else if (c[1] > c[2] && c[1] - c[2] <= 2) {
        ans = f[m + c[0] - 1] * f[c[0]] % mod * fastpow(f[c[0]], mod - 2) % mod * fastpow(f[m - 1], mod - 2) % mod * f[c[1]] % mod * f[c[2]] % mod;
    }

    cout << ans;
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    f[0] = 1;
    for (int i = 1; i < NN; i ++)
        f[i] = f[i - 1] * i % mod;
    solve();

    return 0;
}
