#include <bits/stdc++.h>
using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

// ARGHHHHHHHHHHHHHHHH
//#define int long long
// ARGHHHHHHHHHHHHHHHH

int32_t main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	int n;
	cin >> n;

	vector<vector<ll>> v(n, vector<ll>(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cin >> v[i][j];
		}
	}

	vector<pair<int, int>> pos;

	ll rl;
	map<ll, ll> cnt;
	for (int i = 0; i < n; i++) {
		ll t = 0;
		for (int j = 0; j < n; j++) {
			t += v[i][j];
		}
		cnt[t]++;
	}
	for (int j = 0; j < n; j++) {
		ll t = 0;
		for (int i = 0; i < n; i++) {
			t += v[i][j];
		}
		cnt[t]++;
	}
	ll mxb = -1;
	for (auto [a, b] : cnt) {
		if (b >= mxb) {
			rl = a;
			mxb = b;
		}
	}

	if (n <= 10) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				pos.emplace_back(i, j);
			}
		}
	} else {
		vector<int> h1, h2;
		for (int i = 0; i < n; i++) {
			ll t = 0;
			for (int j = 0; j < n; j++) {
				t += v[i][j];
			}
			if (t != rl) {
				h1.push_back(i);
			}
		}
		for (int j = 0; j < n; j++) {
			ll t = 0;
			for (int i = 0; i < n; i++) {
				t += v[i][j];
			}
			if (t != rl) {
				h2.push_back(j);
			}
		}

		if (h1.empty()) {
			for (int i = 0; i < n; i++) {
				h1.push_back(i);
			}
		}
		if (h2.empty()) {
			for (int j = 0; j < n; j++) {
				h2.push_back(j);
			}
		}

		for (int i : h1) {
			for (int j : h2) {
				pos.emplace_back(i, j);
			}
		}
	}

	vector<ll> sumi(n), sumj(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			sumi[i] += v[i][j];
		}
	}
	for (int j = 0; j < n; j++) {
		for (int i = 0; i < n; i++) {
			sumj[j] += v[i][j];
		}
	}

	auto check_stupid = [&](int i, int j) {
		swap(v[pos[i].first][pos[i].second], v[pos[j].first][pos[j].second]);
		set<ll> s;
		for (int i = 0; i < n; i++) {
			ll t = 0;
			for (int j = 0; j < n; j++) {
				t += v[i][j];
			}
			s.insert(t);
		}
		for (int j = 0; j < n; j++) {
			ll t = 0;
			for (int i = 0; i < n; i++) {
				t += v[i][j];
			}
			s.insert(t);
		}
		swap(v[pos[i].first][pos[i].second], v[pos[j].first][pos[j].second]);
		if (s.size() == 1) return true;
		return false;
	};

	auto check = [&](int i, int j) {
		auto [i1, j1] = pos[i];
		auto [i2, j2] = pos[j];
		sumi[i1] -= v[i1][j1];
		sumi[i2] -= v[i2][j2];
		sumj[j1] -= v[i1][j1];
		sumj[j2] -= v[i2][j2];

		bool good = false;
		ll a = sumi[i1] + v[i2][j2], b = sumi[i2] + v[i1][j1], c = sumj[j1] + v[i2][j2], d = sumj[j2] + v[i1][j1];
		if (a == b && b == c && c == d && d == rl) good = true;
//		if (sumi[i1] + v[i2][j2] == sumi[i2] + v[i1][j1] && sumj[j1] + v[i2][j2] == sumj[j2] + v[i1][j1]) good = true;

		sumi[i1] += v[i1][j1];
		sumi[i2] += v[i2][j2];
		sumj[j1] += v[i1][j1];
		sumj[j2] += v[i2][j2];

		return good;
	};

	for (int i = 0; i < pos.size(); i++) {
		for (int j = i + 1; j < pos.size(); j++) {
			if (n <= 10) {
				if (check_stupid(i, j)) {
					cout << pos[i].first + 1 << " " << pos[i].second + 1 << "\n";
					cout << pos[j].first + 1 << " " << pos[j].second + 1 << "\n";
					return 0;
				}
			} else {
				if (check(i, j)) {
					cout << pos[i].first + 1 << " " << pos[i].second + 1 << "\n";
					cout << pos[j].first + 1 << " " << pos[j].second + 1 << "\n";
					return 0;
				}
			}
		}
	}

	assert(false);

	return 0;
}