#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int n;
vector<vector<int>> g;
vector<int> h, minh, dp, sz, mxd;

deque<int> dfs(int v) {
    sz[v] = 1;
    if (g[v].empty()) {
        minh[v] = 0;
        dp[v] = 1;
        mxd[v] = 0;
        return {1};
    }
    vector<pair<int, deque<int>>> vv;
    for (int u : g[v]) {
        h[u] = h[v] + 1;
        auto d = dfs(u);
        sz[v] += sz[u];
        minh[v] = min(minh[v], minh[u] + 1);
        mxd[v] = max(mxd[v], mxd[u] + 1);
        vv.emplace_back(-sz[u], d);
    }
    sort(vv.begin(), vv.end());
    deque<int> d = {0};
    swap(d, vv[0].second);
    d.push_front(0);
    for (int i = 1; i < vv.size(); i++) {
        for (int x = 0; x < vv[i].second.size(); x++) {
            if (d.size() > x + 1) d[x + 1] = max(d[x + 1], vv[i].second[x]);
            else d.push_back(vv[i].second[x]);
        }
    }
    if (mxd[v] == minh[v]) dp[v] = 1;
    else dp[v] = 1 + d[minh[v]];
    d[0] = dp[v];
//    cout << "DFS " << v << "  ";
//    for (int x : d) cout << x << " ";
//    cout << endl;
    return d;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    g.resize(n);
    h.resize(n, 0);
    minh.resize(n, 1e9);
    dp.resize(n, -1);
    sz.resize(n, 0);
    mxd.resize(n, -1);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        g[p - 1].push_back(i);
    }

    dfs(0);
    cout << dp[0];
}
