#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int __int128
typedef long long ll;

const int INF = (int)(1e18) + 42;

map<int, int> mem;

int ask(ll d) {
    if (mem.count(d))
        return mem[d];

    cout << "? " << d << endl;
    ll res;
    cin >> res;
    mem[d] = res;
    return res;
}

void answer(ll x, ll b) {
    cout << "! " << x << " " << b << endl;
}

int qpow(int a, int n) {
    if (a == 0)
        return 0;
    if (n == 0)
        return 1;

    if (a > INF / a)
        return INF;

    if (n % 2 == 0)
        return qpow(a * a, n / 2);

    int res = qpow(a * a, n / 2);
    if (res > INF / a)
        return INF;
    return a * res;
}

int my_sqrt(int a, int n) {
    int l = 0, r = a + 1;

    while (r - l > 1) {
        int m = (l + r) / 2;

        int res = qpow(m, n - 1);
        if (m - 1 != 0 && res > INF / (m - 1))
            res = INF;
        else
            res *= m - 1;

        if (res <= a)
            l = m;
        else
            r = m;
    }
    return l;
}

void solve() {
    ll n;
    cin >> n;

    int l = 0, r = (1ll << 40); // 43
    while (r - l > 1) {
        int m = (l + r) / 2;

        //cout << "! " << l << " " << r << endl;

        if (ask(m) == n)
            l = m;
        else
            r = m;
    }

    int l1 = 0, r1 = (1ll << 60); // 53
    while (r1 - l1 > 1) {
        int m = (l1 + r1) / 2;

        //cout << "!! " << l1 << " " << r1 << endl;

        if (ask(m) <= n + 1)
            l1 = m;
        else
            r1 = m;
    }

    int d = r1 - r;
    int p = n + 1;
    int b = my_sqrt(d, p);
    int x = qpow(b, n) - r;

    answer(x, b);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}