#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(v) (int)v.size()
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef pair<int, int> pii;

const int MOD = 1e9 + 7;

void solve() {
    int n;
    cin >> n;

    vector<vector<int>> dp1(n + 1, vector<int>(n + 1));
    for (int i = 1; i <= n; ++i)
        dp1[1][i] = 1;
    dp1[0][0] = 1;
    for (int i = 2; i <= n; ++i)
        for (int j = i; j <= n; ++j)
            for (int t = j - i; t > -1; t -= i)
                    dp1[i][j] = (dp1[i][j] + dp1[i - 1][t]) % MOD;
    /*
    for (auto i :dp1) {
        for (auto j : i)
            cout << j << " " ;
        cout << endl;
    }
    */
    vector<vector<int>> dp2(n + 1, vector<int>(n + 1));
    dp2[n][n] = 1;
    for (int i = 0; i <= n; ++i)
        dp2[i][0] = 1;
    for (int i = n - 1; i > 0; --i)
        for (int j = 1; j <= n; ++j)
            for (int t = j; t > -1; t -= i)
                dp2[i][j] = (dp2[i][j] + dp2[i + 1][t]) % MOD;
    /*
    for (auto i :dp2) {
        for (auto j : i)
            cout << j << " " ;
        cout << endl;
    }
    */
    int ans = 0;
    for (int i = 1; i <= n + 1; ++i) {
        for (int j = 0; j <= n; ++j)
            ans = (ans + (dp1[i - 1][j] * (i + 1 <= n ? dp2[i + 1][n - j] : (n - j == 0)) % MOD) * i % MOD) % MOD;

        //cout << "! " << ans << endl;
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}