#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(v) (int)v.size()
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef pair<int, int> pii;

int ask(int i, int x, int y) {
    cout << "? " << i + 1 << " " << char(x + 'a') << char(y + 'a') << endl;
    int res;
    cin >> res;
    return res;
}

void answer(const vector<int>& a) {
    cout << "! ";
    for (auto i : a)
        cout << char(i + 'a');
    cout << endl;
}

vector<int> get3(int i) {
    vector<int> sc(3);
    sc[0] = ask(i, 0, 0);
    sc[1] = ask(i, 1, 1);
    sc[2] = 2 - sc[0] - sc[1];

    int it = 0;
    while (sc[it] == 0)
        ++it;

    vector<int> ans(3);

    if (sc[it] == 2) {
        ans[0] = it;
        ans[1] = it;

        vector<int> sc2(3);
        sc2[0] = ask(i + 1, it, 0);
        sc2[1] = ask(i + 1, it, 1);
        sc2[2] = 4 - sc2[0] - sc2[1];

        int jt = 0;
        while (sc2[jt] != 2)
            ++jt;

        ans[2] = jt;

        return ans;
    } else {
        vector<int> sc2(3);
        sc2[0] = ask(i + 1, it, 0);
        sc2[1] = ask(i + 1, it, 1);

        if (min(sc2[0], sc2[1]) == 0) {
            ans[0] = it;

            --sc[it];

            it = 0;
            while (sc[it] == 0)
                ++it;
            ans[1] = it;

            sc2[2] = 1 - sc2[0] - sc2[1];
            it = 0;
            while (sc2[it] != 1)
                ++it;
            ans[2] = it;

            return ans;
        } else {
            ans[1] = it;

            --sc[it];

            it = 0;
            while (sc[it] == 0)
                ++it;
            ans[0] = it;

            sc2[2] = 4 - sc2[0] - sc2[1];
            it = 0;
            while (sc2[it] != 2)
                ++it;
            ans[2] = it;

            return ans;
        }
    }
}

void solve() {
    int n;
    cin >> n;

    vector<int> ans(n, -1);
    for (int i = 0; i + 3 <= n; i += 3) {
        auto t = get3(i);
        for (int j = 0; j < 3; ++j)
            ans[i + j] = t[j];
    }
    if (n % 3 != 0) {
        int i = n - 3;
        auto t = get3(i);
        for (int j = 0; j < 3; ++j)
            ans[i + j] = t[j];
    }

    answer(ans);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}