#include <bits/stdc++.h>

#define ll long long
#define int long long
#define F first
#define S second
using namespace std;
const int mod = 1e9 + 7;

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> dp(n + 1, vector<int>(n + 1, 0));
    dp[1][1] = 1;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= i; ++j) {
            dp[i][j] += dp[i - j][j] + dp[i - j][j - 1];
            dp[i][j] %= mod;
        }
    }
    vector<vector<int>> dpsuf(n + 1, vector<int>(n + 1, 0));
    vector<vector<int>> pref(n + 1, vector<int>(n + 2, 0));
    for (int i = 1; i <= n; ++i) {
        dpsuf[i][i] = 1;
        for (int j = 1; j <= i; ++j) {
            if (i - j >= j) {
                dpsuf[i][j] += (pref[i - j][i - j] - pref[i - j][j - 1] + mod) % mod;
                dpsuf[i][j] %= mod;
            }
        }
        for (int j = 1; j < n + 1; ++j) {
            pref[i][j] = (pref[i][j - 1] + dpsuf[i][j]) % mod;
        }
    }
    if (n == 1) {
        cout << 2;
        return 0;
    }
    int ans = 0;
    ans += dp[n][n - 1] * n % mod;
    ans %= mod;
    for (int i = 2; i <= n; ++i) {
        ans += dpsuf[n][i];
        ans %= mod;
    }
    for (int mex = 2; mex <= n - 1; ++mex) {
        for (int sum1 = 0; sum1 <= n; ++sum1) {
            int sum2 = n - sum1;
            int sumdp = 0;
            if (sum2 == 0) {
                sumdp = 1;
            } else {
                sumdp = (pref[sum2][n] - pref[sum2][mex] + mod) % mod;
                sumdp %= mod;
            }
            ans += (dp[sum1][mex - 1] * sumdp % mod) * mex % mod;
            ans %= mod;
        }
    }
    cout << ans;
    return 0;
}