#include <bits/stdc++.h>
using namespace std;
#define int long long
const int inf = 1e18;

vector<int> ver, hor;
vector<vector<int>> a;
int res;

void f() {
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            ver[j] += a[i][j];
            hor[i] += a[i][j];
        }
    }
}

bool ok(int i1, int j1, int i2, int j2) {
    if (i1 == i2) {
        return (ver[j1] - a[i1][j1] + a[i2][j2] == res) && (ver[j2] - a[i2][j2] + a[i1][j1] == res);
    }
    if (j1 == j2) {
        return (hor[i1] - a[i1][j1] + a[i2][j2] == res) && (hor[i2] - a[i2][j2] + a[i1][j1] == res);
    }
    return (ver[j1] - a[i1][j1] + a[i2][j2] == res) && (hor[i1] - a[i1][j1] + a[i2][j2] == res) &&
    (ver[j2] - a[i2][j2] + a[i1][j1] == res) && (hor[i2] - a[i2][j2] + a[i1][j1] == res);
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n; cin >> n;
    a.resize(n, vector<int> (n));
    hor.resize(n);
    ver.resize(n);
    map<int, pair<int, int>> cc;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
            cc[a[i][j]] = {i, j};
        }
    }
    f();
    res = n*n*(n*n + 1) / 2;
    res /= n;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (hor[i] == res && ver[j] == res) continue;
            int tmp = res - hor[i] + a[i][j];
            if (tmp == a[i][j]) tmp = res - ver[j] + a[i][j];
            if (cc.find(tmp) == cc.end()) continue;
            if (ok(i, j, cc[tmp].first, cc[tmp].second)) {
                cout << i + 1 << ' ' << j + 1 << '\n';
                cout << cc[tmp].first + 1 << ' ' << cc[tmp].second + 1 << '\n';
                return 0;
            }
        }
    }
    return 0;
}
