#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
using ll = long long;

const int mod = 1e9 + 7;

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	int n;
	cin >> n;
	vector<vector<int>> dp(n, vector<int>(n + 1, 0));
	dp[0][0] = 1;
	for (int x = 1; x < n; x++) {
		for (int y = 0; y <= min(2 * x, n); y++) {
			ll a = 0;
			if (y == 0) {
				a = 1;
			}
			else if (y == 1) {
				a = x;
			}
			else {
				a = (a + dp[x - 1][y] + dp[x - 1][y - 1] + dp[x - 1][y - 2]) % mod;
			}
			dp[x][y] = a;
		}
	}
	ll ans = 1;
	for (int x = 1; x < n; x++) {
		ans = (ans * dp[x][x + 1]) % mod;
	}
	cout << ans;
}