#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
#pragma GCC target("avx2")

using namespace std;

const int MAX_N = 2e5;

int to_list[MAX_N], high[MAX_N];
vector<int> g[MAX_N], dp(MAX_N, 0), border(MAX_N, 0);
vector<vector<int>> h[MAX_N];
set<pair<int, int>> se[MAX_N];

void get_tin(int v = 0, int now_h = 0) {
    high[v] = now_h;
    if (g[v].empty()) {
        to_list[v] = 0;
    } else {
        to_list[v] = 1e9;
    }
    for (int u : g[v]) {
        get_tin(u, now_h + 1);
        to_list[v] = min(to_list[v], to_list[u] + 1);
    }
}

void unite(int a, int b) {
    if (se[a].size() < se[b].size()) {
        swap(se[a], se[b]);
    }
    for (auto p : se[b]) {
        se[a].insert(p);
    }
}

void solve(int v = 0) {
    if (g[v].empty()) {
        dp[v] = 0;
        se[v] = {{high[v], 0}};
        return;
    }
    for (int u : g[v]) {
        solve(u);
        unite(v, u);
    }
    int need_dist = high[v] + to_list[v];
    auto it = se[v].lower_bound({need_dist, -1});
    for (; it != se[v].end(); it++) {
        if (it->first != need_dist) {
            break;
        }
        dp[v] = max(dp[v], it->second + 1);
    }
    se[v].insert({high[v], dp[v]});
}

signed main() {
    //freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, i, p, ans = 0;
    cin >> n;
    for (i = 1; i < n; i++) {
        cin >> p;
        g[p - 1].push_back(i);
    }
    dp[0] = 0;
    get_tin(), solve();
    for (i = 0; i < n; i++) {
        ans = max(ans, dp[i]);
    }
    cout << ans;
}
