#include <iostream>
#include<vector>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;
using vi = vector<ll>;

const int N = 1005;
ll a[N][N];
ll p[N];
ll v[N];

bool check(ll n) {
	for (ll i = 0; i < n; ++i) {
		p[i] = 0;
		v[i] = 0;
	}
	for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j)p[i] += a[i][j];
	for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j)v[i] += a[j][i];
	return (*max_element(p, p + n) == *min_element(p, p + n) &&
		*max_element(v, v + n) == *min_element(v, v + n) &&
		*max_element(p, p + n) == *max_element(v, v + n));
}

void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j) {
		cin >> a[i][j];
	}
	for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j)p[i] += a[i][j];
	for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j)v[i] += a[j][i];
	ll s = n * n * (n * n + 1) / 2;
	s /= n;
	vector<ll> pos, posv;
	for (int i = 0; i < n; ++i) {
		if (p[i] != s) {
			pos.push_back(i);
		}
		if (v[i] != s) {
			posv.push_back(i);
		}
	}
	if (pos.empty() && posv.empty()) {
		cout << "1 1\n1 1\n";
		return;
	}
	if (!pos.empty() && !posv.empty()) {
		int x = pos[0], y = pos[1], z = posv[0], t = posv[1];
		swap(a[x][z], a[y][t]);
		if (check(n)) {
			cout << x + 1 << ' ' << z + 1 << '\n' << y + 1 << ' ' << t + 1 << '\n';
			return;
		}
		swap(a[x][z], a[y][t]);
		for (ll i = 0; i < n; ++i) {
			p[i] = 0;
			v[i] = 0;
		}
		for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j)p[i] += a[i][j];
		for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j)v[i] += a[j][i];
		swap(a[x][t], a[y][z]);
		if (check(n)) {
			cout << x + 1 << ' ' << t + 1 << '\n' << y + 1 << ' ' << z + 1 << '\n';
			return;
		}
		swap(a[x][t], a[y][z]);
	}
	for (int i = 0; i < n; ++i) {
		p[i] = 0;
		v[i] = 0;
	}
	for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j)p[i] += a[i][j];
	for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j)v[i] += a[j][i];
	if (!pos.empty()) {
		int x = pos[0], y = pos[1];
		for (int i = 0; i < n; ++i) {
			if (p[x] - a[x][i] + a[y][i] == s && p[y] + a[x][i] - a[y][i] == s) {
				cout << x + 1 << ' ' << i + 1 << '\n' << y + 1 << ' ' << i + 1 << '\n';
				return;
			}
		}
	}
	if (!posv.empty()) {
		int x = posv[0], y = posv[1];
		for (int i = 0; i < n; ++i) {
			if (v[x] - a[i][x] + a[i][y] == s && v[y] + a[i][x] - a[i][y] == s) {
				cout << i + 1 << ' ' << x + 1 << '\n' << i + 1 << ' ' << y + 1 << '\n';
				return;
			}
		}
	}
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
