#include <bits/stdc++.h>

using namespace std;
#define int long long
using ll = long long;

const int N = 1e5 + 5;
const ll MOD = 1e9 + 7;

ll f[N];

void calc() {
    f[0] = 1;
    for (int i = 1; i < N; i++) f[i] = (f[i - 1] * i) % MOD;
}

ll binpow(ll n, ll p) {
    if (p == 0) return 1;
    if (p == 1) return n;
    if (p % 2 == 0) {
        ll tmp = binpow(n, p / 2);
        return (tmp * tmp) % MOD;
    }
    return (binpow(n, p - 1) * n) % MOD;
}

ll c(ll k, ll n) {
    return f[n] * binpow(f[k] * f[n - k] % MOD, MOD - 2) % MOD;
}

ll cplus(ll sh, ll p) {
    // cout << p - 1 << " " << sh + p - 1 << '\n';
    return c(p - 1, sh + p - 1);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    calc();
    int n;
    cin >> n;
    ll cnt0 = 0, cnt1 = 0, cnt2 = 0, a;
    for (int i = 0; i < n; i++) {
        cin >> a;
        if (a % 3 == 0) cnt0++;
        if (a % 3 == 1) cnt1++;
        if (a % 3 == 2) cnt2++;
    }

    if (abs(cnt1 - cnt2) > 2 || cnt1 + cnt2 == 0 || cnt1 == cnt2) {
        cout << 0;
        return 0;
    }

    // ll ans = (f[n - 1] * binpow(f[cnt1 + cnt2 - 1], MOD - 2)) % MOD;
    // cout << cnt0 << " " << cnt1 + cnt2 << '\n';
    ll ans = cplus(cnt0, cnt1 + cnt2);

    ans = (ans * f[cnt0] % MOD) % MOD;
    ans = (ans * f[cnt1] % MOD) % MOD;
    ans = (ans * f[cnt2] % MOD) % MOD;

    cout << ans << '\n';
}