#include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;

const int N = 5e5 + 5;
const int inf = 1e9;
const ll INF = 1e18;
const int mod = 1e9 + 7;

int f1[N], f2[N], n;
string s;

void add1(int pos, int x) {
    for (; pos <= n; pos += pos & -pos) {
        f1[pos] += x;
    }
}

int get1(int r) {
    int res = 0;
    for (; r > 0; r -= r & -r) {
        res += f1[r];
    }
    return res;
}

int get1(int l, int r) {
    return get1(r) - get1(l - 1);
}

void add2(int pos, int x) {
    for (; pos <= n; pos += pos & -pos) {
        f2[pos] += x;
    }
}

int get2(int r) {
    int res = 0;
    for (; r > 0; r -= r & -r) {
        res += f2[r];
    }
    return res;
}

int get2(int l, int r) {
    return get2(r) - get2(l - 1);
}

int f3[N];

void add3(int pos, int x) {
    for (; pos <= n; pos += pos & -pos) {
        f3[pos] += x;
    }
}

int get3(int r) {
    int res = 0;
    for (; r > 0; r -= r & -r) {
        res += f3[r];
    }
    return res;
}

int get3(int l, int r) {
    return get3(r) - get3(l - 1);
}


int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> s;
    s = "+" + s;

    for (int i = 1; i <= n - 2; i++) {
        if (s.substr(i, 3) == "bbb") add1(i, 1);
    }

    for (int i = 1; i <= n - 4; i++) {
        if (s.substr(i, 5) == "bbabb") add2(i, 1);
    }

    for (int i = 1; i < n; i++) {
        if (s[i] != s[i + 1]) add3(i, 1);
    }

    int q;
    cin >> q;

    while (q--) {
        int type;
        cin >> type;
        if (type == 2) {
            bool bad = false;
            int l, r;
            cin >> l >> r;
            if (r - l + 1 >= 3) bad |= get1(l, r - 2) != 0;
            if (r - l + 1 >= 5) bad |= get2(l, r - 4) != 0;
            if (r - l + 1 > 1) {
                bad |= s.substr(l, 2) == "bb";
                bad |= s.substr(r - 1, 2) == "bb";
            }
            if (r - l + 1 > 3) {
                bad |= s.substr(l, 4) == "babb";
                bad |= s.substr(r - 3, 4) == "bbab";
            }
            if (r - l + 1 == 3) {
                bad |= s.substr(l, 3) == "bab";
            }
            if (l == r) {
                bad |= s[l] == 'b';
            }

            if (l != r) {
                bad |= (get3(l, r - 1) == r - l) && s[l] == 'b' && s[r] == 'b';
            }

            cout << (bad ? "NO" : "YES") << "\n";
        } else {
            int pos;
            cin >> pos;

            for (int i = pos - 2; i <= pos; i++) {
                if (i < 1 || i + 2 > n) continue;
                if (s.substr(i, 3) == "bbb") add1(i, -1);
            }
            for (int i = pos - 4; i <= pos; i++) {
                if (i < 1 || i + 4 > n) continue;
                if (s.substr(i, 5) == "bbabb") add2(i, -1);
            }

            if (pos > 1 && s[pos - 1] != s[pos]) add3(pos - 1, -1);
            if (pos < n && s[pos] != s[pos + 1]) add3(pos, -1);

            if (s[pos] == 'a') s[pos] = 'b';
            else s[pos] = 'a';

            if (pos > 1 && s[pos - 1] != s[pos]) add3(pos - 1, +1);
            if (pos < n && s[pos] != s[pos + 1]) add3(pos, +1);

            for (int i = pos - 2; i <= pos; i++) {
                if (i < 1 || i + 2 > n) continue;
                if (s.substr(i, 3) == "bbb") add1(i, +1);
            }
            for (int i = pos - 4; i <= pos; i++) {
                if (i < 1 || i + 4 > n) continue;
                if (s.substr(i, 5) == "bbabb") add2(i, +1);
            }
        }
    }

    return 0;
}
