#include <bits/stdc++.h>

using i64 = long long;

std::vector<int> good;
std::map<std::vector<int>, std::string> mp;

void solve() {
    int n;
    std::cin >> n;
    if (!n) {
        exit(0);
    }
    auto ask = [&](int i, int x, int y) {
        std::cout << "? " << i + 1 << " " << char('a' + x) << char('a' + y) << std::endl;
        int p;
        std::cin >> p;
        return p;
    };
    auto get = [&](int i) {
        std::vector<int> W = {ask(i, good[0], good[1]), ask(i, good[2], good[3]), ask(i + 1, good[4], good[5]), ask(i + 1, good[6], good[7])};
        return mp[W];
    };
    std::string res = "";
    for (int i = 0; i + 2 < n; i += 3) {
        res += get(i);
    }
    if (n % 3 == 1) {
        int t1 = ask(n - 2, res[n - 2] - 'a', 0);
        int t2 = ask(n - 2, res[n - 2] - 'a', 1);
        if (t1 == 2) {
            res += "a";
        } else if (t2 == 2) {
            res += "b";
        } else {
            res += "c";
        }
    }
    if (n % 3 == 2) {
        int t1 = ask(n - 2, 0, 0);
        int t2 = ask(n - 2, 1, 1);
        if (t1 == 2) {
            res += "aa";
        } else if (t2 == 2) {
            res += "bb";
        } else if (t1 == 0 && t2 == 0) {
            res += "cc";
        } else if (t1 == 1 && t2 == 0) {
            int t3 = ask(n - 2, 0, 2);
            if (t3 == 2) {
                res += "ac";
            } else {
                res += "ca";
            }
        } else if (t1 == 0 && t2 == 1) {
            int t3 = ask(n - 2, 1, 2);
            if (t3 == 2) {
                res += "bc";
            } else {
                res += "cb";
            }
        } else {
            int t3 = ask(n - 2, 0, 1);
            if (t3 == 2) {
                res += "ab";
            } else {
                res += "ba";
            }
        }
    }
    std::cout << "! " << res << "\n";
}

signed main() {
    auto pp = [&](std::string t, int i, int x, int y) {
        int res = 0;
        if ((t[i] - 'a') == x) {
            ++res;
        }
        if ((t[i + 1] - 'a') == y) {
            ++res;
        }
        return res;
    };
    std::vector<std::string> all;
    for (int a = 0; a < 3; a++) {
        for (int b = 0; b < 3; b++) {
            for (int c = 0; c < 3; c++) {
                std::string t;
                t += char('a' + a), t += char('a' + b), t += char('a' + c);
                all.emplace_back(t);
            }
        }
    }
    for (int a = 0; a < 3; a++) {
        for (int b = 0; b < 3; b++) {
            for (int c = 0; c < 3; c++) {
                for (int d = 0; d < 3; d++) {
                    for (int e = 0; e < 3; e++) {
                        for (int f = 0; f < 3; f++) {
                            for (int g = 0; g < 3; g++) {
                                for (int h = 0; h < 3; h++) {
                                    std::set<std::vector<int>> st;
                                    for (std::string t : all) {
                                        std::vector<int> W;
                                        W.emplace_back(pp(t, 0, a, b));
                                        W.emplace_back(pp(t, 0, c, d));
                                        W.emplace_back(pp(t, 1, e, f));
                                        W.emplace_back(pp(t, 1, g, h));
                                        st.insert(W);
                                    }
                                    if (int(st.size()) == 27) {
                                        good = {a, b, c, d, e, f, g, h};
                                        mp.clear();
                                        for (std::string t : all) {
                                            std::vector<int> W;
                                            W.emplace_back(pp(t, 0, a, b));
                                            W.emplace_back(pp(t, 0, c, d));
                                            W.emplace_back(pp(t, 1, e, f));
                                            W.emplace_back(pp(t, 1, g, h));
                                            mp[W] = t;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    while (true) {
        solve();
    }
}
