
#include <bits/stdc++.h>
using namespace std;
using pii = pair<int,int>;
#define f first
#define s second

#define forn(i,s,f) for (int i=(s); i<(f); ++i)

vector<int> dp;
vector<char> used;

void f(int start, vector<vector<int>> &g) {
    queue<int> q;
    q.push(start);
    vector<int> dist(g.size(), -1);
    dist[start]=0;
    while (!q.empty()) {
        auto v=q.front();
        if (g[v].size()==1 && v!=0) {
            break;
        }
        q.pop();
        for (auto u:g[v]) {
            if (dist[u]==-1 and !used[u]) {
                used[u]=true;
                dist[u]=dist[v]+1;
                q.push(u);
            }
        }
    }
    dp[start]=0;
    int list=q.front();
    q.pop();
    ++dp[start];
    int maxx=0;
    while (!q.empty()) {
        int v=q.front();
        if (dist[v]!=dist[list]) {
            break;
        }
        q.pop();
        f(v, g);
        maxx=max(maxx, dp[v]);
    }
    dp[start]+=maxx;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin>>n;
    vector<vector<int>> g(n);
    forn(i,0,n-1){
        int cur;
        cin >> cur;
        cur--;
        g[i+1].push_back(cur);
        g[cur].push_back(i+1);
    }
    dp.resize(n);
    used.resize(n, false);
    f(0, g);
    cout<<dp[0]<<"\n";
    return 0;
}
