#include <iostream>
#include <map>
#include <vector>

using namespace std;

#define int long long

const int mod = 1e9 + 7;

int binpow(int a, int b) {
    if (b == 0)
        return 1;
    int c = binpow(a, b / 2);
    c = c * c % mod;
    if (b % 2 == 1)
        c = c * a % mod;
    return c;
}

void solve() {
    int n;
    cin >> n;
    int c0 = 0, c1 = 0, c2 = 0;
    for (int i = 0; i < n; ++i) {
        int c;
        cin >> c;
        if (c % 3 == 0)
            ++c0;
        if (c % 3 == 1)
            ++c1;
        if (c % 3 == 2)
            ++c2;
    }
    int cnt = 0;
    if (c1 - 1 == c2)
        ++cnt;
    if (c1 - 2 == c2)
        ++cnt;
    if (c2 - 1 == c1)
        ++cnt;
    if (c2 - 2 == c1)
        ++cnt;
    vector<int> fact(n + 1);
    fact[0] = 1;
    for (int i = 1; i <= n; ++i)
        fact[i] = fact[i - 1] * i % mod;
    int C = (fact[n - 1] * binpow(fact[c1 + c2 - 1], mod - 2) % mod) * binpow(fact[c0], mod - 2) % mod;
    int res = ((fact[c1] * fact[c2] % mod) * cnt * C % mod) * fact[c0] % mod;
    cout << res;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int tc = 1;
    // cin >> tc;
    for (int t = 1; t <= tc; ++t) {
        solve();
    }
}