#include <bits/stdc++.h>

using namespace std;

struct node {
    int ans = 0, l = 0, r = 0, len = 0;
};

node cf1(node a, node b) {
    node ans;
    ans.len = a.len + b.len;
    if(a.l == a.len) ans.l = a.l + b.l;
    else ans.l = a.l;
    if(b.r == b.len) ans.r = b.r + a.r;
    else ans.r = b.r;
    ans.ans = max({a.ans, b.ans, ans.l, ans.r, a.r + b.l});
    return ans;
}

int cf2(int a, int b) {
    if(a == 0 || b == 0) return 0;
    return 1;
}

vector<node> tree1;
vector<int> tree2;

void update1(int v, int l, int r, int i, char x) {
    if(r - l == 1) {
        tree1[v].ans = tree1[v].l = tree1[v].r = (x == 'b');
        tree1[v].len = 1;
        return;
    }
    int m = (l + r) / 2;
    if(i < m) update1(v * 2 + 1, l, m, i, x);
    else update1(v * 2 + 2, m, r, i, x);
    tree1[v] = cf1(tree1[v * 2 + 1], tree1[v * 2 + 2]);
}

node query1(int v, int l, int r, int ql, int qr) {
    if(r <= ql || l >= qr) return node();
    if(l >= ql && r <= qr) return tree1[v];
    int m = (l + r) / 2;
    return cf1(query1(v * 2 + 1, l, m, ql, qr), query1(v * 2 + 2, m, r, ql, qr));
}

void update2(int v, int l, int r, int i, int x) {
    if(r - l == 1) {
        tree2[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if(i < m) update2(v * 2 + 1, l, m, i, x);
    else update2(v * 2 + 2, m, r, i, x);
    tree2[v] = cf2(tree2[v * 2 + 1], tree2[v * 2 + 2]);
}

int query2(int v, int l, int r, int ql, int qr) {
    if(r <= ql || l >= qr) return 1;
    if(l >= ql && r <= qr) return tree2[v];
    int m = (l + r) / 2;
    return cf2(query2(v * 2 + 1, l, m, ql, qr), query2(v * 2 + 2, m, r, ql, qr));
}

int main() {
    int n;
    string s;
    cin >> n >> s;
    string_view sv(s);
    int q;
    cin >> q;
    tree1.resize(n * 4);
    tree2.resize(n * 4);
    vector<int> arr2(n, 1);
    for(int ii = 0; ii < n; ii++) {
        arr2[ii] = 1;
        if(sv.substr(ii, 4) == "bbab") arr2[ii] = 0;
        if(sv.substr(ii, 4) == "babb") arr2[ii] = 0;
        update2(0, 0, n, ii, arr2[ii]);
    }
    while(q--) {
        int op;
        cin >> op;
        if(op == 1) {
            int i;
            cin >> i;
            i--;
            if(s[i] == 'a') s[i] = 'b';
            else s[i] = 'a';
            update1(0, 0, n, i, s[i]);

            for(int ii = max(0, i - 4); ii <= i; ii++) {
                arr2[ii] = 1;
                if(sv.substr(ii, 4) == "bbab") arr2[ii] = 0;
                if(sv.substr(ii, 4) == "babb") arr2[ii] = 0;
                update2(0, 0, n, ii, arr2[ii]);
            }
        } else {
            int l, r;
            cin >> l >> r;
            l--;
            if(sv.substr(l, r - l) == "bab") {
                cout << "NO\n";
                continue;
            }
            if(sv.substr(l, r - l) == "bba") {
                cout << "NO\n";
                continue;
            }
            if(sv.substr(l, r - l) == "abb") {
                cout << "NO\n";
                continue;
            }
            if(sv.substr(l, r - l) == "b") {
                cout << "NO\n";
                continue;
            }
            if(sv.substr(l, r - l) == "bb") {
                cout << "NO\n";
                continue;
            }
            node nn1 = query1(0, 0, n, l, r);
            if(nn1.ans >= 3) {
                cout << "NO\n";
                continue;
            }
            if(r - l >= 4 && query2(0, 0, n, l, r - 3) == 0) {
                cout << "NO\n";
                // cout << ">>> " << s << ' ';
                // for(auto i : arr2) cout << i << ' ';
                // cout << '\n';
                continue;
            }
            cout << "YES\n";
        }
    }
}
