/// 174

#include <bits/stdc++.h>

#define PB push_back
#define pb push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())
#define int ll
#define itn int

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
const ll INF=1e18+2;
const ll N=1e6+2;

struct segtree
{
    ve<ll> tree;
    ll sz;

    void init(ll n)
    {
        sz=1;
        while(sz<n) sz*=2;
        tree.assign(sz*2,-INF);
    }

    void build(ve<ll> &arr, ll v, ll tl, ll tr)
    {
        if(tr-tl==1)
        {
            if(tl<sz(arr)) tree[v]=arr[tl];
            return;
        }

        ll tm=(tl+tr)/2;
        build(arr,v*2+1,tl,tm);
        build(arr,v*2+2,tm,tr);
        tree[v]=max(tree[v*2+1],tree[v*2+2]);
    }

    void build(ve<ll> &arr)
    {
        init(sz(arr));
        build(arr,0,0,sz);
    }

    ll get(ll l, ll r, ll v, ll tl, ll tr)
    {
        if(l>=tr||tl>=r) return -INF;
        if(l<=tl&&tr<=r) return tree[v];

        ll tm=(tl+tr)/2;
        ll a=get(l,r,v*2+1,tl,tm);
        ll b=get(l,r,v*2+2,tm,tr);
        return max(a,b);
    }

    ll get(ll l, ll r)
    {
        if(l>r) return -INF;
        return get(l,r+1,0,0,sz);
    }
};

ve<ll> gr[N],lst[N],tin_lst[N];
ll tin[N],tout[N],mnh[N];
ll timer=-1;

void dfs(ll s, ll h)
{
    tin[s]=++timer;
    lst[h].PB(s);
    tin_lst[h].PB(tin[s]);
    mnh[s]=(gr[s].empty()? h:INF);

    for(ll i:gr[s])
    {
        dfs(i,h+1);
        mnh[s]=min(mnh[s],mnh[i]);
    }

    tout[s]=++timer;
}

segtree st[N];
ll dp[N];

ll get(ll h, ll l, ll r)
{
    ll pl=lower_bound(all(tin_lst[h]),l)-tin_lst[h].begin();
    ll pr=upper_bound(all(tin_lst[h]),r)-tin_lst[h].begin();
    return st[h].get(pl,pr-1);
}

void solve()
{
    ll n;
    cin>>n;

    for(ll i=1;i<n;i++)
    {
        ll x;
        cin>>x;
        x--;
        gr[x].PB(i);
    }

    dfs(0,0);

    for(ll h=n-1;h>=0;h--)
    {
        if(lst[h].empty()) continue;

        for(ll v:lst[h])
        {
            for(ll i:gr[v])
            {
                dp[v]=max(dp[v],dp[i]);
                dp[v]=max(dp[v],max(get(mnh[i],tin[v],tin[i]-1),get(mnh[i],tout[i]+1,tout[v]))+1);
            }
        }

        ve<ll> dpv(sz(lst[h]));

        for(ll i=0;i<sz(lst[h]);i++)
        {
            dpv[i]=dp[lst[h][i]];
            if(gr[lst[h][i]].empty()) dpv[i]=-INF;
        }

        st[h].build(dpv);
    }

    cout<<dp[0]+1;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen( "input.txt" , "r" , stdin );
        freopen( "output.txt" , "w" , stdout );
    #endif // LOCAL

    solve();
    return 0;
}
