#include <bits/stdc++.h>

//#define int long long
#define sz(a) (int)a.size()
using namespace std;

const int INF  = 1e9, MAXN = (1 << 20), mod = 1e9 + 7;

vector<int> g[MAXN];
vector<int> need[MAXN];
int deep[MAXN];
int nearest[MAXN];
//vector<int> nearest(MAXN, INF);
int dp[MAXN];
//vector<int> dp(MAXN, 1);

void dfs(int v) {
    if (g[v].size() == 0) {
        nearest[v] = 0;
    }
    for (auto u : g[v]) {
        deep[u] = deep[v] + 1;
        dfs(u);
        nearest[v] = min(nearest[v], nearest[u] + 1);
    }
}

void getdp(int v) {
    if (g[v].size() == 0) {
        return;
    }
//    if (need[deep[v]].size() > 0)
        need[deep[v] + nearest[v]].push_back(v);
    for (auto u : g[v]) {
        getdp(u);
    }
    for (auto u : need[deep[v]]) {
        dp[u] = max(dp[u], dp[v] + 1);
    }
//    if (need[deep[v]].size() > 0)
        need[deep[v] + nearest[v]].pop_back();
}

void solve() {
    int n;
    cin >> n;
    nearest[0] = INF;
    dp[0] = 1;
    for (int i = 1; i < n; i++) {
        int u;
        cin >> u;
        u--;
        nearest[i] = INF;
        dp[i] = 1;
        g[u].push_back(i);
    }
    deep[0] = 0;
    dfs(0);
    getdp(0);
    cout << dp[0];
}

signed main() {
#ifdef home
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}