#include <bits/stdc++.h>
 
using namespace std;
 
const int N = 2e5 + 7, K = 20;
int tin[N];
int depth[N];
int dp[N];
int min_leaf_depth[N];
int mx[K][N];
int go[K][N];
vector <int> g[N];
vector <int> on_depth[N];
int T = 0;

void add(int d, int v) {
    mx[0][v] = dp[v];
    if (on_depth[d].empty()) {
        go[0][v] = -1;
    } else {
        go[0][v] = on_depth[d].back();
    }
    on_depth[d].push_back(v);
    for (int i = 1; i < K; i++) {
        if (go[i - 1][v] == -1) {
            go[i][v] = -1;
            mx[i][v] = mx[i - 1][v];
        } else {
            go[i][v] = go[i - 1][go[i - 1][v]];
            mx[i][v] = max(mx[i - 1][v], mx[i - 1][go[i - 1][v]]);
        }
    }
}

int get(int d, int tin_thresh) {
    int v = on_depth[d].back();
    int res = -1;
    for (int i = K - 1; i >= 0; i--) {
        if (go[i][v] != -1 && tin[go[i][v]] >= tin_thresh) {
            res = max(res, mx[i][v]);
            v = go[i][v];
        }
    }
    return max(res, dp[v]);
}
 
void dfs(int v, int d = 0) {
    dp[v] = 0;
    tin[v] = T++;
    depth[v] = d;
    min_leaf_depth[v] = -1;
    
    if (g[v].empty()) {
        min_leaf_depth[v] = d;
        add(d, v);
        return;
    }

    for (int u : g[v]) {
        dfs(u, d + 1);
        if (min_leaf_depth[v] == -1 || min_leaf_depth[u] < min_leaf_depth[v]) {
            min_leaf_depth[v] = min_leaf_depth[u];
        }
    }

    dp[v] = 1 + get(min_leaf_depth[v], tin[v]);
    add(d, v);
}
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    dfs(1);
    cout << dp[1] << '\n';
    return 0;
}