/*
    @author: EgorUlin
    Egor Ulin, ITMO University
*/

#include <iostream>
#include <cstring>

using namespace std;

#define re return
#define ll int

const ll D = 1e9 + 7;

ll dp[5001][5001];

int main() {
    dp[0][0] = 1;

    for (int i = 1; i <= 5000; ++i) {
        dp[i][0] = 1;
        dp[i][1] = (dp[i - 1][1] + dp[i - 1][0]) % D;
        for (int j = 2; j <= 5000; j++) {
            dp[i][j] = (dp[i - 1][j - 2] + dp[i - 1][j - 1] + dp[i - 1][j]) % D;
        }
    }


    int n; cin >> n;

    ll ans = 1;
    for (ll i = 1; i <= n - 1; ++i) {
        ans = ans * dp[i][i + 1] % D;
    }

    cout << ans;
}