#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) x.begin(), x.end()
#define int long long
#define tm (tl + tr >> 1)
#define ls v << 1, tl, tm
#define rs v << 1 | 1, tm + 1, tr
#define pb push_back
#define F first
#define S second
#define len(x) (int) x.size()
#define vector deque

using namespace std;
using namespace __gnu_pbds;

const int INF = 1e18;
const int N = 2e5 + 7;

int d[N], act[N], sz[N];

vector <int> g[N];


void prec(int v) {
    act[v] = INF;
    for (int u: g[v]) {
        d[u] = d[v] + 1;
        prec(u);
        act[v] = min(act[v], act[u]);
    }
    if (!len(g[v])) act[v] = d[v];
}

int id[N], ans[N];
map <pair<int, int>, vector <int>> mp;

void add(int v, int k) {
    mp[{k, d[v]}].pb(v);
    for (int u: g[v]) add(u, k);
}

void dfs(int v) {
    id[v] = v;
    ans[v] = 0;
    int to = v;
    sz[id[to]] = 1;
    for (int u: g[v]) {
        dfs(u);
        if (sz[id[u]] > sz[id[to]]) to = u;
    }
    id[v] = id[to];
    for (int u: g[v]) if (u != to) {
        sz[id[v]] += sz[id[u]];
        add(u, id[v]);
    }
    int nd = act[v] + 1;
    vector <int> now = mp[{id[v], nd}];
    for (int u: now) {
        ans[v] = max(ans[v], ans[u]);
    }
    ans[v]++;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int v;
        cin >> v;
        g[v].pb(i);
    }
    d[1] = 1;
    prec(1);
    dfs(1);
    cout << ans[1];
}