#include<bits/stdc++.h>

using namespace std;

const int inf = (int)1e9 + 7;
const int N = (int)1e5 + 7;
const int MOD = (int)1e9 + 7;

int sum(int x, int y) {
    x += y;
    if(x >= MOD) {
        x -= MOD;
    }
    return x;
}

int sub(int x, int y) {
    x -= y;
    if(x < 0) {
        x += MOD;
    }
    return x;
}

int mult(int x, int y) {
    return 1ll*x*y%MOD;
}

int binpow(int x, int n) {
    if(n == 0) {
        return 1;
    }
    if(n & 1) {
        return mult(binpow(x, n-1), x);
    }
    int y = binpow(x, n/2);
    return mult(y, y);
}

int f[N];

int C(int n, int k) {
    if(k > n) {
        return 0;
    }
    int ans = f[n];
    ans = mult(ans, binpow(f[k], MOD-2));
    ans = mult(ans, binpow(f[n-k], MOD-2));
    return ans;
}

int n, a[N];
int cnt[3];

void init() {
    f[0] = 1;
    for(int i = 1; i < N; ++i) {
        f[i] = mult(f[i-1], i);
    }
}

int p[N];

int main() {
    ios_base::sync_with_stdio(NULL);
    cin.tie(0);
    init();
    cin >> n;
    for(int i = 1; i <= n; ++i) {
        cin >> a[i];
        a[i] %= 3;
        p[i] = i;
        cnt[a[i]]++;
    }
    int res = 0;
    int m = n-cnt[0];
    if(cnt[1] >= 2) {
        //11 2121212121212121
        int n2 = (m-2+1)/2;
        int n1 = m-2-n2;
        if(cnt[1]-2 == n1 && cnt[2] == n2) {
            res = sum(res, mult(f[cnt[2]], f[cnt[1]]));
        }
    }
    if(cnt[2] >= 2) {
        //22 121212121212121
        int n1 = (m-2+1)/2;
        int n2 = m-2-n1;
        if(cnt[1] == n1 && cnt[2]-2 == n2) {
            res = sum(res, mult(f[cnt[2]], f[cnt[1]]));
        }
    }
    cout << mult(res, mult(C(n-1, cnt[0]), f[cnt[0]]));
    return 0;
}

/*
7
0 1 2 0 1 2 1

8
0 1 2 1 0 1 2 1

6
1 2 1 1 2 1

11
2 2 1 2 0 0 0 2 2 2 1

5
1 2 1 2 1
*/
