#include<bits/stdc++.h>
using namespace std;

using ll = long long;
using ld  = long double;

#define pb push_back
#define ff first
#define ss second
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define sp " "
#define en "\n"

void evraz() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}
const ll N = 2e5 + 5;
const ll mod = 1e9 + 7;
multiset<ll> t[N];
vector<ll> g[N];
ll dp[N], d[N], l[N], b[N], sz[N];

void qfs(ll v, ll p) {
    sz[v] = 1, l[v] = mod;
    bool leaf = 1;
    for(auto to: g[v]) {
        if(to==p) continue;
        d[to] = d[v]+1, leaf = 0;
        qfs(to, v);
        sz[v] += sz[to], l[v] = min(l[v], l[to]);
    }
    if(leaf) l[v] = d[v];
    // cout<<v<<" - "<<l[v]<<"\n";
}

void calc(ll v, ll p, ll x) {
    if(x==-1) t[d[v]].erase(t[d[v]].find(dp[v]));
    else t[d[v]].insert(dp[v]);
    for(auto to: g[v]) {
        if(to==p || to==b[v]) continue;
        calc(to, v, x);
    }
}

void dfs(ll v, ll p, bool keep) {
    ll mx = -1;
    for(auto to: g[v]) {
        if(to==p) continue;
        if(sz[to]>mx) mx = sz[to], b[v] = to;
    }
    for(auto to: g[v]) {
        if(to==p || to==b[v]) continue;
        dfs(to, v, 0);
    }
    if(b[v]) dfs(b[v], v, 1);
    calc(v, p, 1);
    t[d[v]].erase(t[d[v]].find(dp[v]));
    if(l[v]!=d[v]) dp[v] = *t[l[v]].rbegin()+1;
    t[d[v]].insert(dp[v]);
    if(b[v]) b[v] = 0;
    if(!keep) calc(v, p, -1);
}

void psycho() {
    ll n;
    cin>>n;
    for(ll i=2; i<=n; i++) {
        ll p;
        cin>>p;
        g[i].pb(p), g[p].pb(i);
    }
    qfs(1, 0), dfs(1, 0, 1);
    cout<<dp[1]<<"\n";
}


signed main() {
    evraz();
    ll t = 1;
    // cin>>t;
    while(t--) {
        psycho();
    }
}
