#include <bits/stdc++.h>
using namespace std;

#define int long long

int32_t main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int n; cin >> n;

    vector g(n + 1, vector < int >());

    for (int i = 2, p; i <= n; i++) {
        cin >> p;

        g[p].push_back(i);
    }

    vector < int > leaf(n + 1, -1), cntLeaf(n + 1);
    vector < int > depth(n + 1);

    function < void(int) > DFS1 = [&](int v) {
        if (g[v].empty()) {
            leaf[v] = v, cntLeaf[v] = 1;
            return;
        }

        for (auto u : g[v]) {
            depth[u] = depth[v] + 1;

            DFS1(u);

            cntLeaf[v] += cntLeaf[u];

            if (leaf[v] == -1 || depth[leaf[u]] < depth[leaf[v]])
                leaf[v] = leaf[u];
        }
    };

    DFS1(1);

    vector < int > dp(n + 1), mxDp(n + 2);

    function < void(int) > DFS2 = [&](int v) {
        for (auto u : g[v])
            DFS2(u);

        dp[v] = (cntLeaf[v] > 1 ? mxDp[depth[leaf[v]]] : 0) + 1;

        if (!g[v].empty())
            mxDp[depth[v]] = max(mxDp[depth[v]], dp[v]);
    };

    DFS2(1);

    cout << dp[1] << "\n";
}
