#include <bits/stdc++.h>
using namespace std;

#define int long long

vector < vector < int > > g;

vector < int > depth;

const int INF = 1e+9;

int BFS(int v) {
    queue < int > bfs;

    bfs.push(v);

    int cnt = 0, d = INF, mx = 0;

    while (!bfs.empty()) {
        int v = bfs.front(); bfs.pop();

        if (depth[v] == d) {
            mx = max(mx, BFS(v));
            continue;
        }

        for (auto u : g[v]) {
            depth[u] = depth[v] + 1;

            if (g[u].empty()) {
                if (d == INF) {
                    d = depth[u];
                    cnt++;
                }
            } else if (depth[u] <= d) {
                    bfs.push(u);
            }
        }
    }

    return cnt + mx;
}

int32_t main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int n; cin >> n;
    
    g.resize(n + 1);
    depth.resize(n + 1);

    for (int i = 2, p; i <= n; i++) {
        cin >> p;

        g[p].push_back(i);
    }

    cout << BFS(1) << "\n";
}
