# include <bits/stdc++.h>
# define nl '\n'
# define pb push_back
# define sz(x) (ll)(x).size()

using namespace std;
using ll = long long;

const ll N = 2e5+5;
const ll inf = (ll)2e18 + 7;

ll n;
vector <ll> g[N];
ll dp[N];

void dfs (ll v = 1) {
    if (sz(g[v]) == 0) {
        dp[v] = 0;
        return;

    }
    bool leafs = 1;
    for (ll to : g[v]) {
        if (sz(g[to]) != 0) {
            leafs = 0;
            break;
        }
    }
    int add = 0;
    if (sz(g[v]) > 1 && !leafs) {
        add = 1;
    }
    for (ll to : g[v]) {
        dfs(to);
        dp[v] = max(dp[v], dp[to] + add);
    }
    //dp[v] = max(dp[v], 1LL);
    //cout << v << ' ' << dp[v] << nl;
}

void ma1n () {
    cin >> n;
    for (ll i = 2, pa; i <= n; ++i) {
        cin >> pa;
        g[pa].pb(i);
    }
    dfs ();
    cout << dp[1] + 1 << nl;
}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    ma1n();
    return 0;
}
