#include <bits/stdc++.h>
using namespace std;
#define int long long
typedef long long ll;
typedef long double ld;

const int maxn = 1e6 + 1, inf = 1e9;

int check(int x) {
    cout << "? " << x << endl;
    int ans;
    cin >> ans;
    return ans;
}

int binpow(int x, int y) {
    if (y == 0) return 1;
    int res = binpow(x, y / 2);
    res = res * res;
    if (y % 2 == 1) {
        res *= x;
    }
    return res;
}

int tocheck(int x, int y) {
    int l = 1, r = powl(inf * inf, 1l / y) + 2;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        if (binpow(mid, y) * (mid - 1) >= x) {
            r = mid;
        } else {
            l = mid;
        }
    }
    return r;
}

void solve() {
    int fans;
    cin >> fans;
    int l = 0, r = inf * 2022ll + 1;
    while (l + 1 < r) {
        int mid = (l + r) / 2ll;
        if (check(mid) >= fans + 1) {
            r = mid;
        } else {
            l = mid;
        }
    }
    int l1 = 0, r1 = inf * 2022ll * 2022 + 1;
    while (l1 + 1 < r1) {
        int mid = (l1 + r1) / 2ll;
        if (check(mid) >= fans + 2) {
            r1 = mid;
        } else {
            l1 = mid;
        }
    }
    int fd = r1 - r, sm = fans + 1;
    int osn = tocheck(fd, sm);
    cout << "! " << binpow(osn, fans) - r << ' ' << osn << endl;
}

signed main() {
    solve();
}
