#include <iostream>
#include <algorithm>
#include <numeric>
#include <math.h>
#include <cmath>
#include <string>
#include <map>
#include <vector>

using namespace std;
const long long mod = (1e9) + 7;
long long fact(long long a) {
	long long ans = 1;
	for (long long i = 1; i <= a; i++) {
		ans = (ans * i) % mod;
	}
	return ans % mod;
}
long long cnk(long long n, long long k) {
	return (fact(n) / (fact(n - k) * fact(k) % mod)) % mod;
}


int main()
{
	long long n, k, ans = 1;
	cin >> n;
	n--;
	for (long long i = 1; i <= n; i++) {
		long long q = i + 1, part = 0, modi = 1;
		while (q >= 2) {
			q -= 2;
			part = (part + (cnk(i, modi) * cnk(i - modi, q)) % mod) % mod;
			modi++;
			modi %= mod;
		}
		ans = (ans * part) % mod;
	}
	cout << ans << endl;
}
