﻿
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <deque>
#include <set>
#include <map>

using namespace std;

using ll = long long;
using ld = long double;
int n;
bool cmp(pair<int, int> a, pair<int, int> b) {
    return a.second < b.second;
}
bool check(vector<vector<int>> d) {
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            a[i] += d[i][j];
            b[j] += d[i][j];
        }
    }
    set<int> s;
    for (int i = 0; i < n; i++) {
        s.insert(a[i]);
        s.insert(b[i]);
    }
    return (s.size() == 1);
}
int main() {
    cin.tie(0)->sync_with_stdio(false);
    cin >> n;
    vector<vector<int>> d(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> d[i][j];
        }
    }
    if (n < 10) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                for (int x = 0; x < n; x++) {
                    for (int y = 0; y < n; y++) {
                        swap(d[i][j], d[x][y]);
                        if (check(d)) {
                            cout << i + 1 << ' ' << j + 1 << endl<<x+1<<' '<<y+1;
                            exit(0);
                        }
                        swap(d[i][j], d[x][y]);
                    }
                }
            }
        }
    }
    else {
        vector<int> a(n), b(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                a[i] += d[i][j];
                b[j] += d[i][j];
            }
        }
        map<int, int>ma;
        for (auto i : a) {
            ma[i] += 1;
        }
        vector<pair<int, int>> m;
        for (auto i : ma) {
            m.push_back(i);
        }
        sort(m.begin(), m.end(), cmp);
        int s = (*m.rbegin()).second;
        int x=-1, y=-1, x2=-1, y2=-1;
        for (int i = 0; i < n; i++) {
            if (a[i] == (*m.begin()).first) x = i;
            else if (a[i] != (*m.rbegin()).first) x2 = i;
        }
        for (int i = 0; i < n; i++) {
            if (b[i] == (*m.begin()).first) y = i;
            else if (b[i] != (*m.rbegin()).first) y2 = i;
        }
        if (y != -1 and x != -1) {
            cout << x + 1 << ' ' << y + 1 << endl << x2 + 1 << ' ' << y2 + 1;
        }
        else if (x == -1) {
            for (int i = 0; i < n; i++) {
                if (b[y] + d[i][y2] -d[i][y] == b[y2] + d[i][y] - d[i][y2]) {
                    cout << i + 1 << ' ' << y + 1 << endl << i + 1 << ' ' << y2 + 1;
                    exit(0);
                }
            }
        }
        else {
            for (int i = 0; i < n; i++) {
                if (a[x] + d[x2][i] - d[x][i] == a[x2] + d[x][i] - d[x2][i]) {
                    cout << x + 1 << ' ' << i + 1 << endl << x2 + 1 << ' ' << i + 1;
                    exit(0);
                }
            }
        }
    }
}