﻿
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <deque>
#include <set>
#include <map>

using namespace std;

using ll = long long;
using ld = long double;
ll q = 1e9 + 7;
int main() {
    cin.tie(0)->sync_with_stdio(false);
    int n;
    cin >> n;
    vector<vector<ll>> dp(n+1, vector<ll>(n+1));
    vector<ll> f(n+1);
    for (int i = 0; i <= n; i++) {
        dp[0][i] = 1;
        f[i] = 1;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= n; j++) {
            if (j <i) {
                dp[i][j] = (f[j] - dp[i - j - 1][j] + q) % q;
            }
            else {
                dp[i][j] = f[j];
            }
            f[j] += dp[i][j];
            f[j] %= q;
        }
    }
    ll ans = 0, s = 0;
    for (int i = 1; i <= n + 1; i++) {
        if (s > n) break;
        ans += i * (dp[n - s][i - 1]);
        ans %= q;
        s += i;
    }
    cout << ans;
}