﻿#include <iomanip>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <map>
#include <iostream>
#include <string>
#include <iomanip>
#include <vector>
#include <cmath>
#define int long long
using ll = long long;
using namespace std;
const int mod = 1e9 + 7;
const int INF = 1e9 + 7;
#define get_time (double)clock() / (double)(CLOCKS_PER_SEC)
#ifndef ONLINE_JUDGE
#define debug(x) cerr << (#x) << ": " << x << endl;
#else
#define debug(x)
#endif
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll bs_sqrt(ll x) {
    ll left = 0, right = 2000000123;
    while (right > left) {
        ll mid = (left + right) / 2;
        if (mid * mid > x) {
            right = mid;
            continue;
        }
        left = mid + 1;
    }
    return left - 1;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
int bin_pow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        ll t = bin_pow(a, n / 2);
        return (t * t) % mod;
    }
    else {
        ll t = bin_pow(a, n - 1);
        return (t * a) % mod;
    }
}
int rev(int x) {
    return bin_pow(x, mod - 2);
}
int mul(int a, int b) {
    return (a * b) % mod;
}
int make_add(int a, int b) {
    return (a + b) % mod;
}
map<pair<int, int>, int> cnt_x, cnt_y;
int ans_ch_x = 0, ans_nch_x = 0, ans_ch_y = 0, ans_nch_y = 0;
void del_x(int x, int y) {
    int d = max(cnt_x[{x, 0}], cnt_x[{x, 1}]);
    if (x % 2 == 1) ans_nch_x -= d;
    if (x % 2 == 0) ans_ch_x -= d;
    cnt_x[{x, y % 2}]--;
    d = max(cnt_x[{x, 0}], cnt_x[{x, 1}]);
    if (x % 2 == 1) ans_nch_x += d;
    if (x % 2 == 0) ans_ch_x += d;
}
void ins_x(int x, int y) {
    int d = max(cnt_x[{x, 0}], cnt_x[{x, 1}]);
    if (x % 2 == 1) ans_nch_x -= d;
    if (x % 2 == 0) ans_ch_x -= d;
    cnt_x[{x, y % 2}]++;
    d = max(cnt_x[{x, 0}], cnt_x[{x, 1}]);
    if (x % 2 == 1) ans_nch_x += d;
    if (x % 2 == 0) ans_ch_x += d;
}
void del_y(int x, int y) {
    swap(x, y);
    int d = max(cnt_y[{x, 0}], cnt_y[{x, 1}]);
    if (x % 2 == 1) ans_nch_y -= d;
    if (x % 2 == 0) ans_ch_y -= d;
    cnt_y[{x, y % 2}]--;
    d = max(cnt_y[{x, 0}], cnt_y[{x, 1}]);
    if (x % 2 == 1) ans_nch_y += d;
    if (x % 2 == 0) ans_ch_y += d;
}
void ins_y(int x, int y) {
    swap(x, y);
    int d = max(cnt_y[{x, 0}], cnt_y[{x, 1}]);
    if (x % 2 == 1) ans_nch_y -= d;
    if (x % 2 == 0) ans_ch_y -= d;
    cnt_y[{x, y % 2}]++;
    d = max(cnt_y[{x, 0}], cnt_y[{x, 1}]);
    if (x % 2 == 1) ans_nch_y += d;
    if (x % 2 == 0) ans_ch_y += d;
}
void solve() {
    int n;
    cin >> n;
    set<pair<int, int> > s;
    map<vector<int>, int> cnt;
    for (int i = 0; i < n; i++) {
        int x, y; cin >> x >> y;
        if (s.count({ x,y })) {
            s.erase({ x,y });
            del_x(x, y);
            del_y(x, y);
        } else {
            ins_x(x, y);
            ins_y(x, y);
            s.insert({ x,y });
        }
        int ans = max(ans_ch_x, ans_nch_x);
        int ans2 = max(ans_ch_y, ans_nch_y);
        cout << max(ans2, ans) << '\n';
    }
}
signed main() {
    cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}