#include <bits/stdc++.h>

#ifndef Local
#define debug(...) 1337
#define endl '\n'
#endif

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

template<typename T, typename U>
bool smin(T &a, U b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename U>
bool smax(T &a, U b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int maxn = 2e5 + 100;
vector<int> g[maxn];
int dp[maxn];

void dfs0(int v, int d) {
    if (sz(g[v]) == 0)
        dp[v] = d;
    else
        dp[v] = 1e9;
    for (int &u: g[v]) {
        dfs0(u, d + 1);
        smin(dp[v], dp[u]);
    }
    sort(all(g[v]), [&](int i, int j) { return dp[i] < dp[j]; });
}

int ans = 0;

void dfs(int v, int x, int cnt) {
    if (sz(g[v]) == 0)
        return;
    x = g[x][0];
    if (sz(g[x]) == 0)
        ++cnt, x = v;
    smax(ans, cnt);
    for (int &u: g[v])
        dfs(u, x, cnt);
}

void solve() {
    int n;
    cin >> n;
    for (int i = 2, p; i <= n; ++i) {
        cin >> p;
        g[p].push_back(i);
    }
    g[0].push_back(1);
    dfs0(1, 0);
    dfs(1, 0, 1);
    cout << ans << endl;
}

/*

4
1 1 3

3
1 2

8
1 2 1 4 5 6 5

8
1 1 3 3 5 5 7


*/

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);

    int tt = 1;
//	cin >> tt;
    while (tt--)
        solve();

    return 0;
}
