#include <bits/stdc++.h>

using namespace std;
#define int long long
const int mod = 1e9 + 7;
int prod(int a, int b) {
    return (a * b) % mod;
}

int bin_pow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int t = bin_pow(a, n / 2);
        return prod(t, t);
    }
    return prod(a, bin_pow(a, n - 1));
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin>>n;
    vector<int> a(n);
    for (int i=0;i<n;i++){
        cin>>a[i];
    }
    vector<int> F(1e6 + 1), F_inv(1e6 + 1);
    F[0] = 1;
    for (int i = 1; i <= 1e6; ++i) {
        F[i] = prod(F[i - 1], i);
    }
    F_inv.back() = bin_pow(F.back(), mod - 2);
    for (int i = 1e6 - 1; i >= 0; --i) {
        F_inv[i] = prod(F_inv[i + 1], (i + 1));
    }
    int cnt0=0,cnt1=0,cnt2=0;
    for (int i=0;i<n;i++){
        if (a[i]%3==0){
            cnt0++;
        }
        if (a[i]%3==1){
            cnt1++;
        }
        if (a[i]%3==2){
            cnt2++;
        }
    }
    if (abs(cnt2-cnt1)==0 || abs(cnt2-cnt1)>2){
        cout<<0;
        return 0;
    }
    cout<<prod(prod(F[cnt2],F[cnt1]),prod(prod(F[cnt2+cnt1],F_inv[cnt2+cnt1-cnt0]),F_inv[cnt0]));
}
