#include <iostream>
#include<string>
#include<vector>
#define int long long

using namespace std;

long long need = 0;
vector<long long> sum_row, sum_col;
vector<vector<long long>> a;

bool check_swap(long long i, long long j, long long x, long long y)
{
    long long ri = (x != i ? sum_row[i] - a[i][j] + a[x][y] : sum_row[i]);
    long long rx = (x != i ? sum_row[x] - a[x][y] + a[i][j] : sum_row[x]);
    long long cj = (y != j ? sum_col[j] - a[i][j] + a[x][y] : sum_col[j]);
    long long cy = (y != j ? sum_col[y] - a[x][y] + a[i][j] : sum_col[y]);
    return (ri == need && rx == need && cj == need && cy == need);
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int n; cin >> n;
    a.resize(n, vector<int> (n));
    int sum = 0;
    vector<pair<int, int>> pos(n*n+1);
    for (int i = 0; i<n; ++i) {
        for (int j = 0; j<n; ++j) {
            cin >> a[i][j];
            sum += a[i][j];
            pos[a[i][j]] = {i, j};
        }
    }
    sum_row.resize(n);
    sum_col.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            sum_row[i] += a[i][j];
            sum_col[j] += a[i][j];
        }
    }
    need = sum/n;
    vector<pair<int, int>> indi;
    for (int i = 0; i<n; ++i) {
        int cur = 0;
        for (int j = 0; j<n; ++j) cur += a[i][j];
        if (cur != need) {
            indi.emplace_back(i, cur);
        }
    }
    vector<pair<int, int>> indj;
    for (int j = 0; j<n; ++j) {
        int cur = 0;
        for (int i = 0; i<n; ++i) cur += a[i][j];
        if (cur != need) {
            indj.emplace_back(j, cur);
        }
    }
    if (!indi.empty()) {
        for (int j = 0; j<n; ++j) {
            int new_sum = indi[0].second - a[indi[0].first][j];
            if (need - new_sum > 0 && need - new_sum <= n*n && pos[need - new_sum].first == indi[1].first) {
                if (indj.empty() || (min(j, pos[need - new_sum].second) == min(indj[0].first, indj[1].first) && max(j, pos[need - new_sum].second) == max(indj[0].first, indj[1].first))) {
                    if (check_swap(indi[0].first, j, pos[need - new_sum].first, pos[need - new_sum].second)) {
                        cout << indi[0].first+1 << " " << j+1 << '\n' << pos[need - new_sum].first+1 << " " << pos[need - new_sum].second+1 << '\n';
                        return 0;
                    }
                }
            }
        }
    }
    if (!indj.empty()) {
        for (int i = 0; i<n; ++i) {
            int new_sum = indj[0].second - a[i][indj[0].first];
            if (need - new_sum > 0 && need - new_sum <= n*n && pos[need - new_sum].second == indj[1].first) {
                if (indi.empty() || (min(i, pos[need - new_sum].first) == min(indi[0].first, indj[0].first) && max(i, pos[need - new_sum].first) == max(indi[0].first, indj[0].first))) {
                    if (check_swap(i, indj[0].first, pos[need - new_sum].first, pos[need - new_sum].second)) {
                        cout << i+1 << " " << indj[0].first+1 << '\n' << pos[need - new_sum].first+1 << " " << pos[need - new_sum].second+1 << '\n';
                        return 0;
                    }
                }
            }
        }
    }
    cout << "1 1\n";
    cout << "1 1\n";
    return 0;
}
