#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

typedef long long ll;

const long long INF = 1e18, MOD = 1e9 + 7;
#define all(x) x.begin(), x.end()

int ask(int st, char f, char s) {
	cout << "? " << st << ' ' << f << s << '\n';
	cout.flush();
	int ans; cin >> ans;
	return ans;
}

char solve1(int st, char pr) {
	if (ask(st, pr, 'a') == 2) {
		return 'a';
	}
	else if (ask(st, pr, 'b') == 2) {
		return 'b';
	}
	return 'c';
}

string solve3(int st) {
	int f = ask(st, 'a', 'b');
	if (f == 2) {
		return "ab" + solve1(st + 1, 'b');
	}
	if (f == 0) {
		int s = ask(st, 'b', 'a');
		if (s == 0) {
			return "cc" + solve1(st + 1, 'c');
		}
		if (s == 2) {
			return "ba" + solve1(st + 1, 'a');
		}
		s = ask(st + 1, 'a', 'a');
		if (s == 0) {
			int g = ask(st + 1, 'c', 'b');
			if (g == 2) {
				return "bcb";
			}
			return "bcc";
		}
		if (s == 2) {
			return "caa";
		}
		s = ask(st + 1, 'a', 'b');
		if (s == 0) {
			return "bca";
		}
		if (s == 2) {
			return "cab";
		}
		return "cac";
	}
	int s = ask(st + 1, 'b', 'a');
	if (s == 2) {
		s = ask(st, 'b', 'b');
		if (s == 2) {
			return "bba";
		}
		return "cba";
	}
	if (s == 0) {
		s = ask(st, 'a', 'c');
		if (s == 2) {
			s = ask(st + 1, 'c', 'b');
			if (s == 2) {
				return "acb";
			}
			return "acc";
		}
		s = ask(st + 1, 'a', 'b');
		if (s == 2) {
			return "aab";
		}
		return "aac";
	}
	s = ask(st, 'b', 'b');
	if (s == 2) {
		s = ask(st + 1, 'b', 'b');
		if (s == 2) {
			return "bbb";
		}
		return "bbc";
	}
	if (s == 0) {
		s = ask(st, 'a', 'a');
		if (s == 2) {
			return "aaa";
		}
		return "aca";
	}
	s = ask(st + 1, 'b', 'b');
	if (s == 2) {
		return "cbb";
	}
	return "cbc";
}

string solve2(int st) {
	int f = ask(st, 'a', 'b');
	if (f == 2) {
		return "ab";
	}
	if (f == 1) {
		int s = ask(st, 'a', 'c');
		if (s == 2) {
			return "ac";
		}
		if (s == 1) {
			return "aa";
		}
		s = ask(st, 'b', 'b');
		if (s == 2) {
			return "bb";
		}
		return "cb";
	}
	else {
		int s = ask(st, 'b', 'a');
		if (s == 2) {
			return "ba";
		}
		if (s == 0) {
			return "cc";
		}
		s = ask(st, 'a', 'a');
		if (s == 1) {
			return "ca";
		}
		return "bc";
	}
}

void solve(int n)
{
	string ans = "";
	for (int i = 0; i + 2 < n; i += 3) {
		string nw = solve3(i + 1);
		for (char j : nw) {
			ans.push_back(j);
		}
	}
	if (n % 3 == 1) {
		ans.push_back(solve1(n - 1, ans.back()));
	}
	if (n % 3 == 2) {
		string nw = solve2(n - 1);
		ans.push_back(nw[0]);
		ans.push_back(nw[1]);
	}
	cout << "! " << ans << '\n'; cout.flush();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n; cin >> n;
	while (n != 0) {
		solve(n);
		cin >> n;
	}

	return 0;
}

/*

























*/
