#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll INF = 1e18 + 1;
const ll MOD = 1e9 + 7;
#define int long long
#define endl "\n"

vector<vector<int>> w;
int n;

void check(int x1, int y1, int x2, int y2) {
    int valx = -1, valy = -1;
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += w[i][j];
        }
        if (valx == -1) valx = sum;
        else if (valx != sum) return;
    }
    for (int j = 0; j < n; j++) {
        int sum = 0;
        for (int i = 0; i < n; i++) {
            sum += w[i][j];
        }
        if (valy == -1) valy = sum;
        else if (valy != sum) return;
    }
    cout << x1 + 1 << ' ' << y1 + 1 << '\n' << x2 + 1 << ' ' << y2 + 1;
    exit(0);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector <vector <int>> dp(n + 1, vector <int> (n + 1));
    for (int i = 0; i <= n; i++)
        dp[0][i] = 1;
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= n; j++){
            if (j * 2 < i)
                continue;
            dp[i][j] += dp[i][j - 1];
            dp[i][j] += dp[i - 1][j - 1];
            if (i >= 2)
                dp[i][j] += dp[i - 2][j - 1];
            dp[i][j] %= MOD;
        }
    }
    vector <int> dp1(n + 1);
    dp1[1] = 1, dp1[2] = 1;
    for (int i = 3; i <= n; i++){
        dp1[i] = dp[i][i - 1] * dp1[i - 1];
        dp1[i] %= MOD;
    }
    cout << dp1[n];
}
