#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long

void solveF() {
    int n;
    cin >> n;

    vector <vector <int>> a(n, vector <int> (n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }

    auto check = [&]() {
        int s = n * n * (n * n + 1) / 2 / n;
        for (int i = 0; i < n; i++) {
            int cur = 0;
            for (int j = 0; j < n; j++) {
                cur += a[i][j];
            }
            if (cur != s) return false;
        }
        for (int j = 0; j < n; j++) {
            int cur = 0;
            for (int i = 0; i < n; i++) {
                cur += a[i][j];
            }
            if (cur != s) return false;
        }
        return true;
    };

    int s = n * n * (n * n + 1) / 2 / n;
    vector <int> r, c;
    for (int i = 0; i < n; i++) {
        int cur = 0;
        for (int j = 0; j < n; j++) {
            cur += a[i][j];
        }
        if (cur != s) {
            r.push_back(i);
        }
    }
    for (int j = 0; j < n; j++) {
        int cur = 0;
        for (int i = 0; i < n; i++) {
            cur += a[i][j];
        }
        if (cur != s) {
            c.push_back(j);
        }
    }

    if (c.empty()) {
        int s1 = 0, s2 = 0;
        for (int j = 0; j < n; j++) {
            s1 += a[r[0]][j];
            s2 += a[r[1]][j];
        }
        for (int j = 0; j < n; j++) {
            int x = a[r[0]][j], y = a[r[1]][j];
            if (s1 - x + y == s && s2 - y + x == s) {
                cout << r[0] + 1 << " " << j + 1 << "\n";
                cout << r[1] + 1 << " " << j + 1 << "\n";
                return;
            }
        }
    }
    if (r.empty()) {
        int s1 = 0, s2 = 0;
        for (int i = 0; i < n; i++) {
            s1 += a[i][c[0]];
            s2 += a[i][c[1]];
        }
        for (int i = 0; i < n; i++) {
            int x = a[i][c[0]], y = a[i][c[1]];
            if (s1 - x + y == s && s2 - y + x == s) {
                cout << i + 1 << " " << c[0] + 1 << "\n";
                cout << i + 1 << " " << c[1] + 1 << "\n";
                return;
            }
        }
    }

    for (int i1 : r) {
        for (int i2 : r) {
            for (int j1 : c) {
                for (int j2 : c) {
                    if (j1 == j2 && i1 == i2) continue;

                    swap(a[i1][j1], a[i2][j2]);
                    if (check()) {
                        cout << i1 + 1 << " " << j1 + 1 << "\n";
                        cout << i2 + 1 << " " << j2 + 1 << "\n";
                        return;
                    }
                    swap(a[i1][j1], a[i2][j2]);
                }
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;

    while (t--) {
        solveF();
    }
}
