#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define first fi
#define second se
#define push_back pb

const ll MOD = 1'000'000'000 + 7;

ll bin_pow(ll n, ll k)
{
    if (k == 1) return n;
    if (k == 0) return 1;

    if (k % 2 == 0) {
        ll ans = bin_pow(n, k / 2);
        return ans * ans % MOD;
    } else {
        return n * bin_pow(n, k - 1) % MOD;
    }
}

void solve()
{
    ll n;
    cin >> n;

    vector <ll> fact(n + 1);
    vector <ll> inv_fact(n + 1);
    fact[0] = 1;
    for (ll i = 1; i <= n; i++)
    {
        fact[i] = fact[i - 1] * i % MOD;
        inv_fact[i] = bin_pow(fact[i], MOD - 2);
    }

    ll ans = 1;
    for (ll i = 2; i < n; i++)
    {
        ll sum = 0;
        for (ll cnt = 1;; cnt++)
        {
            if (cnt * 2 > i + 1) break;
            sum += inv_fact[cnt] * inv_fact[i - cnt] % MOD * fact[i];
            sum %= MOD;
        }
        ans *= sum;
        ans %= MOD;
    }
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}
