#include <bits/stdc++.h>
using namespace std;
#define int long long

mt19937 rnd(23);

struct g{
    int pref, suf, mx;
    bool ok;
};
string s;
const int MAXN = 1e5;
g tree[MAXN * 4];
void build(int t, int l, int r) {
    if (r - l == 1) {
        if (s[l] == 'b') {
            tree[t] ={1,1, 1, 0};
        } else {
            tree[t] = {0,0, 1,1};
        }
        return;
    }
    int m = (r + l) / 2;
    build (t *2 , l,m);
    build (t * 2 + 1,m,r);
    bool is = true;
    int mx = max(tree[t *2].mx, max(tree[t *2 + 1].mx, tree[t * 2].suf + tree[t * 2 + 1].pref));
    if (mx >= 3) {
        is  = false;
    }
    if (tree[t * 2].suf + tree[t *2 + 1].pref >= 3) {
        is = false;
    }
    if (tree[t * 2 + 1].suf >= 2) {
        is = false;
    }
    if (tree[t * 2].pref >= 2) {
        is = false;
    }
    tree[t] = {tree[t *2 ].pref, tree[t *2 + 1].suf,mx, is};
}

g get(int t, int l, int r, int tl, int tr) {
    if (tl >= l && tr <= r) {
        return tree[t];
    }
    if (tl >= r || tr <= l) {
        return {-1,-1,0,1};
    }
    int m = (tl + tr) / 2;
    auto gl = get(t * 2,l,r,tl,m);
    auto gr = get(t * 2 + 1,l,r,m,tr);
    if (gl.suf == -1) {
        return gr;
    } else if (gr.suf == -1) {
        return gl;
    }
    bool is = true;
    int mx = max(gl.mx, max(gr.mx, gl.suf + gr.pref));
    if (mx >= 3) {
        is  = false;
    }
    if (gl.suf + gr.pref >=3) {
        is = false;
    }
    if (gl.pref >= 2) {
        is = false;
    }
    if (gr.suf >= 2) {
        is = false;
    }
    return {gl.pref, gr.suf,mx, is};
}

void upd(int t,int l, int r , int x) {
    if (r - l == 1) {
        if (tree[t].ok) {
            tree[t].ok = false;
            tree[t].suf = 1;
            tree[t].pref=1;
        } else {
            tree[t].ok=1;
            tree[t].suf=0;
            tree[t].pref = 0;
        }
        return;
    }
    int m = (r + l) / 2;
    if (x < m) {
        upd(t * 2,l,m,x);
    } else {
        upd(t * 2 + 1,m,r,x);
    }
    bool is = true;
    int mx = max(tree[t *2].mx, max(tree[t *2 + 1].mx, tree[t * 2].suf + tree[t * 2 + 1].pref));
    if (mx >= 3) {
        is  = false;
    }
    if (tree[t * 2].suf + tree[t *2 + 1].pref >= 3) {
        is = false;
    }
    if (tree[t * 2 + 1].suf >= 2) {
        is = false;
    }
    if (tree[t * 2].pref >= 2) {
        is = false;
    }
    tree[t] = {tree[t *2 ].pref, tree[t *2 + 1].suf,mx, is};
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    cin >> s;
    int q;
    cin >> q;
    set<string>st;
    st.insert("bab");
    st.insert("bbb");
    st.insert("bba");
    st.insert("abb");
    st.insert("bb");
    st.insert("b");

    build (1,0,n);
    while (q--) {
        int z;
        cin >> z;
        if (z == 1) {
            int x;
            cin >> x;
            x--;
            upd(1,0,n,x);
        } else {
            int l, r;
            cin >> l >> r;
            l--;
            string h = "";
            if (r - l <= 3) {
                for (int i = l; i < r; i++) {
                    h += s[i];
                }
                if(st.find(h) != st.end()) {
                    cout << "NO\n";
                    continue;
                } else {
                    cout << "YES\n";
                    continue;
                }
            }
            auto f = get(1,l,r,0,n);
            if (f.ok) {
                cout << "YES\n";
            } else {
                cout << "NO\n";
            }
        }
    }
    return 0;
}
