#include <bits/stdc++.h>

using ll = long long;

const int M = 1e9 + 7;

void solve() {
    int n; std::cin >> n;
    std::vector<std::vector<ll>>C(n + 1, std::vector<ll>(n + 1, 1));
    for (int i = 2; i <= n; ++i) {
        for (int j = 1; j < i; ++j) {
            C[i][j] = C[i - 1][j - 1] + C[i - 1][j];
            if (C[i][j] >= M) {
                C[i][j] -= M;
            }
        }
    }
    std::vector<int>c(3);
    for (int i = 0; i < n; ++i) {
        int a; std::cin >> a;
        c[a % 3]++;
    }
    if (c[0] == n) {
        std::cout << "0\n";
        return;
    }
    if (n == 1) {
        if (c[0] == 0) {
            std::cout << "1\n";
        } else {
            std::cout << "0\n";
        }
        return;
    }
    ll ans = 0;
    if (c[1] == c[2] + 2 || c[1] == c[2] + 1) {
        ans += C[n - 1][c[0]];
    }
    if (c[2] == c[1] + 2 || c[2] == c[1] + 1) {
        ans += C[n - 1][c[0]];
    }
    ans %= M;
    ll pr = 1;
    for (ll i = 1; i <= n; ++i) {
        pr *= i; pr %= M;
        if (i == c[1]) {
            ans *= pr;
            ans %= M;
        }
        if (i == c[2]) {
            ans *= pr;
            ans %= M;
        }
        if (i == c[0]) {
            ans *= pr;
            ans %= M;
        }
    }
    std::cout << ans << '\n';
}

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    int t = 1;

    while (t--) {
        solve();
    }

    return 0;
}
