#include <iostream>

using namespace std;

using ll = long long;
const ll MOD = 1000000007;

ll C[5000][5000];

int main()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) C[0][i] = 0;
    for (int i = 0; i < n; i++) C[i][0] = 1;
    for (int i = 1; i < n; i++) for (int j = 1; j < n; j++) C[i][j] = (C[i - 1][j - 1] + C[i - 1][j])%MOD;

    ll ans = 1;
    for (int k = 1; k < n; k++)
    {
        ll sum = 0;
        for (int i = 1; i <= (k + 1)/2; i++)
        {
            sum += (C[k][i]*C[k - i][k + 1 - 2*i])%MOD;
            sum %= MOD;
        }
        ans *= sum;
        ans %= MOD;
    }
    cout << ans;
    return 0;
}
