#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>

using namespace std;

using ll = long long;

struct MyPair
{
    ll a, b;

    MyPair()
    {
        a = 0;
        b = 0;
    }

    ll& operator[](int i)
    {
        if (i == 0) return a;
        else return b;
    }

    ll mmm()
    {
        return max(a, b);
    }
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    set<pair<ll, ll>> st;
    int ax[2];
    int ay[2];
    ax[0] = ax[1] = ay[0] = ay[1] = 0;
    map<ll, MyPair> mx;
    map<ll, MyPair> my;

    while(n--)
    {
        ll x, y;
        cin >> x >> y;
        int d;
        if (st.find({x, y}) == st.end())
        {
            d = 1;
            st.insert({x, y});
        }
        else
        {
            d = -1;
            st.erase({x, y});
        }

        ax[x%2] -= mx[x].mmm();
        mx[x][y%2] += d;
        ax[x%2] += mx[x].mmm();

        ay[y%2] -= my[y].mmm();
        my[y][x%2] += d;
        ay[y%2] += my[y].mmm();

        cout << max(max(ax[0], ax[1]), max(ay[0], ay[1])) << '\n';
    }
    return 0;
}
