#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define int long long

typedef pair<int, int> pii;

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}
template<typename T>
ostream &operator <<(ostream &in, vector<T> &arr) {
    for (auto &i : arr) in << i << " ";
    return in;
}

const int maxn = 2e5 + 10;

vector<int> g[maxn];
map<int, pii> d1[maxn], d2[maxn];
int mn[maxn];

int dfs(int v, int p) {

    int d = 0; mn[v] = 1e18;
    for (auto i : g[v]) {
        if (i != p) {
            d = dfs(i, v);

            if (sz(d1[i]) > sz(d1[v])) {
                swap(d1[i], d1[v]);
                swap(d2[i], d2[v]);
            }

            for (auto [j, x] : d1[i]) {
                if (d1[v][j] < x) {
                    if (d1[v][j].ss != x.ss) d2[v][j] = d1[v][j];
                    d1[v][j] = x;
                }
            }

            for (auto [j, x] : d2[i]) {
                if (d2[v][j] < x && d1[v][j].ss != x.ss) d2[v][j] = x;
            }
            mn[v] = min(mn[v], mn[i] + 1);
        }
    }
    if (d == 0) mn[v] = 0;

    int ans = (d != 0);
    for (auto i : g[v]) {
        if (i == p) continue;

        ans = max(ans, d1[v][d - 1].ff);

        int x = d - mn[i] - 1;
        if (d1[v][x].ff == 0 || x <= 0) continue;

        if (d1[v][x].ss == i) {
            if (d2[v][x].ss == i) continue;
            ans = max(ans, d2[v][x].ff + 1);
        } else {
            ans = max(ans, d1[v][x].ff + 1);
        }
    }

    vector<int> ky;
    for (auto [j, x] : d1[v]) ky.pb(j);

    for (auto i : ky) {
        d1[v][i].ss = d2[v][i].ss = v;
    }
    d1[v][d] = d2[v][d] = {ans, v};

    return d + 1;
}

void solve() {
    int n; cin >> n;

    for (int i = 1; i < n; i++) {
        int a; cin >> a;
        a--;

        g[a].pb(i);
        g[i].pb(a);
    }

    int a = dfs(0, 0);

    cout << d1[0][a - 1].ff << "\n";
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int tt = 1;
    //cin >> tt;

    while (tt--) {
        solve();
    }
}