#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define int long long

typedef pair<int, int> pii;

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}
template<typename T>
ostream &operator <<(ostream &in, vector<T> &arr) {
    for (auto &i : arr) in << i << " ";
    return in;
}

int ask(int x) {
    cout << "? " << x << endl;
    cin >> x;
    return x;
}

int binpow(int x, int y) {
    if (y == 0) return 1;
    if (y % 2 == 1) return x * binpow(x, y - 1);
    int a = binpow(x, y / 2);
    return a * a;
}

void solve() {
    int n;
    cin >> n;
    int l = 0;
    int r = 1e9 * 2023 + 10;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        int x = ask(mid);
        if (x >= n + 1) r = mid;
        else l = mid;
    }
    int d1 = r;
    //cout << d1 << endl;
    l = 0;
    r = 1e9 * 2023 * 2023 + 10;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        int x = ask(mid);
        if (x >= n + 2) r = mid;
        else l = mid;
    }
    int d2 = r;
    //cout << d2 << endl;
    int ans = -1;
    for (int b = 1; b <= 2023; b++) {
        if (binpow(b, n + 1) - binpow(b, n) == d2 - d1) {
            ans = b;
            break;
        }
    }
    cout << "! " << binpow(ans, n) - d1 << ' ' << ans << endl;
}

int32_t main() {
/*
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
*/
    int tt = 1;
    //cin >> tt;

    while (tt--) {
        solve();
    }
}
