
#include <bits/stdc++.h>
#define int ll
#define F first
#define S second

using namespace std;

typedef long long ll;
const int N = 1e5 + 10;
const int mod = 1e9 + 7;

int fac[N * 2];

ll bin_pow(int a , int b)
{
    ll ans = 1;
    while(b != 0)
    {
        if(b % 2)
        {
            ans *= a;
            ans %= mod;
        }
        a *= a;
        a %= mod;
        b /= 2;
    }
    return ans;
}

ll dive(int a , int b)
{
    return a * bin_pow(b , mod - 2) % mod;
}

ll C(int x , int y)
{
    return dive(fac[x] , fac[y] * fac[x - y] % mod);
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef LOCAL

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
    int n;
    cin >> n;
    int a[n];
    ll k[3];
    fill(k , k + 3 , 0);
    map <int , int> mp[3];
    for(int i = 0;i < n;++ i)
    {
        cin >> a[i];
        k[a[i] % 3] ++;
        mp[a[i] % 3][a[i]] ++;
    }
    fac[0] = 1;
    for(int i = 1;i < n + n;++ i)
    {
        fac[i] = fac[i - 1] * i;
        fac[i] %= mod;
    }
    if(k[1] + 1 != k[2] && k[2] + 1 != k[1])
    {
        cout << 0;
        return 0;
    }
    ll ans = fac[k[1]] * fac[k[2]] % mod;
    for(auto to : mp[1])
    {
        ans = dive(ans , fac[to.S]);
    }
    for(auto to : mp[2])
    {
        ans = dive(ans , fac[to.S]);
    }
    //cout << ans << endl;
    ll x = (k[1] + k[2]);
    ans *= C(x + k[0] - 1 , x - 1);
    ans %= mod;
    for(auto to : mp[0])
    {
        ans = dive(ans , fac[to.S]);
    }
    cout << ans;
    return 0;
}
