#include "bits/stdc++.h"

using namespace std;

using ll = long long;
using ld = long double;
//using pi = pair<int, int>;
//using pl = pair<ll, ll>;
//using vi = vector<int>;
//using vl = vector<ll>;
//using vp = vector<pi>;
//using vpl = vector<pl>;
//#define f first
//#define s second

vector<vector<int>> gr;
vector<int> deep;
vector<int> ans;
vector<int> d_fin;
vector<int> min_d;

void dfs0(int v, int p)
{
    deep[v] = deep[p] + 1;
    if(gr[v].size() == 0)
    {
        min_d[v] = deep[v];
    }
    for(auto u : gr[v])
    {
        dfs0(u, v);
        min_d[v] = min(min_d[v], min_d[u]);
    }
}

void dfs(int v)
{
    bool fl = false;
    if(deep[v] == d_fin[v])
    {
        fl = true;
    }
    for(auto u : gr[v])
    {
        ans[u] = ans[v];
        d_fin[u] = d_fin[v];
        if(fl)
        {
            ans[u] = ans[v] + 1;
            d_fin[u] = min_d[v];
        }
        dfs(u);
    }
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);

    int n;
    cin >> n;
    gr.resize(n);
    deep.resize(n);
    ans.resize(n);
    d_fin.resize(n);
    min_d.resize(n, 1e9);

    for(int i = 1; i < n; ++i)
    {
        int p;
        cin >> p;
        --p;
        gr[p].push_back(i);
    }

    dfs0(0, 0);
    d_fin[0] = min_d[0];
    dfs(0);

    int otv = 0;

    for(int i = 0; i < n; ++i)
    {
        otv = max(ans[i], otv);
    }
    cout << otv + 1 << '\n';


}
/*
5
1 1 0 0 0
9 1 0 0 0
0 0 9 9 0
0 0 9 0 1
0 0 0 1 9

6 9 2
3 5 7
8 1 4
 */