#include <bits/stdc++.h>
using namespace std;

#define vc vector
#define all(a) a.begin(), a.end()
#define FOR(i, a, b) for (int i = a; i < b; ++i)

#define int long long
const int mod = 1e9 + 7;
const int N = 1052;
int f[N], inv[N];

int bin_pow (int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = res * a % mod;
        a = a * a % mod;
        b >>= 1;
    }
    return res;
}

int C (int n, int k) {
    return f[n] * inv[k] % mod * inv[n - k] % mod;
}
int add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}
int mul(int a, int b) {
    return (1ll * a * b) % mod;
}
int dp[N][N];
void solve_case() {
    int n;
    cin >> n;
    dp[0][0] = 1;
    for (int i = 0; i < n - 1; ++i) {
        for (int j = 0; j <= n; ++j) {
            for (int t = 0; t <= 2; ++t) {
                if (j + t > n)
                    break;
                dp[i + 1][j + t] += dp[i][j];
                dp[i + 1][j + t] %= mod;
            }
        }
    }
    int ans = 1;
    for (int i = 1; i < n; ++i) {
        ans *= dp[i][i + 1];
        ans %= mod;
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int tc = 1; //cin >> tc;
    while (tc--) solve_case();
}
