#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937_64 generator(seed);
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using i128 = __int128;
using ll = long long;
using ld = long double;
#define int ll
const int MOD = (int)1e9+7;

int C[5001][5001];

void solve() {
    for(int i = 0; i <= 5000; ++i) C[i][0] = 1;
    for(int n = 1; n <= 5000; ++n){
        for(int k = 1; k <= n; ++k){
            C[n][k] = C[n-1][k-1] + C[n-1][k];
            C[n][k] %= MOD;
        }
    }
    int n;
    cin>>n;
    vector<int> dp(n+1);
    dp[n] = 1;
    for(int i = n-1; i >= 1; --i){
        dp[i] = dp[i+1];
        ll cnt = 0;
        for(int x = 0; x < i; ++x){
            if((i+1-x) % 2 == 0){
                ll a = 1;
                a *= C[i][x];
                a %= MOD;
                a *= C[i-x][(i+1-x)/2];
                a %= MOD;
                cnt += a;
                cnt %= MOD;
            }
        }
        dp[i] *= cnt;
        dp[i] %= MOD;
    }
    cout << dp[1];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(6);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin>>t;
    while (t--) solve();
    //stress();
}