#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937_64 generator(seed);
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using i128 = __int128;
using ll = long long;
using ld = long double;
#define int ll

bool check(vector<vector<int>> v, pair<int, int> a1, pair<int, int> a4, int n, int a) {
    swap(v[a1.first][a1.second], v[a4.first][a4.second]);
    for (int i = 0; i < n; ++i) {
        ll sum = 0;
        ll sum1 = 0;
        for (int j = 0; j < n; ++j) {
            sum += v[i][j];
            sum1 += v[j][i];
        }
        if (sum != a || sum1 != a) return false;
    }
    return true;
}

void solve() {
    ll n;
    cin >> n;
    vector<vector<int>> v(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> v[i][j];
        }
    }
    ll a = n * (n * n + 1) / 2;
    vector<int> vert;
    vector<int> hor;
    for (int i = 0; i < n; ++i) {
        ll sum = 0;
        ll sum1 = 0;
        for (int j = 0; j < n; ++j) {
            sum += v[i][j];
            sum1 += v[j][i];
        }
        if (sum != a) hor.push_back(i);
        if (sum1 != a) vert.push_back(i);
    }
    for (auto x1: hor) {
        for (auto y1: vert) {
            for (auto x2: hor) {
                for (auto y2: vert) {
                    if (check(v, {x1, y1}, {x2, y2}, n, a)) {
                        cout << x1 + 1 << " " << y1 + 1 << "\n" << x2 + 1 << " " << y2 + 1;
                        return;
                    }
                }
            }
        }
    }
    if(vert.empty()){
        for(int i = 0; i < n; ++i){
             if(check(v, {hor[0], i}, {hor[1], i}, n, a)){
                 cout << hor[0]+1 << " " << i+1 << "\n" << hor[1]+1 << " " << i+1;
                 return;
             }
        }
    }
    for(int i = 0; i < n; ++i){
        if(check(v, {i, vert[0]}, {i, vert[1]}, n, a)){
            cout << i+1 << " " << vert[0]+1 << "\n" << i+1 << " " << vert[1]+1;
            return;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(6);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin>>t;
    while (t--) solve();
    //stress();
}