#include <bits/stdc++.h>

#define int long long
#define ld long double
using namespace std;

constexpr int mod = 1e9 + 7;
constexpr int N = 1100, K = 48;
int pref[N + 1][K], suff[N + 1][N + 1], segment[N + 1][N + 1];

int add(int x, int y) {
    return x + y < mod ? x + y : x + y - mod;
}

int mul(int x, int y) {
    return (x * y) % mod;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    // pref[sum][last]
    pref[0][0] = 1;
    for (int sum = 0; sum <= n; sum++)
        for (int cur = 0; cur < K; cur++)
            if (sum >= cur)
                pref[sum][cur] = add(pref[sum - cur][cur], pref[sum - cur][cur - 1]);
    // suff[sum][last]
    for (int meow = 0; meow <= n; meow++)
        suff[meow][meow] = 1;
    //for (int meow = 0; meow <= n; meow++)
    //suff[0][meow] = 1;
    for (int sum = 0; sum <= n; sum++) {
        for (int cur = 0; cur <= n; cur++) {
//            suff[sum][cur] = suff[sum - cur][was](was >= cur);
            if (sum >= cur)
                suff[sum][cur] = add(suff[sum][cur], segment[sum - cur][cur]);
        }
        segment[sum][n] = suff[sum][n];
        for (int cur = n - 1; cur >= 0; cur--)
            segment[sum][cur] = add(segment[sum][cur + 1], suff[sum][cur]);
    }
//    for (int i = 0; i <= n; i++) {
//        for (int j = 0; j < K; j++)
//            cout << pref[i][j] << ' ';
//        cout << endl;
//    }
//    cout << endl;
//    for (int i = 0; i <= n; i++) {
//        for (int j = 0; j <= n; j++)
//            cout << suff[i][j] << ' ';
//        cout << endl;
//    }
    int ans = 0;
    for (int mex = 1; mex < K; mex++) {
        for (int sum = 0; sum <= n; sum++) {
            if (sum == n) {
                ans = add(ans, mul(mex, pref[sum][mex - 1]));
                //cout << "ERR " << endl;
                //cout << mex << ' ' << sum << endl;

            } else {
                for (int last = mex + 1; last <= n - sum; last++) {
                    ans = add(ans, mul(mex, mul(pref[sum][mex - 1], suff[n - sum][last])));
//                    cout << mex << ' ' << sum << ' ' << last << ": "
//                         << mul(mex, mul(pref[sum][mex - 1], suff[n - sum][last])) << endl;
                }
            }
        }
    }
    cout << ans;
    return 0;
}
