#include "bits/stdc++.h"

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    // freopen("input", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}

ll ask(ll ind, string h) {
    cout << "? " << ind << ' ' << h << endl;
    ll x;
    cin >> x;

    return x;
}

void solve() {
    ll n;
    cin >> n;

    vector<char> ans(n + 1, '-');

    for (ll trio = 0; trio < n / 3; ++trio) {
        ll nach = trio * 3;
        ll fir = ask(nach + 1, "ab");

        if (fir == 2) {
            ans[nach + 1] = 'a';
            ans[nach + 2] = 'b';

            if (ask(nach + 2, "ba") == 2) {
                ans[nach + 3] = 'a';
            }
            else if (ask(nach + 2, "bb") == 2) {
                ans[nach + 3] = 'b';
            }
            else {
                ans[nach + 3] = 'c';
            }
        }
        else if (fir == 1) {
            // possible - aa/ac/bb/cb

            ll x = ask(nach + 2, "ba");
            ll y = ask(nach + 2, "bb");

            if (x == y) {
                ans[nach + 3] = 'c';
            }
            else if (x > y) {
                ans[nach + 3] = 'a';
            }
            else {
                ans[nach + 3] = 'b';
            }

            if (min(x, y) == 1) {
                ans[nach + 2] = 'b';

                if (ask(nach + 1, "bb") == 2) {
                    ans[nach + 1] = 'b';
                }
                else {
                    ans[nach + 1] = 'c';
                }
            }
            else {
                ans[nach + 1] = 'a';

                if (ask(nach + 1, "aa") == 2) {
                    ans[nach + 2] = 'a';
                }
                else {
                    ans[nach + 2] = 'c';
                }
            }
        }
        else {
            // fir = 0

            ll sec = ask(nach + 1, "bc");

            if (sec == 2) {
                ans[nach + 1] = 'b';
                ans[nach + 2] = 'c';

                if (ask(nach + 2, "ca") == 2) {
                    ans[nach + 3] = 'a';
                }
                else if (ask(nach + 2, "cb") == 2) {
                    ans[nach + 3] = 'b';
                }
                else {
                    ans[nach + 3] = 'c';
                }
            }
            else if (sec == 1) {
                // possible - ba/cc
                ll thir = ask(nach + 2, "aa");

                if (thir == 2) {
                    ans[nach + 1] = 'b';
                    ans[nach + 2] = 'a';
                    ans[nach + 3] = 'a';
                }
                else if (thir == 1) {
                    // possible ba(b/c) or cca
                    ll forth = ask(nach + 2, "ab");

                    if (forth == 2) {
                        ans[nach + 1] = 'b';
                        ans[nach + 2] = 'a';
                        ans[nach + 3] = 'b';
                    }
                    else if (forth == 1) {
                        ans[nach + 1] = 'b';
                        ans[nach + 2] = 'a';
                        ans[nach + 3] = 'c';
                    }
                    else {
                        ans[nach + 1] = 'c';
                        ans[nach + 2] = 'c';
                        ans[nach + 3] = 'a';
                    }
                }
            }
            else {
                // sec = 0
                ans[nach + 1] = 'c';
                ans[nach + 2] = 'a';

                if (ask(nach + 2, "aa") == 2) {
                    ans[nach + 3] = 'a';
                }
                else if (ask(nach + 2, "ab") == 2) {
                    ans[nach + 3] = 'b';
                }
                else {
                    ans[nach + 3] = 'c';
                }
            }
        }
    }

    if (n % 3 == 1) {
        ll nach = n / 3;
        nach *= 3;

        string now = "";
        now += ans[nach];

        if (ask(nach, now + 'a') == 2) {
            ans[nach + 1] = 'a';
        }
        else if (ask(nach, now + 'b') == 2) {
            ans[nach + 1] = 'b';
        }
        else {
            ans[nach + 1] = 'c';
        }
    }
    else if (n % 3 == 2) {
        ll nach = n / 3;
        nach *= 3;

        ll fir = ask(nach + 1, "aa");

        if (fir == 2) {
            ans[nach + 1] = 'a';
            ans[nach + 2] = 'a';
        }
        else if (fir == 1) {
            ll sec = ask(nach + 1, "ab");

            if (sec == 2) {
                ans[nach + 1] = 'a';
                ans[nach + 2] = 'b';
            }
            else if (sec == 1) {
                ans[nach + 1] = 'a';
                ans[nach + 1] = 'c';
            }
            else {
                ll thir = ask(nach + 1, "ba");

                if (thir == 2) {
                    ans[nach + 1] = 'b';
                    ans[nach + 2] = 'a';
                }
                else {
                    ans[nach + 1] = 'c';
                    ans[nach + 2] = 'a';
                }
            }
        }
        else {
            // fir = 0

            ll sec = ask(nach + 1, "cc");

            if (sec == 2) {
                ans[nach + 1] = 'c';
                ans[nach + 2] = 'c';
            }
            else if (sec == 1) {
                if (ask(nach + 1, "bc") == 2) {
                    ans[nach + 1] = 'b';
                    ans[nach + 2] = 'c';
                }
                else {
                    ans[nach + 1] = 'c';
                    ans[nach + 2] = 'b';
                }
            }
            else {
                ans[nach + 1] = 'b';
                ans[nach + 2] = 'b';
            }
        }
    }

    cout << "! ";
    for (ll i = 1; i <= n; ++i) cout << ans[i];
    cout << endl;
}

/*
 *
7
? 1 ab
0
? 1 bc
0
? 2 aa
1
? 2 ab
0
? 4 ab
1
? 5 ba
0
? 5 bb
1
? 4 aa
2
? 6 ba
1
? 6 bb
2
! cacaabb
 */