#include <iostream>
#include <vector>


using namespace std;

const int M = 1000000007;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    long long n;
    cin >> n;
    int a0 = 0;
    int a1 = 0;
    int a2 = 0;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (x % 3 == 0) {
            a0 += 1;
        } else if (x % 3 == 1) {
            a1 += 1;
        } else {
            a2 += 1;
        }
    }
    // cout << a1;
    vector <vector<long long>> dp(2, vector<long long>(n, 0));
    dp[0][0] = a1;
    dp[1][0] = a2;
    for (int i = 1; i < a1 + a2; i++) {
        if (i % 2) {
            if ((a2 - (i + 1) / 2) > 0) {
                dp[0][i] = dp[1][i - 1] * (a2 - (i + 1) / 2);
                dp[0][i] %= M;
            }
            if (a1 - (i + 1) / 2 > 0) {
                dp[1][i] = dp[0][i - 1] * (a1 - (i + 1) / 2);
                dp[1][i] %= M;
            }
        } else {
            if ((a2 - (i) / 2) + 1 > 0) {
                dp[0][i] = dp[1][i - 1] * (a2 - (i) / 2 + 1);
                dp[0][i] %= M;
            }
            if (a1 - (i) / 2 + 1 > 0) {
                dp[1][i] = dp[0][i - 1] * (a1 - (i) / 2 + 1);
                dp[1][i] %= M;
            }
        }
    }
//    for (int i = 0; i < 2; i++) {
//        for (int j = 0; j < n; j++) {
//            cout << dp[i][j] << " ";
//        }
//        cout << "\n";
//    }
    // cout << dp[0][n - 1] << " " << dp[1][n - 1];
    long long ans = dp[0][a1 + a2 - 1] + dp[1][a1 + a2 - 1];
    for (int i = 0; i < a0; i++) {
        ans = (ans * (a1 + a2)) % M;
    }
    cout << ans;
}