#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,strict-overflow")
#pragma GCC target("sse4.2,avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif
using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pdd = pair<double, double>;
using pii = pair<int, int>;

#define int long long

#define inf 1'000'001'000

int n;
vector<vector<int>> l;

vector<int> dist(300000, inf);

void dfs1(int now) {
    //cout << now << " ahah\n";
    if (l[now].size() == 0) dist[now] = 0;
    for (int i : l[now]) {
        dfs1(i);
        dist[now] = min(dist[now], dist[i] + 1);
    }
}
int ans = 0;

void dfs2(int now, int needDist, int curAns) {
    //cout << now << " " << needDist << " ahah\n";
    if (l[now].size() == 0){
        ans = max(ans, curAns);
        return;
    }
    for (int i : l[now]) {
        int needDist2 = needDist - 1;
        int curAns2 = curAns;
        if (needDist2 == -1) {
            needDist2 = dist[i];
            curAns2++;
        }
        dfs2(i, needDist2, curAns2);
    }

}



signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    cin >> n;
    l = vector<vector<int>>(n);
    for (int i = 1; i < n; i++) {
        int a;
        cin >> a;
        a--;
        l[a].push_back(i);
    }
    dfs1(0);
    dfs2(0, dist[0], 0);
    cout << ans + 1;
}
