#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> cnt(3, 0);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        cnt[x % 3]++;
    }
    if (cnt[1] > cnt[2]) {
        if (cnt[1] - cnt[2] > 2) {
            cout << 0;
            return 0;
        }
    } else {
        if (cnt[2] - cnt[1] > 2 || cnt[2] == cnt[1]) {
            cout << 0;
            return 0;
        }
    }
    int k = cnt[1] + cnt[2];
    ll res = 1;
    for (ll i = k; i < k + cnt[0]; i++)
        res = (res * i) % MOD;
    for (ll i = 1; i <= cnt[1]; i++)
        res = (res * i) % MOD;
    for (ll i = 1; i <= cnt[2]; i++)
        res = (res * i) % MOD;
    cout << res << "\n";
    return 0;
}
