#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = 1e9 + 7;

ll ans = 0;

void reCursion(ll a, ll l, ll mexnow) {
    if (a == 0) {
        if (mexnow == -1) {
            ans += l + 1;
            ans %= MOD;
        } else {
            ans += mexnow;
            ans %= MOD;
        }
        return;
    }
    if (a < 0) return;
    if (l == -1) {
        for (ll i = 1; i <= a; ++i) {
            if (i >= 2) {
                reCursion(a - i, i, 1);
            } else {
                reCursion(a - i, i, mexnow);
            }
        }
    } else {
        for (ll i = l; i <= a; ++i) {
            if (mexnow == -1) {
                if (i - l >= 2) {
                    reCursion(a - i, i, l + 1);
                } else {
                    reCursion(a - i, i, mexnow);
                }
            } else {
                reCursion(a - i, i, mexnow);
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n; cin >> n;
    reCursion(n, -1, -1);
    cout << ans;
    return 0;

    return 0;
}
