#include <iostream>
#include <vector>
#include<cmath>
#include<algorithm>
#include<map>
#include<unordered_map>

using namespace std;

#define int long long
#define fir first
#define sec second
#define endl '\n'
#define pii pair<int,int>
#define all(u) u.begin(), u.end()
#define rall(u) u.rbegin(), u.rend()
#define pb push_back

const int MOD = 1e9 + 7, mod = 1e9 + 7;

int pow1(int a, int p) {
    if (p == 0) {
        return 1;
    }
    if (p % 2 == 0) {
        int now = pow1(a, p / 2);
        return now * now % mod;
    }
    int now = pow1(a, p - 1);
    return now * a % mod;
}

vector<int> f(1e6 + 1, 1), rf(1e6 + 1);

int c(int k, int n) {
    return f[n] * rf[k] % mod * rf[n - k] % mod;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    for (int i = 1; i <= 1e6; i++) {
        f[i] = f[i - 1] * i % mod;
    }
    for (int i = 0; i <= 1e6; i++) {
        rf[i] = pow1(f[i], mod - 2);
    }
    int n;
    cin >> n;

    vector<int> vc(n);

    vector<int> cnt(3);
    for (int i = 0; i < n; i++) {
        cin >> vc[i];
        cnt[vc[i] % 3]++;
    }

    if (abs(cnt[1] - cnt[2]) > 2) {
        cout << 0;
        return 0;
    }

    int ans = 0;
    if (cnt[1] - cnt[2] >= 1) {
        //cnt[1]--;
        int res = 1;
        for (int i = 2; i <= cnt[1]; i++) {
            res *= i;
            res %= MOD;
        }

        for (int i = 2; i <= cnt[2]; i++) {
            res *= i;
            res %= MOD;
        }

        res = res * f[cnt[0]] * c(cnt[0], cnt[0] + cnt[1] + cnt[2] - 1) % mod;
        ans += res;
        ans %= MOD;
        //cnt[1]++;
    }

    if (cnt[2] - cnt[1] >= 1) {
        //cnt[2]--;
        int res = 1;
        for (int i = 2; i <= cnt[1]; i++) {
            res *= i;
            res %= MOD;
        }

        for (int i = 2; i <= cnt[2]; i++) {
            res *= i;
            res %= MOD;
        }

        res = res * f[cnt[0]] % mod * c(cnt[0], cnt[0] + cnt[1] + cnt[2] - 1);
        ans += res;
        ans %= MOD;
    }

    cout << ans;
    return 0;
}