#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    out << a.first << ' ' << a.second;
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a)out << i << '\n';
    return out;
}

void solve() {
    int q;
    cin >> q;
    vector<map<ll, ll>> a{{},
                          {}};
    map<pair<ll, ll>, ll> mp;
    ll ans1 = 0;
    ll ans2 = 0;
    while (q--) {
        ll x, y;
        cin >> x >> y;
        bool exist = mp[{x, y}];
        mp[{x, y}] = !exist;
        x = x % 2;
        if (exist) {
            if (y % 2) {
                ans1 -= max(a[x][y], a[!x][y]);
                a[x][y] -= 1;
                ans1 += max(a[x][y], a[!x][y]);
            } else {
                ans2 -= max(a[x][y], a[!x][y]);
                a[x][y] -= 1;
                ans2 += max(a[x][y], a[!x][y]);
            }
        } else {
            if (y % 2) {
                ans1 -= max(a[x][y], a[!x][y]);
                a[x][y] += 1;
                ans1 += max(a[x][y], a[!x][y]);
            } else {
                ans2 -= max(a[x][y], a[!x][y]);
                a[x][y] += 1;
                ans2 += max(a[x][y], a[!x][y]);
            }
        }
        cout << max(ans1, ans2) << '\n';
    }
}

signed main() {
#ifdef Local
    freopen("in.in", "r", stdin);
    freopen("out.out", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    ll t = 1;
    //cin>>t;
    while (t--) solve();
}