#include<bits/stdc++.h>
#define ll long long

using namespace std;

ll n, MOD = 1e9 + 7, ans;

void input() {
    cin >> n;
}

ll BVS(ll tek, ll step) {
    if (step == 1) {
        return tek;
    }
    if (step == 0) {
        return 1;
    }
    if (step % 2 == 0) {
        return BVS((tek * tek) % MOD, step / 2);
    } else {
        return (BVS(tek, step - 1) * tek) % MOD;
    }
}

ll obr(ll x) {
    return BVS(x, MOD - 2);
}

void solve() {
    ans = 1;
    vector<vector<ll>> c(n + 1, vector<ll>(n + 1));
    vector<ll> fac(n + 1, 1), obrfac(n + 1, 1);
    for (ll i = 1; i < n + 1; i++) {
        fac[i] = (fac[i - 1] * i) % MOD;
    }
    for (ll i = 1; i < n + 1; i++) {
        obrfac[i] = obr(fac[i]);
    }
    for (ll i = 1; i <= n; i++) {
        for (ll j = 1; j <= n; j++) {
            c[i][j] = ((fac[i] * obrfac[j]) % MOD * obrfac[i - j]) % MOD;
            //cout << i << " " << j << " " << c[i][j];
        }
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(n + 1, 0));
    dp[1][1] = 1;
    dp[0][0] = 1;
    for (ll i = 2; i <= n; i++) {
        ll sum = 0;
        dp[i][i] = 1;
        for (ll j = i / 2 + i % 2; j < i; j++) {
            dp[i][j] += dp[i - 1][j - 1];
            dp[i][j] += dp[i - 2][j - 1];
            dp[i][j] %= MOD;
            //cout << i << " " << j << " " << dp[i][j] << " " << c[i - 1][j] << endl;
            sum += (dp[i][j] * c[i - 1][j]) % MOD;
            sum %= MOD;
        }
        ans *= sum;
        ans %= MOD;
    }
}

void output() {
    cout << ans;
}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();
    output();
    return 0;
}
