#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define str string
#define vc vector<char>
#define ret return
#define vll vector<ll>
#define pb push_back
#define all(x) x.begin(), x.end()
#define ba(x) x.back()
#define sll set<ll>
#define spll set<pair<ll,ll>>
#define en(x) x.end()
#define be(x) x.begin()
#define pll pair<ll,ll>
#define ins insert
#define sz(x) x.size()

template<typename T>
void amin(T &a, T b) {
    a = min(a, b);
}

template<typename T>
void amax(T &a, T b) {
    a = max(a, b);
}

ll mod = 1e9 + 7;

ll fpow(ll b, ll m) {
    ll ans = 1;
    ll x = b;
    while (m) {
        if (m & 1) ans *= x;
        ans %= mod;
        x *= x;
        x %= mod;
        m >>= 1;
    }
    return ans;
}

ll DEL(ll a, ll b) {
    return ((a % mod) * fpow((b % mod), (mod - 2))) % mod;
}

const int N = 2e5 + 5;
vector<int> g[N];
int s[N], mn[N];
deque<int> d[N];

void sizes(int v = 0) {
    s[v] = 1;
    if (!sz(g[v])) {
        mn[v] = 0;
        ret;
    }
    mn[v] = 1e9;
    for (auto &x: g[v]) {
        sizes(x);
        s[v] += s[x];
        amin(mn[v], mn[x] + 1);
    }
    sort(all(g[v]), [&](int &A, int &B) { ret (s[A] == s[B] ? A < B : s[A] > s[B]); });
}

void dfs(int v = 0) {
    if (!sz(g[v])) {
        d[v].push_front(0);
        return;
    }
    for (auto &x: g[v]) {
        dfs(x);
        if (x == g[v][0]) {
            swap(d[v], d[x]);
        } else {
            for (int i = 0; i < sz(d[x]); i++) {
                amax(d[v][i], d[x][i]);
            }
        }
    }
    d[v].push_front(d[v][mn[v] - 1] + 1);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].pb(i);
    }
    sizes();
    dfs();
    cout << d[0][0];
}
