#include<bits/stdc++.h>
using namespace std;

int mod = 1e9 + 7;

int add(int a, int b) {
    return a + b >= mod ? a +  b - mod : a + b;
}

int sub(int a, int b) {
    return a >= b ? a - b : a + mod - b;
}

int mul(int a, int b) {
    return 1ll * a * b % mod;
}

using ll = long long;

#define int ll

int binpow(int a, int n) {
    int res = 1;
    for (; n; n >>= 1) {
        if (n & 1) res = mul(res, a);
        a = mul(a, a);
    }
    return res;
}

struct segtree {
    int n;
    vector<int> tr;

    segtree() = default;
    segtree(int n) : n(n), tr(vector<int>(2 * n, -1e9)) {}

    void update(int k, int x) {
        for (tr[k += n] = x; k; k >>= 1, tr[k] = max(tr[k << 1], tr[k << 1 | 1]));
    }

    int get(int l, int r) {
        int res = 0;
        for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
            if (l & 1) res = max(res,tr[l++]);
            if (~r & 1) res = max(res,tr[r--]);
        }
        return res;
    }
};

int32_t main() {
//    cin.tie(0)->sync_with_stdio(0);

    int n;
    cin >> n;
    ll l = 0, r = 3 * pow(10, 12);
    while (r - l > 1) {
        ll m = (r + l) / 2;
        cout << "? " << m << endl;
        int x;
        cin >> x;
        if (x < n + 1) {
            l = m;
        } else {
            r = m;
        }
    }
    ll d1 = r;
    l = 0, r = 1e16;
    while (r - l > 1) {
        ll m = (r + l) / 2;
        cout << "? " << m << endl;
        int x;
        cin >> x;
        if (x < n + 2) {
            l = m;
        } else {
            r = m;
        }
    }
    ll d2 = r;
    ll xx = d2 - d1;
    ll b;
    for (int i = 2; i <= 2023; i++) {
        if (binpow(i, n) * (i - 1) == xx) {
            b = i;
            break;
        }
    }
    ll xxx = binpow(b, n) - d1;
    cout << "! " << xxx << ' ' << b << endl;
}