#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define f first
#define s second
#define pb push_back
#define nl endl
#define in insert
#define pb push_back

using namespace std;

typedef long long ll;

#define int long long

const int N = 2e5 + 100;
const int oo = 1e9 + 100;

struct tree {
    tree *L = NULL;
    tree *R = NULL;

    int l, r, mdl;

    int mx = -oo;

    tree(int _l, int _r) : l(_l), r(_r) {
        mdl = (l + r) >> 1;
        if (l == r) return;
        L = new tree(l, mdl);
        R = new tree(mdl + 1, r);
    }

    void upd(int x, int y) {
        mx = max(mx, y);
        if (l == r) return;
        if (x <= mdl) L -> upd(x, y);
        else R -> upd(x, y);
    }

    int get_mx(int _l, int _r) {
        if (_l > _r) return -oo;
        if (_l == l && _r == r) return mx;
        return max(L -> get_mx(_l, min(mdl, _r)), R -> get_mx(max(mdl + 1, _l), _r));
    }

};

tree *mx_vals[N];

int in[N];
int out[N];
int dep[N];
int t;
vector <pair<int, int> > max_dep[N];
vector <int> a[N];

vector <pair<int, int> > v[N];

void Rec(int x) {
    in[x] = t++;
    v[dep[x]].push_back({in[x], x});
    if (a[x].size() > 0) {
        for (auto i : a[x]) {
                Rec(i);
                max_dep[x].pb({max_dep[i].front().f + 1, i});
        }
        sort(max_dep[x].begin(), max_dep[x].end());
    } else {
        max_dep[x].pb({0, 0});
    }
    max_dep[x].resize(1);
    out[x] = t++;
}

void calc_dp(int x) {
    for (auto i : a[x])
        calc_dp(i);
    int dp = 0;
    if (a[x].size() > 0) {
        int dep1 = max_dep[x].front().f + dep[x];
        int l = lower_bound(v[dep1].begin(), v[dep1].end(), pair<int, int>(in[x], x)) - v[dep1].begin();
        int r = lower_bound(v[dep1].begin(), v[dep1].end(), pair<int, int>(out[x], x)) - v[dep1].begin() - 1;
        dp = mx_vals[dep1] -> get_mx(l, r) + 1;
    }
    int pos = lower_bound(v[dep[x]].begin(), v[dep[x]].end(), pair<int, int>(in[x], x)) - v[dep[x]].begin();
    mx_vals[dep[x]] -> upd(pos, dp);
}

main()
{
    ios_base::sync_with_stdio(0);
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        x--;
        a[x].pb(i);
        dep[i] = dep[x] + 1;
    }
    Rec(0);
    for (int i = 0; i < n; i++) {
        if (v[i].size() > 0) mx_vals[i] = new tree(0, v[i].size() - 1);
    }
    calc_dp(0);
    cout << mx_vals[0] -> get_mx(0, 0);
}
