#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;
typedef long long ll;

ll n;
vector <vector <ll>> a;
vector <ll> sumstr, sumst;

ll sum = 0, i1ans, j1ans, i2ans, j2ans;

bool check(int i1, int j1, int i2, int j2) {
	ll x = a[i1][j1], y = a[i2][j2];
	if (i1 == i2) {
		if (sumst[j1] - x + y == sum && sumst[j2] - y + x == sum) {
			i1ans = i1, j1ans = j1, i2ans = i2, j2ans = j2;
			return 1;
		}
	}
	else if (j1 == j2) {
		if (sumstr[i1] - x + y == sum && sumstr[i2] - y + x == sum) {
			i1ans = i1, j1ans = j1, i2ans = i2, j2ans = j2;
			return 1;
		}
	}
	else if (sumstr[i1] - x + y == sum && sumst[j1] - x + y == sum && sumstr[i2] - y + x == sum && sumst[j2] - y + x == sum) {
		i1ans = i1, j1ans = j1, i2ans = i2, j2ans = j2;
		return 1;
	}
	return 0;
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	cin >> n;
	sum = n * (n * n + 1) / 2;
	a.resize(n, vector <ll>(n));
	sumstr.resize(n), sumst.resize(n);
	for (int i = 0; i < n; i++) for (int j = 0; j < n; j++) cin >> a[i][j], sumstr[i] += a[i][j], sumst[j] += a[i][j];
	ll i1 = -1, i2 = -1, j1 = -1, j2 = -1;
	for (int i = 0; i < n; i++) {
		if (sumstr[i] != sum) {
			if (i1 == -1) i1 = i;
			else i2 = i;
		}
		if (sumst[i] != sum) {
			if (j1 == -1) j1 = i;
			else j2 = i;
		}
	}
	bool fl = 0;
	if (i1 == -1) {
		for (int i = 0; i < n; i++) {
			if (check(i, j1, i, j2)) { cout << i1ans + 1 << ' ' << j1ans + 1 << ' ' << i2ans + 1 << ' ' << j2ans + 1; return 0; }
		}
	}
	else if (j1 == -1) {
		for (int i = 0; i < n; i++) {
			if (check(i1, i, i2, i)) { cout << i1ans + 1 << ' ' << j1ans + 1 << ' ' << i2ans + 1 << ' ' << j2ans + 1; return 0; }
		}
	}
	else {
		if (check(i1, j1, i2, j2)) { cout << i1ans + 1 << ' ' << j1ans + 1 << ' ' << i2ans + 1 << ' ' << j2ans + 1; return 0; }
		if (check(i2, j1, i1, j2)) { cout << i1ans + 1 << ' ' << j1ans + 1 << ' ' << i2ans + 1 << ' ' << j2ans + 1; return 0; }
	}
	return 0;
}