#include <bits/stdc++.h>

constexpr int mod = 1e9 + 7;
int add(int a, int b) {
    return a + b - mod * (a + b >= mod);
}
int mul(int a, int b) {
    return a * 1ULL * b % mod;
}
int power(int b, int e) {
    int r = 1;
    for (; e > 0; e >>= 1) {
        if (e & 1)
            r = mul(r, b);
        b = mul(b, b);
    }
    return r;
}

constexpr int N = 1e3 + 5;

int dp[2 * N][2 * N];

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n;
    std::cin >> n;
    int ans = 0;
    for (int mx = 1; mx <= n + 1; mx++) {
        int cnt = n - mx * (mx - 1) / 2;
        if (cnt < 0) {
            continue;
        }
        if (cnt == 0) {
            ans = add(ans, mx);
            continue;
        }
        memset(dp, 0, sizeof(dp));
        dp[1][0] = 1;
        for (int i = 1; i <= cnt; i++) {
            for (int j = 0; j <= cnt; j++) {
                dp[i + 1][j] = dp[i][j];
                if (i != mx) {
                    dp[i][j + i] = add(dp[i][j + i], dp[i][j]);
                }
            }
        }
        int res = dp[cnt][cnt];
        ans = add(ans, mul(res, mx));
    }

    std::cout << ans << "\n";

    return 0;
}
