#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <queue>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using vint = vector<int>;
#define all(x) x.begin(), x.end()
#define rep(x) for(int ri = 0; ri < x; ++ri)
//#define int long long

const int INF = 2e9 + 7;
const long long LINF = 1e18 + 7;
const int MOD = 1e9 + 7;

vint g[200010], lvl[200010];
int mn[200010], tin[200010], tout[200010], ans[200010], timer = 0;
void dfs_mn(int v, int l) {
	lvl[l].push_back(v);
	tin[v] = timer++;
	if (!size(g[v])) {
		mn[v] = 0;
		return;
	}
	int ans = INF;
	for (int to : g[v]) {
		dfs_mn(to, l + 1);
		ans = min(ans, mn[to]);
	}
	tout[v] = timer;
	mn[v] = ans + 1;
}
void rec(int v, int ur) {
	if (!size(g[v]))
		return;
	int l = -1, r = size(lvl[ur + mn[v]]);
	while (l + 1 < r) {
		int mid = (l + r) / 2;
		if (tin[mid] <= tin[v])
			l = mid;
		else
			r = mid;
	}
	if (r >= size(lvl[ur + mn[v]])) {
		ans[v] = 1;
		return;
	}
	int to = lvl[ur + mn[v]][r];
	while (tout[to] < tout[v]) {
		rec(to, ur + mn[v]);
		ans[v] = max(ans[v], ans[to]);
	}
	ans[v]++;
}
signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	int n;
	cin >> n;
	vint p(n);
	for (int i = 1; i < n; ++i) {
		cin >> p[i];
		g[p[i] - 1].push_back(i);
	}
	dfs_mn(0, 0);
	rec(0, 0); // v;
	cout << ans[0];
}