#include <iostream>

#define int long long

int cntq = 0;

int ask(int x) {
    cntq++;
    if (cntq > 100) {
        exit(1);
    }
    std::cout << "? " << x << std::endl;
    int res;
    std::cin >> res;
    return res;
}

void ans(int x, int b) {
    std::cout << "! " << x << ' ' << b << std::endl;
    exit(0);
}

constexpr int inf = 2000000000000000000ll;

int pow(int a, int b) {
    int res = 1;
    while (b > 0) {
        if (b & 1) {
            res = res * a;
        }
        a = a * a;
        b >>= 1;
    }
    return res;
}

signed main() {
    int n;
    std::cin >> n;
    int l = 0;
    int r = 3000000000000ll;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (ask(mid) > n) {
            r = mid;
        } else {
            l = mid;
        }
    }
    int d1 = r;
    l = d1;
    r = 3000 * 3000000000000ll;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (ask(mid) > n + 1) {
            r = mid;
        } else {
            l = mid;
        }
    }
    int d2 = r;
    int b = 2;
    while (pow(b, n) * (b - 1) < d2 - d1) {
        b++;
    }
    int cd1 = pow(b, n);
    int x = cd1 - d1;
    ans(x, b);
    return 0;
}