#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    int n;
    std::cin >> n;
    std::set<std::pair<int, int>> s;
    std::vector<std::vector<int>> cnt(2, std::vector<int>(2));
    for (int i = 0; i < n; i++) {
        int x, y;
        std::cin >> x >> y;
        if (s.find({x, y}) != s.end()) {
            s.erase({x, y});
            cnt[x % 2][y % 2]--;
        } else {
            s.insert({x, y});
            cnt[x % 2][y % 2]++;
        }
        std::cout << std::max({cnt[0][0], cnt[0][1], cnt[1][0], cnt[1][1]}) << '\n';
    }
    return 0;
}