#include <algorithm>
#include <array>
#include <iostream>
#include <map>
#include <set>

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    int n;
    std::cin >> n;
    std::set<std::pair<int, int>> s;
    std::map<int, std::array<int, 2>> cntstr, cntcol;
    std::array<int, 2> sumstr, sumcol;
    sumstr.fill(0);
    sumcol.fill(0);
    for (int i = 0; i < n; i++) {
        int x, y;
        std::cin >> x >> y;
        sumstr[y % 2] -= std::max(cntstr[y][0], cntstr[y][1]);
        sumcol[x % 2] -= std::max(cntcol[x][0], cntcol[x][1]);
        if (s.find({x, y}) == s.end()) {
            cntstr[y][x % 2]++;
            cntcol[x][y % 2]++;
            s.insert({x, y});
        } else {
            cntstr[y][x % 2]--;
            cntcol[x][y % 2]--;
            s.erase({x, y});
        }
        sumstr[y % 2] += std::max(cntstr[y][0], cntstr[y][1]);
        sumcol[x % 2] += std::max(cntcol[x][0], cntcol[x][1]);
        std::cout << std::max({sumstr[0], sumstr[1], sumcol[0], sumcol[1]}) << '\n';
    }
    return 0;
}