#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <stack>
#include <set>

using namespace std;

#define ll long long
#define vll vector<ll>
#define pll pair<ll,ll>
#define FOR(i,a,b) for(ll i = (a); i < (b); ++i)
#define vvll vector<vll>


void speed()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

int main()
{
	ll n;
	cin >> n;
	vvll s(n, vll(n));
	vll sumg(n), sumv(n);
	ll sum = (n * n + 1) * n * n / 2;
	sum /= n;
	FOR(i, 0, n)
	{
		FOR(j, 0, n)
		{
			cin >> s[i][j];
			sumg[i] += s[i][j];
			sumv[j] += s[i][j];
		}
	}
	int i1 = -1, i2 = -1;
	int j1 = -1, j2 = -1;
	ll difg = 0, difv = 0;
	FOR(i, 0, n)
	{
		if (sumg[i] != sum)
		{
			if (i1 == -1) i1 = i;
			else 
			{
				i2 = i; 
				difg = (sumg[i2] - sumg[i1]) / 2;
			}
		}
		if (sumv[i] != sum)
		{
			if (j1 == -1) j1 = i;
			else
			{
				j2 = i; 
				difv = (sumv[j2] - sumv[j1]) / 2;
			}
		}
	}
	//cout << i1 << " " << i2 << " " << j1 << " " << j2 << "\n";
	//cout << difg << " " << difv << "\n";
	if (i1 != -1 && i2 != -1 && j1 != -1 && j2 != -1)
	{
		if (s[i2][j2] - s[i1][j1] == difv && s[i2][j2] - s[i1][j1] == difg)
		{
			cout << i1 + 1 << " " << j1 + 1 << "\n" << i2 + 1 << " " << j2 + 1;
		}
		else
		{
			cout << i1 + 1 << " " << j2 + 1 << "\n" << i2 + 1 << " " << j1 + 1;
		}
	}
	else if (i1 != -1 && i2 != -1)
	{
		FOR(i, 0, n)
		{
			if (s[i2][i] - s[i1][i] == difg)
			{
				cout << i1 + 1 << " " << i + 1 << "\n" << i2 + 1 << " " << i + 1;
			}
		}
	}
	else if (j1 != -1 && j2 != -1)
	{
		FOR(i, 0, n)
		{
			if (s[i][j2] - s[i][j1] == difv)
			{
				cout << i + 1 << " " << j1 + 1 << "\n" << i + 1 << " " << j2 + 1;
			}
		}
	}
	else
	{
		cout << 1 << " " << 1 << "\n" << 1 << " " << 1;
	}
}