#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define S second
#define F first
const int maxn = 2e5;
vector<int> g[maxn];
vector<int> byD[maxn];
int dp[maxn], leaf[maxn];

void dfs(int v) {
    if (g[v].empty()) {
        dp[v] = 0;
        leaf[v] = 0;
        byD[v] = {0};
        return;
    }
    leaf[v] = maxn + 10;
    for (const int& u : g[v]) {
        dfs(u);
        leaf[v] = min(leaf[v], leaf[u]);
        if ((int) byD[v].size() < (int) byD[u].size()) {
            byD[v].swap(byD[u]);
        }
        for (int i = 0; i < (int) byD[u].size(); ++i) {
            byD[v][i] = max(byD[v][i], byD[u][i]);
        }
        byD[u].clear();
    }
    ++leaf[v];
    byD[v].emplace_back();
    dp[v] = 1 + byD[v][(int)byD[v].size() - 1 - leaf[v]];
    byD[v].back() = dp[v];
    /*cerr << "v: " << v << ", " << leaf[v] << '\n';
    for (const int& i : byD[v]) {
        cerr << i << ' ';
    }
    cerr << '\n';*/
}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[p].emplace_back(i);
    }
    dfs(0);
    cout << dp[0] << '\n';
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
