#include <bits/stdc++.h>
using namespace std;

using i64 = long long;

int ask(i64 d) {
    cout << "? " << d << endl;
    int r;
    cin >> r;
    return r;
}

i64 get_root(i64 n, int k) {
    i64 l = 0, r = n + 1;
    while (r > l + 1) {
        i64 mid = (l + r) / 2;
        i64 ans = 1;
        for (int i = 0; i < k; i++) {
            if (LLONG_MAX / ans < mid) {
                ans = LLONG_MAX;
            } else {
                ans *= mid;
            }
        }
        if ((LLONG_MAX / ans) < mid - 1) {
            ans = LLONG_MAX;
        } else {
            ans *= mid;
        }
        if (ans <= n) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return l;
}

i64 my_pow(int n, int k) {
    i64 ans = 1;
    while (k--) {
        ans *= n;
    }
    return ans;
}

int main() {
    int n;
    cin >> n;
    i64 l1 = 0, r1 = 2050LL * int(1e9);
    // i64 l1 = 0, r1 = 17;
    while (r1 > l1 + 1) {
        i64 mid = (l1 + r1) / 2;
        int resp = ask(mid);
        if (resp > n) {
            r1 = mid;
        } else {
            l1 = mid;
        }
    }
    i64 l2 = 0, r2 = 2050LL * 2050LL * int(1e9);
    // i64 l2 = 0, r2 = 17;
    while (r2 > l2 + 1) {
        i64 mid = (l2 + r2) / 2;
        int resp = ask(mid);
        if (resp > n + 1) {
            r2 = mid;
        } else {
            l2 = mid;
        }
    }
    i64 b = get_root(r2 - r1, n - 1);
    i64 x = my_pow(b, n) - r1;
    cout << "! " << x << " " << b << endl;
}

