#include <bits/stdc++.h>
using namespace std;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }
    int S = n * (n * n + 1) / 2;
    vector<int> rows, cols;
    for (int i = 0; i < n; i++) {
        int cur = S;
        for (int j = 0; j < n; j++) {
            cur -= a[i][j];
        }
        if (cur != 0) {
            rows.push_back(i);
        }
    }
    for (int i = 0; i < n; i++) {
        int cur = S;
        for (int j = 0; j < n; j++) {
            cur -= a[j][i];
        }
        if (cur != 0) {
            cols.push_back(i);
        }
    }
    if (rows.empty()) {
        cout << "1 1 1 1\n";
        exit(0);
    }
    for (int x = 0; x < 2; x++) {
        for (int y = 0; y < 2; y++) {
            int x1 = rows[x], y1 = cols[y], x2 = rows[x ^ 1], y2 = cols[y ^ 1];
            vector<vector<int>> b = a;
            swap(b[x1][y1], b[x2][y2]);
            bool good = true;
            for (int i = 0; i < n; i++) {
                int cur = S;
                for (int j = 0; j < n; j++) {
                    cur -= b[i][j];
                }
                if (cur != 0) {
                    good = false;
                }
            }
            for (int i = 0; i < n; i++) {
                int cur = S;
                for (int j = 0; j < n; j++) {
                    cur -= b[j][i];
                }
                if (cur != 0) {
                    good = false;
                }
            }
            if (good) {
                cout << 1 + x1 << " " << 1 + y1 << "\n" << 1 + x2 << " " << 1 + y2 << "\n";
                exit(0);
            }
        }
    }
}
