#include <bits/stdc++.h>
using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

// ARGHHHHHHHHHHHHHHHH
#define int long long
// ARGHHHHHHHHHHHHHHHH

const ll mod = 1e9+7;

vector<ll> fact;

ll binpow(ll a, ll b) {
	ll r = 1, pw = a;
	for (; b > 0; b >>= 1) {
		if (b & 1) {
			r = (r * pw) % mod;
		}
		pw = (pw * pw) % mod;
	}
	return r;
}

ll rev(ll n) {
	return binpow(n, mod - 2);
}

ll cnk(ll n, ll k) {
	return fact[n] * rev(fact[k]) % mod * rev(fact[n - k]) % mod;
}

int32_t main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	int n;
	cin >> n;
	int a0 = 0, a1 = 0, a2 = 0;
	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		if (x % 3 == 0) a0++;
		else if (x % 3 == 1) a1++;
		else a2++;
	}

	fact.resize(2 * n + 100);
	fact[0] = 1;
	for (int i = 1; i < fact.size(); i++) {
		fact[i] = (fact[i - 1] * (ll)i) % mod;
	}

	ll ans = 0;
	if (a1 >= 1) {
		int s = 0, s1 = a1 - 1, s2 = a2;
		while (true) {
			if (s == 0) {
				if (s1 == 0) break;
				s1--;
			} else {
				if (s2 == 0) break;
				s2--;
			}
			s++;
			if (s == 2) s = 0;
		}
		if (s1 == 0 && s2 == 0) ans++;
//		(ans + fact[a1] * fact[a2]) % mod;
	}
	if (a2 >= 2) {
		int s = 0, s1 = a1, s2 = a2 - 2;
		while (true) {
			if (s == 0) {
				if (s1 == 0) break;
				s1--;
			} else {
				if (s2 == 0) break;
				s2--;
			}
			s++;
			if (s == 2) s = 0;
		}
		if (s1 == 0 && s2 == 0) ans++;
	} else if (a2 == 1 && a1 == 0) {
		ans++;
	}

//	cout << ans << "\n";
//	cout << a0 << " " << a1 << " " << a2 << "\n";

	ans = (ans * fact[a1] % mod * fact[a2]) % mod;
	if (a1 + a2 > 0 && a0 > 0) ans = (ans * cnk(a1 + a2 - 1 + a0, a0) % mod * fact[a0]) % mod;

	cout << ans;

	return 0;
}