#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int n;
vector<vector<int>> g;
vector<int> h, minh, mxd, vmxd;

void dfs(int v) {
    if (g[v].empty()) {
        minh[v] = 0;
        mxd[v] = 0;
        vmxd[v] = v;
    }
    for (int u : g[v]) {
        h[u] = h[v] + 1;
        dfs(u);
        minh[v] = min(minh[v], minh[u] + 1);
        if (mxd[u] + 1 > mxd[v]) {
            mxd[v] = mxd[u] + 1;
            vmxd[v] = u;
        }
        mxd[v] = max(mxd[v], mxd[u]);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    g.resize(n);
    h.resize(n, 0);
    minh.resize(n, 1e9);
    mxd.resize(n, 0);
    vmxd.resize(n, -1);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        g[p - 1].push_back(i);
    }

    int ans = 0;
    dfs(0);
//    for (int i = 0; i < n; i++) {
//        cout << i << " " << h[i] << " " << minh[i] << " " << mxd[i] << " " << vmxd[i] << endl;
//    }
//    return 0;


    int h_b = mxd[0];
    if (h_b == 0) {
        ans = 1;
        cout << 1;
        return 0;
    }
    int v = 0;
    while (true) {
        if (minh[v] == mxd[v]) {
            ans++;
            break;
        } else {
            ans++;
            for (int i = 0; i < minh[v]; i++) {
                v = vmxd[v];
            }
        }
    }
    cout << ans;
}
