#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int n;
vector<vector<int>> g;
vector<int> h, minh, dp, sz, mxd;
vector<deque<int>> dd;

void dfs(int v) {
    sz[v] = 1;
    if (g[v].empty()) {
        minh[v] = 0;
        dp[v] = 1;
        mxd[v] = 0;
        dd[v] = {1};
        return;
    }
    int ind = g[v][0];
    for (int u : g[v]) {
        h[u] = h[v] + 1;
        dfs(u);
        sz[v] += sz[u];
        minh[v] = min(minh[v], minh[u] + 1);
        mxd[v] = max(mxd[v], mxd[u] + 1);
        if (dd[ind].size() < dd[u].size()) ind = u;
    }
    swap(dd[v], dd[ind]);
    for (int u : g[v]) {
        if (u != ind) {
            for (int x = 0; x < dd[u].size(); x++) {
                dd[v][x] = max(dd[v][x], dd[u][x]);
            }
        }
    }
    if (mxd[v] == minh[v]) dp[v] = 1;
    else dp[v] = 1 + dd[v][minh[v] - 1];
    dd[v].push_front(dp[v]);
//    cout << "DFS " << v << "  ";
//    for (int x : dd[v]) cout << x << " ";
//    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    g.resize(n);
    h.resize(n, 0);
    minh.resize(n, 1e9);
    dp.resize(n, -1);
    sz.resize(n, 0);
    mxd.resize(n, -1);
    dd.resize(n, {});
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        g[p - 1].push_back(i);
    }

    dfs(0);
    cout << dp[0];
}
