#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int long long
const int MOD = 1e9 + 7;

int fastPow(int x, int p) {
    if (p == 0) return 1;
    if (p % 2 == 1) return fastPow(x, p - 1) * x % MOD;
    int q = fastPow(x, p / 2);
    return q * q % MOD;
}

vector<int> factorials, inv;

void build() {
    factorials.resize(1e4 + 100, 1);
    for (int i = 2; i < factorials.size(); i++) {
        factorials[i] = factorials[i - 1] * i % MOD;
    }
    inv.resize(1e4 + 100, 1);
    for (int i = 0; i < inv.size(); i++) inv[i] = fastPow(factorials[i], MOD - 2);
}

int Cnk(int n, int k) {
    return (factorials[n] * inv[k]% MOD * inv[n - k]) % MOD;
}

signed main() {
    int n;
    cin >>n;
    vector<int> dp(n);
    dp[0] = 1;
    build();
    for (int i = 1; i < n; i++) {
        for (int j = 1; j <= (i + 1) / 2; j++) {
            dp[i] = (dp[i] + (__int128_t) dp[i - 1] * Cnk(i, j) % MOD * Cnk(i - j, j - 1)) % MOD;
        }
    }
    cout << dp[n - 1];
}