#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(v) (int)v.size()
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef pair<int, int> pii;

const int MOD = 1e9 + 7;

void solve() {
    int n;
    cin >> n;

    vector<vector<int>> dp(n + 1, vector<int>(n + 1));
    dp[1][0] = 1;
    dp[1][1] = 1;
    dp[1][2] = 1;
    for (int i = 2; i < dp.size(); ++i) {
        dp[i][0] = 1;
        dp[i][1] = i;
        for (int j = 2; j < dp[i].size(); ++j)
            dp[i][j] = (dp[i - 1][j - 1] + dp[i - 1][j - 2] + dp[i - 1][j]) % MOD;
    }
    /*
    for (auto i : dp) {
        for (auto j: i)
            cout << j << " ";
        cout << endl;
    }
    */
    int ans = 1;
    for (int i = 1; i < n; ++i)
        ans = ans * dp[i][i + 1] % MOD;
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}