#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;

constexpr ll MOD = 1'000'000'007;

ll sum(ll a, ll b) {
    if (a + b >= MOD) {
        return a + b - MOD;
    }
    return a + b;
}

constexpr int maxn = 1e3 + 5;

int dpl[maxn][maxn], dpv[maxn][maxn], dpr[maxn][maxn];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i <= n + 3; ++i) {
        for (int j = 0; j <= n + 3; ++j) {
            dpl[i][j] = dpr[i][j] = 0;
        }
        dpr[i][0] = 1;
    }
    dpl[0][0] = 1;
    dpv[0][0] = 1;
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            dpl[i][j] = dpv[i - 1][j];
        }
        for (int j = 0; j + i <= n; ++j) {
            dpl[i][j + i] += dpl[i][j];
            if (dpl[i][j + i] >= MOD) {
                dpl[i][j + i] -= MOD;
            }
        }
        for (int j = 0; j <= n; ++j) {
            dpv[i][j] = dpl[i][j] - dpv[i - 1][j];
            if (dpv[i][j] < 0) {
                dpv[i][j] += MOD;
            }
        }
    }
    dpr[n + 1][0] = 1;
    for (int i = n; i > 0; --i) {
        for (int j = 0; j <= n; ++j) {
            dpr[i][j] = dpr[i + 1][j];
        }
        for (int j = 0; j + i <= n; ++j) {
            dpr[i][j + i] += dpr[i][j];
            if (dpr[i][j + i] >= MOD) {
                dpr[i][j + i] -= MOD;
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        for (int s = 0; s <= n; ++s) {
            ans += (i + 1) * 1LL * dpv[i][s] % MOD * dpr[i + 2][n - s] % MOD;
            if (ans >= MOD) {
                ans -= MOD;
            }
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
