#include <bits/stdc++.h>
using namespace std;

int n;
string s;

set<pair<int, int>> seg, bb;

void remseg(set<pair<int, int>>::iterator it) {
    int l = it->first, r = it->second;
    seg.erase(it);
    bb.erase({l, r});
}

void insseg(int l, int r) {
    seg.insert({l, r});
    if (s[l] == 'b' && s[r] == 'b')
        bb.insert({l, r});
}

int main() {
    cin >> n >> s;
    int q; cin >> q;
    int cnt = 1;
    for (int i = 1; i < n; i++) {
        if (s[i] == s[i - 1]) {
            insseg(i - cnt, i - 1);
            cnt = 0;
        }
        cnt++;
    }
    insseg(n - cnt, n - 1);
    while (q--) {
        int type; cin >> type;
        if (type == 1) {
            int i; cin >> i; i--;
            s[i] = 'a' + 'b' - s[i];
            auto it = seg.upper_bound({i, n}); it--;
            int l = it->first, r = it->second;
            if (l == r) {
                int nl = l, nr = r;
                if (it != seg.begin()) {
                    auto prv = it; prv--;
                    nl = prv->first;
                    remseg(prv);
                }
                auto nxt = it; nxt++;
                if (nxt != seg.end()) {
                    nr = nxt->second;
                    remseg(nxt);
                }
                remseg(it);
                insseg(nl, nr);
            } else if (i == l) {
                int nl = l, nr = l;
                if (it != seg.begin()) {
                    auto prv = it; prv--;
                    nl = prv->first;
                    remseg(prv);
                }
                remseg(it);
                insseg(nl, nr);
                insseg(nr + 1, r);
            } else if (i == r) {
                int nl = l, nr = l;
                auto nxt = it; nxt++;
                if (nxt != seg.end()) {
                    nr = nxt->second;
                    remseg(nxt);
                }
                remseg(it);
                insseg(nl, nr);
                insseg(l, nl - 1);
            } else {
                remseg(it);
                insseg(l, i - 1);
                insseg(i, i);
                insseg(i + 1, r);
            }
        } else {
            int l, r; cin >> l >> r; l--; r--;
            bool good = true;
            auto it = bb.lower_bound({l, 0});
            if (it != bb.end() && it->second <= r)
                good = false;
            auto il = seg.upper_bound({l, n}); il--;
            if (s[l] == 'b' && s[min(il->second, r)] == 'b')
                good = false;
            auto ir = seg.upper_bound({r, n}); ir--;
            if (s[r] == 'b' && s[max(ir->first, l)] == 'b')
                good = false;
            if (good) cout << "YES\n";
            else cout << "NO\n";
        }
    }
}
