#include<bits/stdc++.h>
using namespace std;
#define int long long
#define pb push_back
#define ff first
#define ss second

using vi = vector<int>;
using pi = pair<int, int>;
const int INF = 1e18;

const int M = 1e9 + 7;

int bpow(int a, int p) {
    if (p == 0) {
        return 1;
    }
    if (p == 1) {
        return a;
    }
    if (p % 2) {
        return a * bpow(a, p - 1) % M;
    }
    int x = bpow(a, p / 2);
    return x * x % M;
}

int C(int n, int k, vi& fac) {
    int ans = fac[n];
    ans *= bpow(fac[k], M - 2);
    ans %= M;
    ans *= bpow(fac[n - k], M - 2);
    ans %= M;
    //cout << ans << endl;
    return ans;
}

void solve() {
    int n; cin >> n;
    vi a(n);
    vi cnt(3, 0);
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        cnt[x % 3]++;
    }
    if (abs(cnt[1] - cnt[2]) != 1 && abs(cnt[1] - cnt[2]) != 2) {
        cout << 0 << endl;
        return;
    }
    vi fac(n + 1, 0);
    fac[0] = 1;
    for (int i = 1; i <= n; i++) {
        fac[i] = (fac[i - 1] * i) % M;
    }
    int ans = fac[cnt[0]];
    ans *= fac[cnt[1]];
    ans %= M;
    ans *= fac[cnt[2]];
    ans %= M;
    //cout << ans << endl;
    ans *= C(n - 1, cnt[0], fac);
    ans %= M;
    cout << ans << endl;
}

signed main() {
    solve();
}
