#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = ll(2e18) + 36;
#define int long long
int mod = 1e9 + 7;


struct Fast {
    int mul(int a, int b) {
        return 1ll * a * b % mod;
    }

    int add(int a, int b) {
        return (a + b < mod ? a + b : a + b - mod);
    }

    int sub(int a, int b) {
        return (a - b < 0 ? a - b + mod : a - b);
    }

    int binP(int a, ll n) {
        return (n ? n & 1 ? mul(a, binP(a, n - 1)) : mul(mul(a, a), binP(a, n / 2)) : 1);
    }

    void solve() {
        ll have;
        cin >> have;
        ll l = 0, r = 10;
        while (r - l > 1) {
            ll mid = (r + l) / 2;
            cout << "? " << mid << endl;
            ll ans;
            cin >> ans;
            if (ans > have) {
                r = mid;
            } else {
                l = mid;
            }
        }
        for (int b = 2; b <= 2023; b++) {
            ll num = binP(b, have);
            ll ish = num - r;
            ll cnt = 0;
            while (ish) {
                cnt++;
                ish /= b;
            }
            if (cnt == have) {
                cout << "! " << num - r << ' ' << b << endl;
                return;
            }
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int __ = 1;
    //cin>>__;
    while (__--) {
        auto s = Fast();
        s.solve();
    }
    return 0;
}