#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <string> 
#include <set>

using namespace std;
using ll = long long;

const int mod = 1e9 + 7;
const int N = 2e5 + 10;
vector<vector<int>> g;
int p[N], used[N], mnd[N], h[N], dp[N], dist[N], deg[N];

void dfs(int v) {
	if (g[v].empty()) {
		return;
	}
	mnd[v] = 1e9;
	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		dist[to] = dist[v] + 1;
		dfs(to);
		if (deg[to] > deg[g[v][0]]) {
			swap(g[v][0], g[v][i]);
		}
		deg[v] += deg[to];
		mnd[v] = min(mnd[v], mnd[to] + 1);
	}
}

void dfs1(int v, bool f) {
	for (int i = 1; i < g[v].size(); i++) {
		int to = g[v][i];
		dfs1(to, true);
	}
	if (!g[v].empty()) {
		dfs1(g[v][0], false);
	}
	for (int i = 1; i < g[v].size(); i++) {
		int to = g[v][i];
		dfs1(to, false);
	}
	h[dist[v]] = max(h[dist[v]], dp[v]);
	dp[v] = h[dist[v] + mnd[v]] + 1;
	if (f) {
		fill(h + dist[v], h + N, 0);
	}
}

int main() {
	ios_base::sync_with_stdio(0); //cin.tie(0);
	int n;
	cin >> n;
	g.resize(n);
	for (int i = 1; i <= n - 1; i++) {
		cin >> p[i];
		p[i]--;
		g[p[i]].push_back(i);
	}
	dist[0] = 0;
	dfs(0);
	dfs1(0, false);
	cout << dp[0];
}