#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<vector<int>> arr(n, vector<int>(n));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            cin >> arr[i][j];

    int sum = 0, mn = INT_MAX, mx = INT_MIN;
    for (int i = 0; i < 3; i++) {
        int buff = 0;
        for (int j = 0; j < n; j++) {
            buff += arr[i][j];
        }
        sum += buff;
        mn = min(mn, buff);
        mx = max(mx, buff);
    }

    sum -= mx + mn;

    int x1 = -1, x2 = -1, y1 = -1, y2 = -1;
    for (int i = 0; i < n; i++) {
        int buff = 0;
        for (int j = 0; j < n; j++) {
            buff += arr[i][j];
        }
        if (buff > sum)
            x1 = i;
        else if (buff < sum)
            x2 = i;
    }

    for (int i = 0; i < n; i++) {
        int buff = 0;
        for (int j = 0; j < n; j++) {
            buff += arr[j][i];
        }
        if (buff > sum)
            y1 = i;
        else if (buff < sum)
            y2 = i;
    }

    if (x1 != -1 && y1 != -1) {
        cout << x1 + 1 << ' ' << y1 + 1 << '\n';
        cout << x2 + 1 << ' ' << y2 + 1 << '\n';
    } else if (x1 == -1) {
        int d = 0;
        for (int i = 0; i < n; i++) {
            d += arr[i][y1] - arr[i][y2];
        }
        d /= 2;
        for (int i = 0; i < n; i++) {
            if (d == arr[i][y1] - arr[i][y2]) {
                cout << i + 1 << ' ' << y1 + 1 << '\n';
                cout << i + 1 << ' ' << y2 + 1 << '\n';
                return 0;
            }
        }
    } else {
        int d = 0;
        for (int i = 0; i < n; i++) {
            d += arr[x1][i] - arr[x2][i];
        }
        d /= 2;
        for (int i = 0; i < n; i++) {
            if (d == arr[x1][i] - arr[x2][i]) {
                cout << x1 + 1 << ' ' << i + 1 << '\n';
                cout << x2 + 1 << ' ' << i + 1 << '\n';
                return 0;
            }
        }
    }

    return 0;
}
