#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
using ll = long long;

const ll MOD = 1e9 + 7;

ll mul(ll a, ll b) {
	return a * b % MOD;
}

int main() {
	int n, el;
	int cnt[3];
	fill(cnt, cnt + 3, 0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> el;
		cnt[el % 3]++;
	}
	if ((abs(cnt[1] - cnt[2]) + 1) / 2 != 1) {
		cout << 0;
		return 0;
	}
	ll ans = 1;
	for (int i = 1; i <= max(cnt[1], cnt[2]); ++i) {
		if (i <= min(cnt[1], cnt[2])) {
			ans = mul(ans, i);
		}
		ans = mul(ans, i);
	}
	for (int i = cnt[1] + cnt[2]; i < cnt[0] + cnt[1] + cnt[2]; ++i) {
		ans = mul(ans, i);
	}
	cout << ans;

	return 0;
}
