#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = 1e9;

#define int long long
#define pi pair<int, int>
int cnt[10][10];

int bp(int a, int p, int mod) {
    if (p == 0) {
        return 1;
    }
    if (p & 1) {
        return bp(a, p - 1, mod) * a % mod;
    }
    int k = bp(a, p / 2, mod);
    return k * k % mod;
}

const int MOD = 1e9 + 7;

vector<int> F(100010);


ll C(ll n, ll k) {
//    n! / k! * (n - k)!
    ll x = F[k] * F[n - k];
    x %= MOD;
    //cout << n << " " << k << " " << x << endl;
    return (F[n] * bp(x, MOD - 2, MOD)) % MOD;
}

void solveH() {
    int n;
    cin >> n;
    vector<vector<int>> dp(n + 1, vector<int>(n + 1));
    dp[0][0] = 1;
    for (int j = 1; j <= n; j++) {
        for (int i = j; i <= n; i++) {
            for (int p = j; p <= i; p++) {
                dp[i][j] += dp[i - p][j - 1];
                dp[i][j] %= MOD;
            }
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= n; j++) {
            ans += dp[j][i - 1] * i;
            ans += dp[j][1];
        }
    }
}

void solveI() {
    set<pi > st;
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        if (st.count({x, y})) {
            st.erase({x, y});
            cnt[x & 1][y & 1]--;
        } else {
            st.insert({x, y});
            cnt[x & 1][y & 1]++;
        }
        cout << max(max(cnt[0][1], cnt[0][0]), max(cnt[1][0], cnt[1][1])) << "\n";
    }
}

//const int N = 1e6+9;
//struct node {
//    int sum, pref, suff, ans, sz;
//};
//node combine(node a, node b) {
//    node c;
//    c.sum = a.sum + b.sum;
//    c.sz = a.sz + b.sz;
//    c.pref = a.sum == a.sz ? a.sum + b.pref : a.pref;
//    c.suff = b.sum == b.sz ? b.sum + a.suff : b.suff;
//    c.ans = max(max(a.ans, b.ans), a.suff + b.pref);
//    return c;
//}
//node d[N];
//void make(int lx, int rx, int v, int pos, char c) {
//    if (rx - lx == 1) {
//        if (c == 'a') d[v] = {0, 0, 0, 0, 1};
//        else d[v] = {1, 1, 1, 1, 1};
//        return;
//    }
//    int m = (lx + rx) / 2;
//    if (pos < m) make(lx, m, 2 * v + 1, pos, c);
//    else make(m, rx, 2 * v + 2, pos, c);
//    d[v] = combine(d[2 * v + 1], d[2 * v + 2]);
//}
//node Z = {0, 0, 0, 0, 0};
//node get(int lx, int rx, int v, int l, int r) {
//    if (l >= rx || lx >= r) return Z;
//    if (l <= lx && rx <= r) return d[v];
//    int m = (lx + rx) / 2;
//    return combine(get(lx, m, 2 * v + 1, l, r), get(m, rx, 2 * v + 2, l, r));
//}
//void solveL() {
//    int n;
//    string s;
//    cin >> n >> s;
//    int q;
//    cin >> q;
//    int kol = 1;
//    while (kol < n) kol *= 2;
//    for (int i = kol - 1; i < kol - 1 + n; i++) {
//        if (s[i - kol + 1] == 'a') d[i] = {0, 0, 0, 0, 1};
//        else d[i] = {1, 1, 1, 1, 1};
//    }
//    for (int i = kol - 1 + n; i < 2 * kol - 1; i++) d[i] = {0, 0, 0, 0, 0};
//    for (int i = kol - 2; i > -1; i--) d[i] = combine(d[2 * i + 1], d[2 * i + 2]);
//    for (int o = 0; o < q; o++) {
//        int t;
//        cin >> t;
//        if (t == 1) {
//            int pos;
//            cin >> pos;
//            pos--;
//            s[pos] = s[pos] == 'a' ? 'b' : 'a';
//            make(0, kol, 0, pos, s[pos]);
//        } else {
//            int l, r;
//            cin >> l >> r;
//            l--;
//            if (r - l == 1) {
//                cout << (s[l] == 'a' ? "YES\n" : "NO\n");
//                continue;
//            } else {
//                if (s[l] == 'b' && s[l + 1] == 'b') {
//                    cout << "NO\n";
//                    continue;
//                }
//                if (s[r - 2] == 'b' && s[r - 1] == 'b') {
//                    cout << "NO\n";
//                    continue;
//                }
//            }
//            node res = get(0, kol, 0, l, r);
//            if (res.sum > r - l - res.sum || res.ans >= 3) {
//                cout << "NO\n";
//                continue;
//            }
//            cout << "YES\n";
//        }
//    }
//}
//const int N = 2e5+9;
//int p[N], sz[N], ans[N];
//map<int, int> *mp[N];
//vector<int> vec[N];
//int dop[N];
//#define pb push_back
//#define fi first
//#define se second
//void dfs(int v) {
//    pi m = {-1, -1};
//    for (int u: vec[v]) {
//        if (u == p[v]) continue;
//        dfs(u);
//        sz[v] += sz[u];
//        m = max(m, (pi){sz[u], u});
//    }
//    int mx = m.se;
//    if (mx == -1) {
//        mp[v] = new map<int, int>;
//        mp[v][0] = 0;
//        ans[v] = 0;
//        return;
//    }
//    dop[v] = dop[mx] + 1;
//    mp[v] = mp[mx];
//
//}
//void solveB() {
//    int n;
//    cin >> n;
//    for (int i = 1; i < n; i++) {
//        cin >> p[i];
//        p[i]--;
//        vec[p[i]].pb(i);
//    }
//    dfs(0);
//    cout << ans[0];
//}


void solveI2() {
    int n;
    cin >> n;
    map<pair<int, int>, int> m;
    ll s0 = 0, s1 = 0, t1 = 0, t0 = 0;
    map<int, map<int, int>> S, T;
    ll S0 = 0, S1 = 0, T0 = 0, T1 = 0;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        if (m[{x, y}] == 0) {
            m[{x, y}] = 1;
            if (x % 2 == 0) {
                S0 -= max(S[x][0], S[x][1]);
                S[x][y % 2]++;
                S0 += max(S[x][0], S[x][1]);
            } else {
                S1 -= max(S[x][0], S[x][1]);
                S[x][y % 2]++;
                S1 += max(S[x][0], S[x][1]);
            }
            if (y % 2 == 0) {
                T0 -= max(T[y][0], T[y][1]);
                T[y][x % 2]++;
                T0 += max(T[y][0], T[y][1]);
            } else {
                T1 -= max(T[y][0], T[y][1]);
                T[y][x % 2]++;
                T1 += max(T[y][0], T[y][1]);
            }
            cout << max({S0, S1, T0, T1}) << '\n';
        } else {
            m[{x, y}] = 0;
            if (x % 2 == 0) {
                S0 -= max(S[x][0], S[x][1]);
                S[x][y % 2]--;
                S0 += max(S[x][0], S[x][1]);
            } else {
                S1 -= max(S[x][0], S[x][1]);
                S[x][y % 2]--;
                S1 += max(S[x][0], S[x][1]);
            }
            if (y % 2 == 0) {
                T0 -= max(T[y][0], T[y][1]);
                T[y][x % 2]--;
                T0 += max(T[y][0], T[y][1]);
            } else {
                T1 -= max(T[y][0], T[y][1]);
                T[y][x % 2]--;
                T1 += max(T[y][0], T[y][1]);
            }
            cout << max({S0, S1, T0, T1}) << '\n';
        }
    }
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    while (t--) {
        solveI2();
    }


    return 0;
}
