#include "bits/stdc++.h"

using namespace std;

#define int long long
#define vec vector
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rend(), (a).rbegin()

template<typename t>
istream& operator>>(istream& in, vector<t>& v) {
    for (auto& u: v) in >> u;
    return in;
}

void solve () {
    int n; cin >> n;
    set<pair<int, int>> q;
    int cnt[4][4];
    for (int i = 0; i < 4; ++i) fill(cnt[i], cnt[i] + 4, 0);
    for (int _ = 0; _ < n; ++_) {
        int x, y; cin >> x >> y;
        int pl = 0;
        if (q.find({x, y}) == q.end()) {
            pl = 1;
            q.insert({x, y});
        }
        else {
            pl = -1;
            q.erase({x, y});
        }
        cnt[x % 4][y % 4] += pl;
        int ans = 0;
        for (int i = 0; i < 4; ++i) {
            for (int j = 0; j < 4; ++j) {
                int i0 = i, i1 = (i + 1) % 4, i2 = (i + 2) % 4, i3 = (i + 3) % 4;
                int j0 = j, j1 = (j + 1) % 4, j2 = (j + 2) % 4, j3 = (j + 3) % 4;
                ans = max({ans,
                           cnt[i0][j0] + cnt[i2][j0] + cnt[i0][j2] + cnt[i2][j2],
                           cnt[i0][j0] + cnt[i2][j1] + cnt[i0][j2] + cnt[i2][j3],
                           cnt[i0][j0] + cnt[i1][j2] + cnt[i2][j0] + cnt[i3][j2],
                           cnt[i1][j0] + cnt[i0][j2] + cnt[i3][j0] + cnt[i2][j2],
                           cnt[i0][j1] + cnt[i2][j0] + cnt[i0][j3] + cnt[i2][j2]});
            }
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}