#include <iostream>
#include<vector>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;
using vi = vector<ll>;
const ll inf = 1e9 + 7;
vi fact(1, 1);
ll bp(ll a, ll st) {
	ll res = 1, cur = a;
	while (st) {
		if (st % 2) {
			res = (res * cur) % inf;
		}
		st /= 2;
		cur = (cur * cur) % inf;
	}
	return res;
}
void solve() {
	ll f, add;
	vi cnt(3, 0);
	cin >> f;
	for (int i = 0; i < f; ++i) {
		cin >> add;
		cnt[add % 3]++;
	}
	if (abs(cnt[2] - cnt[1]) <= 2 && abs(cnt[2] - cnt[1]) >= 1) {
		int n = cnt[1] + cnt[2], x = cnt[0];
		ll ans = 1;
		if (x > 0) ans = (fact[n + x - 1] * bp(fact[n - 1], inf - 2)) % inf;
		ans = (ans * fact[cnt[2]]) % inf;
		ans = (ans * fact[cnt[1]]) % inf;
		cout << ans << "\n";
	}
	else {
		cout << "0";
	}
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	for (int i = 1; i < 4e5; ++i) {
		fact.push_back((fact[i - 1] * i) % inf);
	}
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}

}