#include <bits/stdc++.h>

using namespace std;
#define int long long
#define F first
#define S second
using ll = long long;

const int maxn = 2e5 + 5;
const int INF = 1e9 + 4;
int min_dist[maxn];
vector<int> g[maxn];
int dep[maxn];
map<int, int> hui[maxn];
int dp[maxn];

void dfs1(int v, int p = -1, int depth = 0) {
    dep[v] = depth;
    min_dist[v] = INF;
    for(auto u : g[v]) {
        if(u == p) continue;
        dfs1(u, v, depth + 1);
        min_dist[v] = min(min_dist[v], min_dist[u] + 1);
    }

    if(g[v].size() == 1 && v != 0) {
        min_dist[v] = 0;
    }
}

void dfs2(int v, int p = -1) {
    for(auto u : g[v]) {
        if(u == p) continue;

        dfs2(u, v);

        if(hui[v].size() < hui[u].size()) hui[v].swap(hui[u]);
        for(auto [x, y] : hui[u]) {
            hui[v][x] = max(hui[v][x], y);
        }
        hui[u].clear();
    }

    if(g[v].size() == 1 && v != 0) {
        dp[v] = 0;
        return;
    }
    dp[v] = 1 + hui[v][min_dist[v]];
    hui[v][dep[v]] = max(hui[v][dep[v]], dp[v]);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    for(int i = 1; i < n; i++) {
        int v;
        cin >> v;
        v--;
        g[i].push_back(v);
        g[v].push_back(i);
    }

    dfs1(0);
    dfs2(0);

    cout << dp[0];

    return 0;
}