#include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;

const int N = 5e5 + 5;
const int inf = 1e9;
const ll INF = 1e18;
const int mod = 1e9 + 7;

int n;
string s;

set <array <int, 2>> st1, st2;

int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> s;
    s = "+" + s + "+";

    int l = 1, r = 1;

    for (int r = 1; r <= n; r++) {
        if (s[r] == s[r + 1] || r == n) {
            st1.insert({l, r});
            if (s[l] == 'b' && s[r] == 'b') st2.insert({l, r});
            l = r + 1;
        }
    }

    int q;
    cin >> q;

    while (q--) {
        int type;
        cin >> type;

        if (type == 2) {
            int l, r;
            cin >> l >> r;
            {
                auto it = st2.upper_bound({l, (int)1e9});
                if (it != st2.begin()) {
                    it--;
                    if (it != st2.end() && (*it)[0] >= l && (*it)[1] <= r) {
                        cout << "NO\n";
                        continue;
                    }
                }
            }


            {
                auto it = st1.upper_bound({l, (int)1e9});
                it--;
                if (it != st1.end() && (*it)[0] <= l && (*it)[1] >= r && s[l] == 'b' && s[r] == 'b') {
                    cout << "NO\n";
                    continue;
                }
            }


            {
                auto it = st1.upper_bound({l, (int)1e9});
                it--;
                if (s[l] == 'b' && s[min((*it)[1], r)] == 'b') {
                    cout << "NO\n";
                    continue;
                }
            }

            {
                auto it = st1.lower_bound({r, (int)1e9});
                it--;
                if (s[r] == 'b' && s[max((*it)[0], l)] == 'b') {
                    cout << "NO\n";
                    continue;
                }
            }

            cout << "YES\n";
        } else {
            int pos;
            cin >> pos;
            auto it = st1.upper_bound({l, (int)1e9});
            it--;
            if (pos != (*it)[0] && pos != (*it)[1]) {
                int l = (*it)[0], r = (*it)[1];
                st1.erase(it);
                if (s[l] == 'b' && s[r] == 'b') st2.erase(*it);
                st1.insert({l, pos - 1});
                st1.insert({pos + 1, r});
                if (s[l] == 'b' && s[pos - 1] == 'b') st2.insert({l, pos - 1});
                if (s[pos + 1] == 'b' && s[r] == 'b') st2.insert({pos + 1, r});
                st1.insert({pos, pos});
                if (s[pos] == 'a') s[pos] = 'b';
                else s[pos] = 'a';
                if (s[pos] == 'b') st2.insert({pos, pos});
                continue;
            }
            if (pos == (*it)[0] && pos == (*it)[1]) {
                int l = pos, r = pos;
                if (it != st1.begin()) {
                    it--;
                    l = (*it)[0];
                    it++;
                }
                if (it != --st1.end()) {
                    it++;
                    r = (*it)[1];
                    it--;
                }
                st1.erase(it);
                if (l != pos) {
                    st1.erase({l, pos - 1});
                    if (s[l] == 'b' && s[pos - 1] == 'b') st2.erase({l, pos - 1});
                }
                if (r != pos) {
                    st1.erase({pos + 1, r});
                    if (s[r] == 'b' && s[pos + 1] == 'b') st2.erase({pos + 1, r});
                }
                st1.insert({l, r});
                if (s[pos] == 'a') s[pos] = 'b';
                else s[pos] = 'a';
                if (s[l] == 'b' && s[r] == 'b') st2.insert({l, r});
                continue;
            }
            if (pos == (*it)[0]) {
                int l1 = pos, r1 = (*it)[1];
                int l2 = 1, r2 = 0;
                if (it != st1.begin()) {
                    it--;
                    l2 = (*it)[0];
                    r2 = (*it)[1];
                }
                st1.erase({l1, r1});
                st1.erase({l2, r2});
                if (s[l2] == 'b' && s[r2] == 'b') st2.erase({l2, r2});
                if (s[l1] == 'b' && s[r1] == 'b') st2.erase({l1, r1});
                r2++;
                l1++;
                if (s[pos] == 'a') s[pos] = 'b';
                else s[pos] = 'a';
                if (l1 <= r1) {
                    st1.insert({l1, r1});
                    if (s[l1] == 'b' && s[r1] == 'b') st2.insert({l1, r1});
                }
                if (l2 <= r2) {
                    st1.insert({l2, r2});
                    if (s[l2] == 'b' && s[r2] == 'b') st2.insert({l2, r2});
                }
            }
            if (pos == (*it)[1]) {
                int l1 = pos, r1 = (*it)[1];
                int l2 = n, r2 = n;
                if (it != --st1.end()) {
                    it--;
                    l2 = (*it)[0];
                    r2 = (*it)[1];
                }
                st1.erase({l1, r1});
                st1.erase({l2, r2});
                if (s[l2] == 'b' && s[r2] == 'b') st2.erase({l2, r2});
                if (s[l1] == 'b' && s[r1] == 'b') st2.erase({l1, r1});
                r1--;
                l2--;
                if (s[pos] == 'a') s[pos] = 'b';
                else s[pos] = 'a';
                if (l1 <= r1) {
                    st1.insert({l1, r1});
                    if (s[l1] == 'b' && s[r1] == 'b') st2.insert({l1, r1});
                }
                if (l2 <= r2) {
                    st1.insert({l2, r2});
                    if (s[l2] == 'b' && s[r2] == 'b') st2.insert({l2, r2});
                }
            }
        }
    }

    return 0;
}
