#include <bits/stdc++.h>
using namespace std;
using ll  = long long;
using ld = long double;
const int INF = 1e9;

inline int max(pair<int, int> p) {
    return max(p.first, p.second);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    map<int, pair<int, int>> verticals[2];
    set<pair<int, int>> squares;
    int vert_odd[2] = {0, 0};
    int vert_even[2] = {0, 0};
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        int d;
        if (squares.find({x, y}) != squares.end()) {
            d = -1;
            squares.erase({x,y});
        }
        else {
            d = 1;
            squares.emplace(x, y);
        }
        for (int k = 0; k < 2; k++) {
            swap(x, y);
            if (x % 2) {
                vert_odd[k] -= max(verticals[k][x]);
            }
            else {
                vert_even[k] -= max(verticals[k][x]);
            }
            if (y % 2) {
                verticals[k][x].first += d;
            }
            else {
                verticals[k][x].second += d;
            }
            if (x % 2) {
                vert_odd[k] += max(verticals[k][x]);
            }
            else {
                vert_even[k] += max(verticals[k][x]);
            }
        }
        cout << max(max(vert_odd[0], vert_odd[1]), max(vert_even[0], vert_even[1])) << "\n";
    }
    return 0.42069;
}