#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll

#define vc vector

const int N = 1e6 + 5;

int F[N], iF[N];

const ll MOD = 1e9 + 7;

ll pw(ll x, ll y) {
    if (!y) return 1;
    if (y & 1) return pw(x, y - 1) * x % MOD;
    return pw(x * x % MOD, y / 2);
}

ll C(int n, int k) {
    return F[n] * iF[k] % MOD * iF[n - k] % MOD;
}

bool ch1(map<int, int> cnt) {
    cnt.erase(0);
    if (!cnt.count(1)) return 0;
    --cnt[1];
    for (int i = 0; ; ++i) {
        if (i % 2 == 0) {
            if (!cnt[1]) return !cnt[1] && !cnt[2];
            --cnt[1];
        } else {
            if (!cnt[2]) return !cnt[1] && !cnt[2];
            --cnt[2];
        }
    }
    assert(false);
}
bool ch2(map<int, int> cnt) {
    cnt.erase(0);
    if (!cnt.count(2)) return 0;
    --cnt[2];
    for (int i = 0; ; ++i) {
        if (i % 2 == 0) {
            if (!cnt[2]) return !cnt[1] && !cnt[2];
            --cnt[2];
        } else {
            if (!cnt[1]) return !cnt[1] && !cnt[2];
            --cnt[1];
        }
    }
    assert(false);
}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    F[0] = 1;
    for (int i = 1; i < N; ++i) F[i] = F[i - 1] * i % MOD;
    iF[N - 1] = pw(F[N - 1], MOD - 2);
    for (int i = N - 1; i; --i) iF[i - 1] = iF[i] * i % MOD;
    int n;
    cin >> n;
    map<int, int> cnt;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        cnt[x % 3]++;
    }
    if (cnt.size() == 1 && cnt.count(0)) {
        cout << 0 << '\n';
        return 0;
    }
    ll ans = 0;
    if (ch1(cnt)) {
        ll x = F[cnt[1]] * F[cnt[2]] % MOD;
        x *= C(n - 1, cnt[0]) * F[cnt[0]];
        ans += x % MOD;
    }
    if (ch2(cnt)) {
        ll x = F[cnt[1]] * F[cnt[2]] % MOD;
        x *= C(n - 1, cnt[0]) * F[cnt[0]];
        ans += x % MOD;
    }
    cout << ans % MOD << '\n';
}