#include <bits/stdc++.h>

using i64 = long long;

void solve() {
    int n;
    std::cin >> n;
    std::vector<std::vector<int>> a(n, std::vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            std::cin >> a[i][j];
        }
    }
    i64 sum = 1LL * (n * n) * (n * n + 1) / 2;
    i64 need = sum / n;
    std::vector<int> x, y;
    for (int i = 0; i < n; i++) {
        i64 cur = 0;
        for (int j = 0; j < n; j++) {
            cur += a[i][j];
        }
        if (cur != need) {
            x.emplace_back(i);
        }
    }
    for (int j = 0; j < n; j++) {
        i64 cur = 0;
        for (int i = 0; i < n; i++) {
            cur += a[i][j];
        }
        if (cur != need) {
            y.emplace_back(j);
        }
    }
    if (int(x.size()) == 2 && int(y.size()) == 2) {
        std::swap(a[x[0]][y[0]], a[x[1]][y[1]]);
        for (int i = 0; i < n; i++) {
            i64 cur = 0;
            for (int j = 0; j < n; j++) {
                cur += a[i][j];
            }
            if (cur != need) {
                std::cout << x[0] + 1 << " " << y[1] + 1 << "\n" << x[1] + 1 << " " << y[0] + 1 << "\n";
                return;
            }
        }
        for (int j = 0; j < n; j++) {
            i64 cur = 0;
            for (int i = 0; i < n; i++) {
                cur += a[i][j];
            }
            if (cur != need) {
                std::cout << x[0] + 1 << " " << y[1] + 1 << "\n" << x[1] + 1 << " " << y[0] + 1 << "\n";
                return;
            }
        }
        std::cout << x[0] + 1 << " " << y[0] + 1 << "\n" << x[1] + 1 << " " << y[1] + 1 << "\n";
    } else if (x.empty()) {
        i64 s1 = 0, s2 = 0;
        for (int i = 0; i < n; i++) {
            s1 += a[i][y[0]];
            s2 += a[i][y[1]];
        }
        for (int i = 0; i < n; i++) {
            i64 nw1 = s1 - a[i][y[0]] + a[i][y[1]];
            i64 nw2 = s2 - a[i][y[1]] + a[i][y[0]];
            if (nw1 == nw2) {
                std::cout << i + 1 << " " << y[0] + 1 << "\n" << i + 1 << " " << y[1] + 1 << "\n";
                return;
            }
        }
    } else {
        i64 s1 = 0, s2 = 0;
        for (int i = 0; i < n; i++) {
            s1 += a[x[0]][i];
            s2 += a[x[1]][i];
        }
        for (int i = 0; i < n; i++) {
            i64 nw1 = s1 - a[x[0]][i] + a[x[1]][i];
            i64 nw2 = s2 - a[x[1]][i] + a[x[0]][i];
            if (nw1 == nw2) {
                std::cout << x[0] + 1 << " " << i + 1 << "\n" << x[1] + 1 << " " << i + 1 << "\n";
                return;
            }
        }
    }
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    solve();
}
