#include <bits/stdc++.h>

using i64 = long long;

constexpr int MOD = 1e9 + 7;

void solve() {
    int n;
    std::cin >> n;
    std::vector<std::vector<int>> dp1(n + 1, std::vector<int>(n + 4, 0)), dp2(n + 1, std::vector<int>(n + 4, 0));
    dp1[0][0] = 1;
    for (int j = 1; j <= n + 2; j++) {
        for (int i = 0; i <= n; i++) {
            for (int k = 1; k * j <= i; k++) {
                dp1[i][j] += dp1[i - k * j][j - 1];
            }
        }
    }
    dp2[0][n + 3] = 1;
    for (int j = n + 2; j >= 1; j--) {
        for (int i = 0; i <= n; i++) {
            for (int k = 0; k * j <= i; k++) {
                dp2[i][j] += dp2[i - k * j][j + 1];
            }
        }
    }
    int res = 0;
    for (int mex = 1; mex <= n + 1; mex++) {
        for (int sumL = 0; sumL <= n; sumL++) {
            int sumR = n - sumL;
//            std::cout << sumL << " " << sumR << " " << dp1[sumL][mex - 1] << " " << dp2[sumR][mex + 1] << "\n";
            res += (1LL * mex * ((1LL * dp1[sumL][mex - 1] * dp2[sumR][mex + 1]) % MOD)) % MOD;
            res %= MOD;
        }
//        std::cout << res << "\n";
    }
    std::cout << res << "\n";
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    solve();
}
