#include <iostream>
#include <map>
#include <algorithm>
#include <vector>

using namespace std;

#define int long long

const int mod = 1e9 + 7;

vector<vector<int>> gr;
vector<int> maxd, mind;
vector<int> to;

void dfs(int v) {
    maxd[v] = 1;
    mind[v] = 1e9 + 1;
    if (gr[v].size() == 0) mind[v] = 1;
    for (auto e : gr[v]) {
        dfs(e);
        if (maxd[e] + 1 > maxd[v]) {
            to[v] = e;
        }
        maxd[v] = max(maxd[v], maxd[e] + 1);
        mind[v] = min(mind[v], mind[e] + 1);
    }
}

void solve() {
    int n;
    cin >> n;
    gr.resize(n);
    to.resize(n, -1);
    maxd.resize(n);
    mind.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        gr[p - 1].push_back(i);
    }
    dfs(0);
    int cur = 0;
    int ans = 1;
    while (cur != -1) {
        if (maxd[cur] == mind[cur]) break;
        ans++;
        int t = mind[cur];
        for (int i = 0; i < t; ++i) cur = to[cur];
    }
    cout << ans << '\n';

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int tc = 1;
    // cin >> tc;
    for (int t = 1; t <= tc; ++t) {
        solve();
    }
}