#include <iostream>
#include <map>
#include <vector>

using namespace std;

#define int long long

const int mod = 1e9 + 7;

int binpow(int a, int b) {
    if (b == 0)
        return 1;
    int c = binpow(a, b / 2);
    c = c * c % mod;
    if (b % 2 == 1)
        c = c * a % mod;
    return c;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    for (int i = 0; i < n; ++i) for (int j = 0; j < n; ++j) cin >> a[i][j];
    int sum = ((n * n) * ((n * n) + 1) / 2);
    int c = sum / n;
    // cout << c << '\n';
    int row1 = -1, row2 = -1;
    int col1 = -1, col2 = -1;
    vector<int> rows(n);
    vector<int> cols(n);
    for (int i = 0; i < n; ++i) {
        int sumt = 0;
        for (int j = 0; j < n; ++j) sumt += a[i][j];
        if (sumt != c) {
            row2 = row1;
            row1 = i;
        }
        rows[i] = sumt;
    }
    for (int i = 0; i < n; ++i) {
        int sumt = 0;
        for (int j = 0; j < n; ++j) sumt += a[j][i];
        if (sumt != c) {
            col2 = col1;
            col1 = i;
        }
        cols[i] = sumt;
    }
    if (row1 == -1) {
        for (int i = 0; i < n; ++i) {
            if (cols[col1] - a[i][col1] + a[i][col2] == cols[col2] - a[i][col2] + a[i][col1]) {
                cout << i + 1 << ' ' << col1 + 1 << '\n' << i + 1 << ' ' << col2 + 1 << '\n';
                return;
            }
        }
    }
    if (col1 == -1) {
        for (int i = 0; i < n; ++i) {
            if (rows[row1] - a[row1][i] + a[row2][i] == rows[row2] - a[row2][i] + a[row1][i]) {
                cout << row1 + 1 << ' ' << i + 1 << '\n' << row2 + 1 << ' ' << i + 1 << '\n';
                return;
            }
        }
    }
    vector<pair<int, int>> aulol = {{row1, col1}, {row1, col2}, {row2, col1}, {row2, col2}};
    for (auto e : aulol) {
        for (auto i : aulol) {
            if (rows[e.first] - a[e.first][e.second] + a[i.first][i.second] == c && rows[i.first] - a[i.first][i.second] + a[e.first][e.second] == c && cols[i.second] - a[i.first][i.second] + a[e.first][e.second] == c && cols[e.second] - a[e.first][e.second] + a[i.first][i.second]) {
                cout << e.first + 1 << ' ' << e.second + 1 << '\n' << i.first + 1 << ' ' << i.second + 1 << '\n';
                return;
            }
        }
    }
    // cout << row1 <<  ' ' << col1 << ' ' << row2 << ' ' << col2 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int tc = 1;
    // cin >> tc;
    for (int t = 1; t <= tc; ++t) {
        solve();
    }
}