#include <bits/stdc++.h>

using namespace std;

const long long MOD = 1'000'000'007;

long long binpow(long long a, long long n) {
    if(n == 0) return 1;
    if(n % 2 == 0) {
        return binpow((a* a) % MOD, n/2);
    }

    return (a * binpow(a, n-1)) % MOD;
}

vector<long long> f, fr;

long long fn(long long n, long long k) {
    return (((f[n + k - 1] * fr[k]) % MOD) * fr[n - 1]) % MOD;
}

int main() {
    int n;
    cin >> n;
    int a = 0, b = 0, c = 0;
    for(int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if(x % 3 == 0) a++;
        if(x % 3 == 1) b++;
        if(x % 3 == 2) c++;
    }
    if(abs(b - c) > 2 || (b + c * 2) % 3 == 0) {
        cout << "0\n";
        return 0;
    }

    f.resize(200000);
    f[0] = 1;
    for(int i = 1; i < f.size(); i++) f[i] = (f[i - 1] * i) % MOD;
    fr.resize(200000);
    for(int i = 0; i < fr.size(); i++) fr[i] = binpow(f[i], MOD - 2);

    if(b < c) swap(c, b);
    b--;

    //cout << a << " " << b << " " << c << endl;
    long long ans = fn(a + 1, b + c);
    //cout << ans << endl;
    ans = (ans * f[b + 1]) % MOD;
    ans = (ans * f[c]) % MOD;
    cout << ans << '\n';
}
