
#include <bits\stdc++.h>

using namespace std;
using ll = long long;
#define f(i, l, r) for (int i = (l); i < (r); i++)
#define pb push_back
#define int ll
#define sc second
#define ff first

const int mod = 1e9 + 7;

vector<vector<int>> g;
vector<int> h, nl, siz;

void dfs(int v) {
    siz[v] = 1;
    if (g[v].empty()) {
        nl[v] = h[v];
        return;
    }
    for (auto &u : g[v]) {
            h[u] = h[v] + 1;
            dfs(u);
            nl[v] = min(nl[v], nl[u]);
            siz[v] += siz[u];
    }
}

vector<int> dp;
vector<unordered_map<int, int>> bdp;
void dfs2(int v) {
    if (g[v].empty()) {
        dp[v] = 0;
        //bdp[v][h[v]] = 0;
        return;
    }

    int hg = -1;
    vector<pair<int, int>> next_l;
    for (auto &u : g[v]) {

        dfs2(u);
        next_l.push_back({nl[u], u});
        dp[v] = max(dp[v], dp[u]);

        if (hg == -1 || (siz[hg] < siz[u])) hg = u;
    }
    if (next_l.size() == 1) {
        swap(bdp[g[v][0]], bdp[v]);
        bdp[v][h[v]] = dp[v];
        return;
    }

    sort(next_l.begin(), next_l.end());
    int MN = 0;

    for (auto &u : g[v]) {
        int HHH;
        if (next_l[0].second == u) {
            HHH = next_l[1].first;
        } else {
            HHH = next_l[0].first;
        }
        if (bdp[u].find(HHH) == bdp[u].end()) continue;
        MN = max(MN, bdp[u][HHH] + 1);
    }
    dp[v] = max(dp[v], MN);
    for (auto &u : g[v]) {
        if (u != hg) {
            for (auto &p : bdp[u]) {
                bdp[hg][p.first] = max(bdp[hg][p.first], p.second);
            }
            bdp[u].clear();
        }
    }
    swap(bdp[hg], bdp[v]);
    bdp[v][h[v]] = dp[v];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int n; cin >> n;
    g.resize(n);
    h.assign(n, 0);
    nl.assign(n, n + 1);
    siz.assign(n, 0);
    for (int i = 0; i < n - 1; i++) {
        int p; cin >> p;
        g[p - 1].pb(i + 1);
    }

    dfs(0);
    //return 0;
    bdp.assign(n, {});
    dp.assign(n, 0);
    dfs2(0);
    cout << dp[0] + 1<< '\n';

    return 0;
}